#include "main.h"
#include "sysdeps.h"
#include "hatari-glue.h"
#include "maccess.h"
#include "memory.h"
#include "custom.h"
#include "newcpu.h"
#include "cpu_prefetch.h"
#include "cputbl.h"
#include "debugmem.h"
#include "cpummu030.h"
#define CPUFUNC(x) x##_ff
#define SET_CFLG_ALWAYS(x) SET_CFLG(x)
#define SET_NFLG_ALWAYS(x) SET_NFLG(x)
#ifdef NOFLAGS
#include "noflags.h"
#endif

#if !defined(PART_1) && !defined(PART_2) && !defined(PART_3) && !defined(PART_4) && !defined(PART_5) && !defined(PART_6) && !defined(PART_7) && !defined(PART_8)
#define PART_1 1
#define PART_2 1
#define PART_3 1
#define PART_4 1
#define PART_5 1
#define PART_6 1
#define PART_7 1
#define PART_8 1
#endif

#ifdef PART_1
/* OR.B #<data>.B,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0000_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}	m68k_incpci (4);
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.B #<data>.B,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0010_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.B #<data>.B,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0018_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.B #<data>.B,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0020_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.B #<data>.B,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_0028_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 8 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* OR.B #<data>.B,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_0030_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}return 8 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* OR.B #<data>.B,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_0038_34)(uae_u32 opcode)
{
	OpcodeFamily = 1;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 8 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* OR.B #<data>.B,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_0039_34)(uae_u32 opcode)
{
	OpcodeFamily = 1;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 8 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* ORSR.B #<data>.W */
uae_u32 REGPARAM2 CPUFUNC(op_003c_34)(uae_u32 opcode)
{
	OpcodeFamily = 4;
	CurrentInstrCycles = 4;  
{	MakeSR ();
{	uae_s16 src = get_iword_mmu030c_state (2);
	src &= 0xFF;
	regs.sr |= src;
	MakeFromSR_T0();
	m68k_incpci (4);
	fill_prefetch_030_ntx();
}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.W #<data>.W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0040_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.W #<data>.W,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0050_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.W #<data>.W,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0058_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.W #<data>.W,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0060_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.W #<data>.W,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_0068_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* OR.W #<data>.W,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_0070_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* OR.W #<data>.W,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_0078_34)(uae_u32 opcode)
{
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* OR.W #<data>.W,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_0079_34)(uae_u32 opcode)
{
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* ORSR.W #<data>.W */
uae_u32 REGPARAM2 CPUFUNC(op_007c_34)(uae_u32 opcode)
{
	OpcodeFamily = 4;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340018; }
{	MakeSR ();
{	uae_s16 src = get_iword_mmu030c_state (2);
	regs.sr |= src;
	MakeFromSR_T0();
	m68k_incpci (4);
	fill_prefetch_030_ntx();
}}}l_340018: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.L #<data>.L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0080_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (src);
}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* OR.L #<data>.L,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0090_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* OR.L #<data>.L,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0098_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* OR.L #<data>.L,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_00a0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* OR.L #<data>.L,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_00a8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (6);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* OR.L #<data>.L,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_00b0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (6);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 2,0   */

/* OR.L #<data>.L,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_00b8_34)(uae_u32 opcode)
{
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (6);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* OR.L #<data>.L,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_00b9_34)(uae_u32 opcode)
{
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (6);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (10);
	m68k_incpci (10);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 10 0,0   */

/* CHK2.B #<data>.W,(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_00d0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 81;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower = (uae_s32)(uae_s8)get_byte_mmu030c_state (dsta); upper = (uae_s32)(uae_s8)get_byte_mmu030c_state (dsta + 1);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s8)reg;
	SET_ZFLG (upper == reg || lower == reg);
	SET_CFLG_ALWAYS (lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower);
	if ((extra & 0x800) && GET_CFLG ()) { Exception_cpu(6); goto l_340027; }
}
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}	m68k_incpci (4);
l_340027: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* CHK2.B #<data>.W,(d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_00e8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 81;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower = (uae_s32)(uae_s8)get_byte_mmu030c_state (dsta); upper = (uae_s32)(uae_s8)get_byte_mmu030c_state (dsta + 1);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s8)reg;
	SET_ZFLG (upper == reg || lower == reg);
	SET_CFLG_ALWAYS (lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower);
	if ((extra & 0x800) && GET_CFLG ()) { Exception_cpu(6); goto l_340028; }
}
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}	m68k_incpci (6);
l_340028: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* CHK2.B #<data>.W,(d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_00f0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 81;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower = (uae_s32)(uae_s8)get_byte_mmu030c_state (dsta); upper = (uae_s32)(uae_s8)get_byte_mmu030c_state (dsta + 1);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s8)reg;
	SET_ZFLG (upper == reg || lower == reg);
	SET_CFLG_ALWAYS (lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower);
	if ((extra & 0x800) && GET_CFLG ()) { Exception_cpu(6); goto l_340029; }
}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340029: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* CHK2.B #<data>.W,(xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_00f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 81;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower = (uae_s32)(uae_s8)get_byte_mmu030c_state (dsta); upper = (uae_s32)(uae_s8)get_byte_mmu030c_state (dsta + 1);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s8)reg;
	SET_ZFLG (upper == reg || lower == reg);
	SET_CFLG_ALWAYS (lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower);
	if ((extra & 0x800) && GET_CFLG ()) { Exception_cpu(6); goto l_340030; }
}
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}	m68k_incpci (6);
l_340030: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* CHK2.B #<data>.W,(xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_00f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 81;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower = (uae_s32)(uae_s8)get_byte_mmu030c_state (dsta); upper = (uae_s32)(uae_s8)get_byte_mmu030c_state (dsta + 1);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s8)reg;
	SET_ZFLG (upper == reg || lower == reg);
	SET_CFLG_ALWAYS (lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower);
	if ((extra & 0x800) && GET_CFLG ()) { Exception_cpu(6); goto l_340031; }
}
	regs.irc = get_iword_mmu030c_opcode_state (8);
}}}	m68k_incpci (8);
l_340031: ;
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* CHK2.B #<data>.W,(d16,PC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_00fa_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 2;
	OpcodeFamily = 81;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_getpci () + 4;
	dsta += (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower = (uae_s32)(uae_s8)get_byte_mmu030c_state (dsta); upper = (uae_s32)(uae_s8)get_byte_mmu030c_state (dsta + 1);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s8)reg;
	SET_ZFLG (upper == reg || lower == reg);
	SET_CFLG_ALWAYS (lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower);
	if ((extra & 0x800) && GET_CFLG ()) { Exception_cpu(6); goto l_340032; }
}
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}	m68k_incpci (6);
l_340032: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* CHK2.B #<data>.W,(d8,PC,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_00fb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 3;
	OpcodeFamily = 81;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr tmppc;
	uaecptr dsta;
	m68k_incpci (4);
{	tmppc = m68k_getpci ();
	dsta = get_disp_ea_020_mmu030c (tmppc, 0);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower = (uae_s32)(uae_s8)get_byte_mmu030c_state (dsta); upper = (uae_s32)(uae_s8)get_byte_mmu030c_state (dsta + 1);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s8)reg;
	SET_ZFLG (upper == reg || lower == reg);
	SET_CFLG_ALWAYS (lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower);
	if ((extra & 0x800) && GET_CFLG ()) { Exception_cpu(6); goto l_340033; }
}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340033: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* BTST.L Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0100_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 21;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src &= 31;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MVPMR.W (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0108_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 29;
	CurrentInstrCycles = 12; 
{	uaecptr memp = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_u16 val  = (get_byte_mmu030c_state (memp) & 0xff) << 8;
	        val |= (get_byte_mmu030c_state (memp + 2) & 0xff);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((val) & 0xffff);
}}	m68k_incpci (4);
return 12 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BTST.B Dn,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0110_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 21;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* BTST.B Dn,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0118_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 21;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* BTST.B Dn,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0120_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 21;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* BTST.B Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_0128_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 21;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BTST.B Dn,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_0130_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 21;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* BTST.B Dn,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_0138_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 21;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BTST.B Dn,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_0139_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 21;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* BTST.B Dn,(d16,PC) */
uae_u32 REGPARAM2 CPUFUNC(op_013a_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = 2;
	OpcodeFamily = 21;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_getpci () + 2;
	dsta += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BTST.B Dn,(d8,PC,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_013b_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = 3;
	OpcodeFamily = 21;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr tmppc;
	uaecptr dsta;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	dsta = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* BTST.B Dn,#<data>.B */
uae_u32 REGPARAM2 CPUFUNC(op_013c_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 21;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uae_s8 dst = (uae_u8)get_iword_mmu030c_state (2);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}	m68k_incpci (4);
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BCHG.L Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0140_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 22;
	CurrentInstrCycles = 6;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src &= 31;
	dst ^= (1 << src);
	SET_ZFLG (((uae_u32)dst & (1 << src)) >> src);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (dst);
}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MVPMR.L (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0148_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 29;
	CurrentInstrCycles = 20; 
{	uaecptr memp = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_u32 val  = (get_byte_mmu030c_state (memp) & 0xff) << 24;
	        val |= (get_byte_mmu030c_state (memp + 2) & 0xff) << 16;
	        val |= (get_byte_mmu030c_state (memp + 4) & 0xff) << 8;
	        val |= (get_byte_mmu030c_state (memp + 6) & 0xff);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (val);
}}	m68k_incpci (4);
return 20 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BCHG.B Dn,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0150_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 22;
	CurrentInstrCycles = 6;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	dst ^= (1 << src);
	SET_ZFLG (((uae_u32)dst & (1 << src)) >> src);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* BCHG.B Dn,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0158_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 22;
	CurrentInstrCycles = 6;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	src &= 7;
	dst ^= (1 << src);
	SET_ZFLG (((uae_u32)dst & (1 << src)) >> src);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}	mmufixup[0].reg = -1;
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* BCHG.B Dn,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0160_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 22;
	CurrentInstrCycles = 6;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src &= 7;
	dst ^= (1 << src);
	SET_ZFLG (((uae_u32)dst & (1 << src)) >> src);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}	mmufixup[0].reg = -1;
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* BCHG.B Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_0168_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 22;
	CurrentInstrCycles = 6;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	dst ^= (1 << src);
	SET_ZFLG (((uae_u32)dst & (1 << src)) >> src);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BCHG.B Dn,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_0170_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 22;
	CurrentInstrCycles = 6;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	dst ^= (1 << src);
	SET_ZFLG (((uae_u32)dst & (1 << src)) >> src);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}}return 6 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* BCHG.B Dn,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_0178_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 22;
	CurrentInstrCycles = 6;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	dst ^= (1 << src);
	SET_ZFLG (((uae_u32)dst & (1 << src)) >> src);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BCHG.B Dn,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_0179_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 22;
	CurrentInstrCycles = 6;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	dst ^= (1 << src);
	SET_ZFLG (((uae_u32)dst & (1 << src)) >> src);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* BCLR.L Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0180_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 23;
	CurrentInstrCycles = 6;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src &= 31;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst &= ~(1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (dst);
}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MVPRM.W Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_0188_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 28;
	CurrentInstrCycles = 12; 
{{	uae_s16 src = m68k_dreg (regs, srcreg);
	uaecptr memp = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	put_byte_mmu030c_state (memp, src >> 8);
	put_byte_mmu030c_state (memp + 2, src);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}	m68k_incpci (4);
return 12 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BCLR.B Dn,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0190_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 23;
	CurrentInstrCycles = 6;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst &= ~(1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* BCLR.B Dn,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0198_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 23;
	CurrentInstrCycles = 6;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst &= ~(1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}	mmufixup[0].reg = -1;
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* BCLR.B Dn,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_01a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 23;
	CurrentInstrCycles = 6;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst &= ~(1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}	mmufixup[0].reg = -1;
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* BCLR.B Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_01a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 23;
	CurrentInstrCycles = 6;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst &= ~(1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BCLR.B Dn,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_01b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 23;
	CurrentInstrCycles = 6;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst &= ~(1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}}return 6 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* BCLR.B Dn,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_01b8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 23;
	CurrentInstrCycles = 6;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst &= ~(1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BCLR.B Dn,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_01b9_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 23;
	CurrentInstrCycles = 6;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst &= ~(1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* BSET.L Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_01c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 24;
	CurrentInstrCycles = 6;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src &= 31;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst |= (1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (dst);
}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MVPRM.L Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_01c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 28;
	CurrentInstrCycles = 20; 
{{	uae_s32 src = m68k_dreg (regs, srcreg);
	uaecptr memp = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	put_byte_mmu030c_state (memp, src >> 24);
	put_byte_mmu030c_state (memp + 2, src >> 16);
	put_byte_mmu030c_state (memp + 4, src >> 8);
	put_byte_mmu030c_state (memp + 6, src);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}	m68k_incpci (4);
return 20 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BSET.B Dn,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_01d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 24;
	CurrentInstrCycles = 6;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst |= (1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* BSET.B Dn,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_01d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 24;
	CurrentInstrCycles = 6;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst |= (1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}	mmufixup[0].reg = -1;
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* BSET.B Dn,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_01e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 24;
	CurrentInstrCycles = 6;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst |= (1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}	mmufixup[0].reg = -1;
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* BSET.B Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_01e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 24;
	CurrentInstrCycles = 6;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst |= (1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BSET.B Dn,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_01f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 24;
	CurrentInstrCycles = 6;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst |= (1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}}return 6 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* BSET.B Dn,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_01f8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 24;
	CurrentInstrCycles = 6;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst |= (1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BSET.B Dn,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_01f9_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 24;
	CurrentInstrCycles = 6;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst |= (1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* AND.B #<data>.B,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0200_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}	m68k_incpci (4);
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.B #<data>.B,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0210_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.B #<data>.B,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0218_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.B #<data>.B,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0220_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.B #<data>.B,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_0228_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 8 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* AND.B #<data>.B,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_0230_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}return 8 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* AND.B #<data>.B,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_0238_34)(uae_u32 opcode)
{
	OpcodeFamily = 2;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 8 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* AND.B #<data>.B,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_0239_34)(uae_u32 opcode)
{
	OpcodeFamily = 2;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 8 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* ANDSR.B #<data>.W */
uae_u32 REGPARAM2 CPUFUNC(op_023c_34)(uae_u32 opcode)
{
	OpcodeFamily = 5;
	CurrentInstrCycles = 4;  
{	MakeSR ();
{	uae_s16 src = get_iword_mmu030c_state (2);
	src |= 0xFF00;
	regs.sr &= src;
	MakeFromSR_T0();
	m68k_incpci (4);
	fill_prefetch_030_ntx();
}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.W #<data>.W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0240_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.W #<data>.W,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0250_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.W #<data>.W,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0258_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.W #<data>.W,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0260_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.W #<data>.W,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_0268_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* AND.W #<data>.W,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_0270_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* AND.W #<data>.W,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_0278_34)(uae_u32 opcode)
{
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* AND.W #<data>.W,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_0279_34)(uae_u32 opcode)
{
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* ANDSR.W #<data>.W */
uae_u32 REGPARAM2 CPUFUNC(op_027c_34)(uae_u32 opcode)
{
	OpcodeFamily = 5;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340090; }
{	MakeSR ();
{	uae_s16 src = get_iword_mmu030c_state (2);
	regs.sr &= src;
	MakeFromSR_T0();
	m68k_incpci (4);
	fill_prefetch_030_ntx();
}}}l_340090: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.L #<data>.L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0280_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (src);
}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* AND.L #<data>.L,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0290_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* AND.L #<data>.L,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0298_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* AND.L #<data>.L,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_02a0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* AND.L #<data>.L,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_02a8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (6);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* AND.L #<data>.L,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_02b0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (6);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 2,0   */

/* AND.L #<data>.L,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_02b8_34)(uae_u32 opcode)
{
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (6);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* AND.L #<data>.L,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_02b9_34)(uae_u32 opcode)
{
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (6);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (10);
	m68k_incpci (10);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 10 0,0   */

/* CHK2.W #<data>.W,(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_02d0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 81;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower = (uae_s32)(uae_s16)get_word_mmu030c_state (dsta); upper = (uae_s32)(uae_s16)get_word_mmu030c_state (dsta + 2);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s16)reg;
	SET_ZFLG (upper == reg || lower == reg);
	SET_CFLG_ALWAYS (lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower);
	if ((extra & 0x800) && GET_CFLG ()) { Exception_cpu(6); goto l_340099; }
}
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}	m68k_incpci (4);
l_340099: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* CHK2.W #<data>.W,(d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_02e8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 81;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower = (uae_s32)(uae_s16)get_word_mmu030c_state (dsta); upper = (uae_s32)(uae_s16)get_word_mmu030c_state (dsta + 2);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s16)reg;
	SET_ZFLG (upper == reg || lower == reg);
	SET_CFLG_ALWAYS (lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower);
	if ((extra & 0x800) && GET_CFLG ()) { Exception_cpu(6); goto l_340100; }
}
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}	m68k_incpci (6);
l_340100: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* CHK2.W #<data>.W,(d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_02f0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 81;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower = (uae_s32)(uae_s16)get_word_mmu030c_state (dsta); upper = (uae_s32)(uae_s16)get_word_mmu030c_state (dsta + 2);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s16)reg;
	SET_ZFLG (upper == reg || lower == reg);
	SET_CFLG_ALWAYS (lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower);
	if ((extra & 0x800) && GET_CFLG ()) { Exception_cpu(6); goto l_340101; }
}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340101: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* CHK2.W #<data>.W,(xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_02f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 81;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower = (uae_s32)(uae_s16)get_word_mmu030c_state (dsta); upper = (uae_s32)(uae_s16)get_word_mmu030c_state (dsta + 2);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s16)reg;
	SET_ZFLG (upper == reg || lower == reg);
	SET_CFLG_ALWAYS (lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower);
	if ((extra & 0x800) && GET_CFLG ()) { Exception_cpu(6); goto l_340102; }
}
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}	m68k_incpci (6);
l_340102: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* CHK2.W #<data>.W,(xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_02f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 81;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower = (uae_s32)(uae_s16)get_word_mmu030c_state (dsta); upper = (uae_s32)(uae_s16)get_word_mmu030c_state (dsta + 2);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s16)reg;
	SET_ZFLG (upper == reg || lower == reg);
	SET_CFLG_ALWAYS (lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower);
	if ((extra & 0x800) && GET_CFLG ()) { Exception_cpu(6); goto l_340103; }
}
	regs.irc = get_iword_mmu030c_opcode_state (8);
}}}	m68k_incpci (8);
l_340103: ;
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* CHK2.W #<data>.W,(d16,PC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_02fa_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 2;
	OpcodeFamily = 81;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_getpci () + 4;
	dsta += (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower = (uae_s32)(uae_s16)get_word_mmu030c_state (dsta); upper = (uae_s32)(uae_s16)get_word_mmu030c_state (dsta + 2);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s16)reg;
	SET_ZFLG (upper == reg || lower == reg);
	SET_CFLG_ALWAYS (lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower);
	if ((extra & 0x800) && GET_CFLG ()) { Exception_cpu(6); goto l_340104; }
}
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}	m68k_incpci (6);
l_340104: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* CHK2.W #<data>.W,(d8,PC,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_02fb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 3;
	OpcodeFamily = 81;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr tmppc;
	uaecptr dsta;
	m68k_incpci (4);
{	tmppc = m68k_getpci ();
	dsta = get_disp_ea_020_mmu030c (tmppc, 0);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower = (uae_s32)(uae_s16)get_word_mmu030c_state (dsta); upper = (uae_s32)(uae_s16)get_word_mmu030c_state (dsta + 2);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s16)reg;
	SET_ZFLG (upper == reg || lower == reg);
	SET_CFLG_ALWAYS (lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower);
	if ((extra & 0x800) && GET_CFLG ()) { Exception_cpu(6); goto l_340105; }
}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340105: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* SUB.B #<data>.B,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0400_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}	m68k_incpci (4);
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.B #<data>.B,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0410_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.B #<data>.B,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0418_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.B #<data>.B,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0420_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.B #<data>.B,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_0428_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 8 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* SUB.B #<data>.B,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_0430_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}}return 8 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* SUB.B #<data>.B,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_0438_34)(uae_u32 opcode)
{
	OpcodeFamily = 7;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 8 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* SUB.B #<data>.B,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_0439_34)(uae_u32 opcode)
{
	OpcodeFamily = 7;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 8 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* SUB.W #<data>.W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0440_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.W #<data>.W,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0450_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.W #<data>.W,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0458_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.W #<data>.W,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0460_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.W #<data>.W,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_0468_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* SUB.W #<data>.W,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_0470_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* SUB.W #<data>.W,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_0478_34)(uae_u32 opcode)
{
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* SUB.W #<data>.W,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_0479_34)(uae_u32 opcode)
{
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* SUB.L #<data>.L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0480_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* SUB.L #<data>.L,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0490_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* SUB.L #<data>.L,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0498_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* SUB.L #<data>.L,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_04a0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* SUB.L #<data>.L,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_04a8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (6);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* SUB.L #<data>.L,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_04b0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (6);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 2,0   */

/* SUB.L #<data>.L,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_04b8_34)(uae_u32 opcode)
{
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (6);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* SUB.L #<data>.L,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_04b9_34)(uae_u32 opcode)
{
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (6);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (10);
	m68k_incpci (10);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 10 0,0   */

/* CHK2.L #<data>.W,(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_04d0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 81;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower = get_long_mmu030c_state (dsta); upper = get_long_mmu030c_state (dsta + 4);
	SET_ZFLG (upper == reg || lower == reg);
	SET_CFLG_ALWAYS (lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower);
	if ((extra & 0x800) && GET_CFLG ()) { Exception_cpu(6); goto l_340130; }
}
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}	m68k_incpci (4);
l_340130: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* CHK2.L #<data>.W,(d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_04e8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 81;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower = get_long_mmu030c_state (dsta); upper = get_long_mmu030c_state (dsta + 4);
	SET_ZFLG (upper == reg || lower == reg);
	SET_CFLG_ALWAYS (lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower);
	if ((extra & 0x800) && GET_CFLG ()) { Exception_cpu(6); goto l_340131; }
}
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}	m68k_incpci (6);
l_340131: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* CHK2.L #<data>.W,(d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_04f0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 81;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower = get_long_mmu030c_state (dsta); upper = get_long_mmu030c_state (dsta + 4);
	SET_ZFLG (upper == reg || lower == reg);
	SET_CFLG_ALWAYS (lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower);
	if ((extra & 0x800) && GET_CFLG ()) { Exception_cpu(6); goto l_340132; }
}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340132: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* CHK2.L #<data>.W,(xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_04f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 81;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower = get_long_mmu030c_state (dsta); upper = get_long_mmu030c_state (dsta + 4);
	SET_ZFLG (upper == reg || lower == reg);
	SET_CFLG_ALWAYS (lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower);
	if ((extra & 0x800) && GET_CFLG ()) { Exception_cpu(6); goto l_340133; }
}
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}	m68k_incpci (6);
l_340133: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* CHK2.L #<data>.W,(xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_04f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 81;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower = get_long_mmu030c_state (dsta); upper = get_long_mmu030c_state (dsta + 4);
	SET_ZFLG (upper == reg || lower == reg);
	SET_CFLG_ALWAYS (lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower);
	if ((extra & 0x800) && GET_CFLG ()) { Exception_cpu(6); goto l_340134; }
}
	regs.irc = get_iword_mmu030c_opcode_state (8);
}}}	m68k_incpci (8);
l_340134: ;
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* CHK2.L #<data>.W,(d16,PC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_04fa_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 2;
	OpcodeFamily = 81;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_getpci () + 4;
	dsta += (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower = get_long_mmu030c_state (dsta); upper = get_long_mmu030c_state (dsta + 4);
	SET_ZFLG (upper == reg || lower == reg);
	SET_CFLG_ALWAYS (lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower);
	if ((extra & 0x800) && GET_CFLG ()) { Exception_cpu(6); goto l_340135; }
}
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}	m68k_incpci (6);
l_340135: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* CHK2.L #<data>.W,(d8,PC,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_04fb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 3;
	OpcodeFamily = 81;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr tmppc;
	uaecptr dsta;
	m68k_incpci (4);
{	tmppc = m68k_getpci ();
	dsta = get_disp_ea_020_mmu030c (tmppc, 0);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower = get_long_mmu030c_state (dsta); upper = get_long_mmu030c_state (dsta + 4);
	SET_ZFLG (upper == reg || lower == reg);
	SET_CFLG_ALWAYS (lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower);
	if ((extra & 0x800) && GET_CFLG ()) { Exception_cpu(6); goto l_340136; }
}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340136: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* ADD.B #<data>.B,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0600_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}	m68k_incpci (4);
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.B #<data>.B,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0610_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.B #<data>.B,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0618_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.B #<data>.B,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0620_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.B #<data>.B,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_0628_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 8 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ADD.B #<data>.B,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_0630_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}}return 8 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* ADD.B #<data>.B,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_0638_34)(uae_u32 opcode)
{
	OpcodeFamily = 11;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 8 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ADD.B #<data>.B,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_0639_34)(uae_u32 opcode)
{
	OpcodeFamily = 11;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 8 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* ADD.W #<data>.W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0640_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.W #<data>.W,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0650_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.W #<data>.W,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0658_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.W #<data>.W,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0660_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.W #<data>.W,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_0668_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ADD.W #<data>.W,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_0670_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* ADD.W #<data>.W,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_0678_34)(uae_u32 opcode)
{
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ADD.W #<data>.W,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_0679_34)(uae_u32 opcode)
{
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* ADD.L #<data>.L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0680_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ADD.L #<data>.L,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0690_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ADD.L #<data>.L,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0698_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ADD.L #<data>.L,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_06a0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ADD.L #<data>.L,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_06a8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (6);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* ADD.L #<data>.L,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_06b0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (6);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 2,0   */

/* ADD.L #<data>.L,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_06b8_34)(uae_u32 opcode)
{
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (6);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* ADD.L #<data>.L,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_06b9_34)(uae_u32 opcode)
{
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (6);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (10);
	m68k_incpci (10);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 10 0,0   */

/* RTM.L Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_06c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 101;
	CurrentInstrCycles = 4;  
{	m68k_incpci (2);
	op_illg (opcode);
}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* RTM.L An */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_06c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 101;
	CurrentInstrCycles = 4;  
{	m68k_incpci (2);
	op_illg (opcode);
}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* CALLM.L (An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_06d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 100;
	CurrentInstrCycles = 4;  
{	m68k_incpci (2);
	op_illg (opcode);
}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* CALLM.L (d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_06e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 100;
	CurrentInstrCycles = 4;  
{	m68k_incpci (2);
	op_illg (opcode);
}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* CALLM.L (d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_06f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 100;
	CurrentInstrCycles = 4;  
{	m68k_incpci (2);
	op_illg (opcode);
}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* CALLM.L (xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_06f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 100;
	CurrentInstrCycles = 4;  
{	m68k_incpci (2);
	op_illg (opcode);
}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* CALLM.L (xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_06f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 100;
	CurrentInstrCycles = 4;  
{	m68k_incpci (2);
	op_illg (opcode);
}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* CALLM.L (d16,PC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_06fa_34)(uae_u32 opcode)
{
	OpcodeFamily = 100;
	CurrentInstrCycles = 4;  
{	m68k_incpci (2);
	op_illg (opcode);
}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* CALLM.L (d8,PC,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_06fb_34)(uae_u32 opcode)
{
	OpcodeFamily = 100;
	CurrentInstrCycles = 4;  
{	m68k_incpci (2);
	op_illg (opcode);
}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* BTST.L #<data>.W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0800_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 21;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src &= 31;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BTST.B #<data>.W,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0810_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 21;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BTST.B #<data>.W,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0818_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 21;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BTST.B #<data>.W,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0820_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 21;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BTST.B #<data>.W,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_0828_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 21;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* BTST.B #<data>.W,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_0830_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 21;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* BTST.B #<data>.W,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_0838_34)(uae_u32 opcode)
{
	OpcodeFamily = 21;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* BTST.B #<data>.W,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_0839_34)(uae_u32 opcode)
{
	OpcodeFamily = 21;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	regs.irc = get_iword_mmu030c_opcode_state (8);
}}}}	m68k_incpci (8);
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* BTST.B #<data>.W,(d16,PC) */
uae_u32 REGPARAM2 CPUFUNC(op_083a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 2;
	OpcodeFamily = 21;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_getpci () + 4;
	dsta += (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* BTST.B #<data>.W,(d8,PC,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_083b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 3;
	OpcodeFamily = 21;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr tmppc;
	uaecptr dsta;
	m68k_incpci (4);
{	tmppc = m68k_getpci ();
	dsta = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* BCHG.L #<data>.W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0840_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 22;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src &= 31;
	dst ^= (1 << src);
	SET_ZFLG (((uae_u32)dst & (1 << src)) >> src);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (dst);
}}}	m68k_incpci (4);
return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BCHG.B #<data>.W,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0850_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 22;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	dst ^= (1 << src);
	SET_ZFLG (((uae_u32)dst & (1 << src)) >> src);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BCHG.B #<data>.W,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0858_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 22;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	src &= 7;
	dst ^= (1 << src);
	SET_ZFLG (((uae_u32)dst & (1 << src)) >> src);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}	mmufixup[0].reg = -1;
return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BCHG.B #<data>.W,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0860_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 22;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src &= 7;
	dst ^= (1 << src);
	SET_ZFLG (((uae_u32)dst & (1 << src)) >> src);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}	mmufixup[0].reg = -1;
return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BCHG.B #<data>.W,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_0868_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 22;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	dst ^= (1 << src);
	SET_ZFLG (((uae_u32)dst & (1 << src)) >> src);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* BCHG.B #<data>.W,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_0870_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 22;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	dst ^= (1 << src);
	SET_ZFLG (((uae_u32)dst & (1 << src)) >> src);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}}return 6 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* BCHG.B #<data>.W,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_0878_34)(uae_u32 opcode)
{
	OpcodeFamily = 22;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	dst ^= (1 << src);
	SET_ZFLG (((uae_u32)dst & (1 << src)) >> src);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* BCHG.B #<data>.W,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_0879_34)(uae_u32 opcode)
{
	OpcodeFamily = 22;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	dst ^= (1 << src);
	SET_ZFLG (((uae_u32)dst & (1 << src)) >> src);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* BCLR.L #<data>.W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0880_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 23;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src &= 31;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst &= ~(1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (dst);
}}}	m68k_incpci (4);
return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BCLR.B #<data>.W,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0890_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 23;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst &= ~(1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BCLR.B #<data>.W,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0898_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 23;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst &= ~(1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}	mmufixup[0].reg = -1;
return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BCLR.B #<data>.W,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_08a0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 23;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst &= ~(1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}	mmufixup[0].reg = -1;
return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BCLR.B #<data>.W,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_08a8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 23;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst &= ~(1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* BCLR.B #<data>.W,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_08b0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 23;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst &= ~(1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}}return 6 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* BCLR.B #<data>.W,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_08b8_34)(uae_u32 opcode)
{
	OpcodeFamily = 23;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst &= ~(1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* BCLR.B #<data>.W,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_08b9_34)(uae_u32 opcode)
{
	OpcodeFamily = 23;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst &= ~(1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* BSET.L #<data>.W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_08c0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 24;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src &= 31;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst |= (1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (dst);
}}}	m68k_incpci (4);
return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BSET.B #<data>.W,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_08d0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 24;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst |= (1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BSET.B #<data>.W,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_08d8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 24;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst |= (1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}	mmufixup[0].reg = -1;
return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BSET.B #<data>.W,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_08e0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 24;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst |= (1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}	mmufixup[0].reg = -1;
return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* BSET.B #<data>.W,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_08e8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 24;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst |= (1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* BSET.B #<data>.W,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_08f0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 24;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst |= (1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}}return 6 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* BSET.B #<data>.W,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_08f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 24;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst |= (1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* BSET.B #<data>.W,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_08f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 24;
	CurrentInstrCycles = 6;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= 7;
	SET_ZFLG (1 ^ ((dst >> src) & 1));
	dst |= (1 << src);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, dst);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* EOR.B #<data>.B,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0a00_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}	m68k_incpci (4);
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* EOR.B #<data>.B,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0a10_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* EOR.B #<data>.B,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0a18_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* EOR.B #<data>.B,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0a20_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* EOR.B #<data>.B,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_0a28_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 8 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* EOR.B #<data>.B,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_0a30_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}return 8 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* EOR.B #<data>.B,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_0a38_34)(uae_u32 opcode)
{
	OpcodeFamily = 3;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 8 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* EOR.B #<data>.B,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_0a39_34)(uae_u32 opcode)
{
	OpcodeFamily = 3;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 8 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* EORSR.B #<data>.W */
uae_u32 REGPARAM2 CPUFUNC(op_0a3c_34)(uae_u32 opcode)
{
	OpcodeFamily = 6;
	CurrentInstrCycles = 4;  
{	MakeSR ();
{	uae_s16 src = get_iword_mmu030c_state (2);
	src &= 0xFF;
	regs.sr ^= src;
	MakeFromSR_T0();
	m68k_incpci (4);
	fill_prefetch_030_ntx();
}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* EOR.W #<data>.W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0a40_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* EOR.W #<data>.W,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0a50_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* EOR.W #<data>.W,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0a58_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* EOR.W #<data>.W,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0a60_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* EOR.W #<data>.W,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_0a68_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* EOR.W #<data>.W,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_0a70_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* EOR.W #<data>.W,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_0a78_34)(uae_u32 opcode)
{
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* EOR.W #<data>.W,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_0a79_34)(uae_u32 opcode)
{
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* EORSR.W #<data>.W */
uae_u32 REGPARAM2 CPUFUNC(op_0a7c_34)(uae_u32 opcode)
{
	OpcodeFamily = 6;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340221; }
{	MakeSR ();
{	uae_s16 src = get_iword_mmu030c_state (2);
	regs.sr ^= src;
	MakeFromSR_T0();
	m68k_incpci (4);
	fill_prefetch_030_ntx();
}}}l_340221: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* EOR.L #<data>.L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0a80_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (src);
}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* EOR.L #<data>.L,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0a90_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* EOR.L #<data>.L,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0a98_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* EOR.L #<data>.L,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0aa0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* EOR.L #<data>.L,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_0aa8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (6);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* EOR.L #<data>.L,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_0ab0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (6);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 2,0   */

/* EOR.L #<data>.L,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_0ab8_34)(uae_u32 opcode)
{
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (6);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* EOR.L #<data>.L,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_0ab9_34)(uae_u32 opcode)
{
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (6);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (10);
	m68k_incpci (10);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 10 0,0   */

/* CAS.B #<data>.W,(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0ad0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 84;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_lrmw_byte_mmu030c_state (dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(m68k_dreg (regs, rc)));
{	int flgs = ((uae_s8)(m68k_dreg (regs, rc))) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(m68k_dreg (regs, rc))) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	if (GET_ZFLG ()) {
		regs.irc = get_iword_mmu030c_opcode_state (0);
	put_lrmw_byte_mmu030c_state (dsta, (m68k_dreg (regs, ru)));
	}else{
	regs.irc = get_iword_mmu030c_opcode_state (0);
		m68k_dreg(regs, rc) = (m68k_dreg(regs, rc) & ~0xff) | (dst & 0xff);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* CAS.B #<data>.W,(An)+ */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0ad8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 84;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_lrmw_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(m68k_dreg (regs, rc)));
{	int flgs = ((uae_s8)(m68k_dreg (regs, rc))) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(m68k_dreg (regs, rc))) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	if (GET_ZFLG ()) {
		regs.irc = get_iword_mmu030c_opcode_state (0);
	put_lrmw_byte_mmu030c_state (dsta, (m68k_dreg (regs, ru)));
	}else{
	regs.irc = get_iword_mmu030c_opcode_state (0);
		m68k_dreg(regs, rc) = (m68k_dreg(regs, rc) & ~0xff) | (dst & 0xff);
}}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* CAS.B #<data>.W,-(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0ae0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 84;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_lrmw_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(m68k_dreg (regs, rc)));
{	int flgs = ((uae_s8)(m68k_dreg (regs, rc))) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(m68k_dreg (regs, rc))) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	if (GET_ZFLG ()) {
		regs.irc = get_iword_mmu030c_opcode_state (0);
	put_lrmw_byte_mmu030c_state (dsta, (m68k_dreg (regs, ru)));
	}else{
	regs.irc = get_iword_mmu030c_opcode_state (0);
		m68k_dreg(regs, rc) = (m68k_dreg(regs, rc) & ~0xff) | (dst & 0xff);
}}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* CAS.B #<data>.W,(d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0ae8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 84;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_lrmw_byte_mmu030c_state (dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(m68k_dreg (regs, rc)));
{	int flgs = ((uae_s8)(m68k_dreg (regs, rc))) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(m68k_dreg (regs, rc))) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	if (GET_ZFLG ()) {
		regs.irc = get_iword_mmu030c_opcode_state (0);
	put_lrmw_byte_mmu030c_state (dsta, (m68k_dreg (regs, ru)));
	}else{
	regs.irc = get_iword_mmu030c_opcode_state (0);
		m68k_dreg(regs, rc) = (m68k_dreg(regs, rc) & ~0xff) | (dst & 0xff);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
#endif

#ifdef PART_2
/* CAS.B #<data>.W,(d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0af0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 84;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s8 dst = get_lrmw_byte_mmu030c_state (dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(m68k_dreg (regs, rc)));
{	int flgs = ((uae_s8)(m68k_dreg (regs, rc))) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(m68k_dreg (regs, rc))) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	if (GET_ZFLG ()) {
		regs.irc = get_iword_mmu030c_opcode_state (0);
	put_lrmw_byte_mmu030c_state (dsta, (m68k_dreg (regs, ru)));
	}else{
	regs.irc = get_iword_mmu030c_opcode_state (0);
		m68k_dreg(regs, rc) = (m68k_dreg(regs, rc) & ~0xff) | (dst & 0xff);
}}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* CAS.B #<data>.W,(xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0af8_34)(uae_u32 opcode)
{
	OpcodeFamily = 84;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_lrmw_byte_mmu030c_state (dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(m68k_dreg (regs, rc)));
{	int flgs = ((uae_s8)(m68k_dreg (regs, rc))) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(m68k_dreg (regs, rc))) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	if (GET_ZFLG ()) {
		regs.irc = get_iword_mmu030c_opcode_state (0);
	put_lrmw_byte_mmu030c_state (dsta, (m68k_dreg (regs, ru)));
	}else{
	regs.irc = get_iword_mmu030c_opcode_state (0);
		m68k_dreg(regs, rc) = (m68k_dreg(regs, rc) & ~0xff) | (dst & 0xff);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* CAS.B #<data>.W,(xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0af9_34)(uae_u32 opcode)
{
	OpcodeFamily = 84;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_s8 dst = get_lrmw_byte_mmu030c_state (dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(m68k_dreg (regs, rc)));
{	int flgs = ((uae_s8)(m68k_dreg (regs, rc))) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(m68k_dreg (regs, rc))) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	if (GET_ZFLG ()) {
		regs.irc = get_iword_mmu030c_opcode_state (0);
	put_lrmw_byte_mmu030c_state (dsta, (m68k_dreg (regs, ru)));
	}else{
	regs.irc = get_iword_mmu030c_opcode_state (0);
		m68k_dreg(regs, rc) = (m68k_dreg(regs, rc) & ~0xff) | (dst & 0xff);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* CMP.B #<data>.B,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0c00_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}	m68k_incpci (4);
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMP.B #<data>.B,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0c10_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}}	m68k_incpci (4);
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMP.B #<data>.B,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0c18_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}}	m68k_incpci (4);
	mmufixup[0].reg = -1;
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMP.B #<data>.B,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0c20_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}}	m68k_incpci (4);
	mmufixup[0].reg = -1;
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMP.B #<data>.B,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_0c28_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}}}}	m68k_incpci (6);
return 8 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* CMP.B #<data>.B,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_0c30_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}}}return 8 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* CMP.B #<data>.B,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_0c38_34)(uae_u32 opcode)
{
	OpcodeFamily = 25;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}}}}	m68k_incpci (6);
return 8 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* CMP.B #<data>.B,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_0c39_34)(uae_u32 opcode)
{
	OpcodeFamily = 25;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
}}}}}}}	m68k_incpci (8);
return 8 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* CMP.B #<data>.B,(d16,PC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0c3a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 2;
	OpcodeFamily = 25;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_getpci () + 4;
	dsta += (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}}}}	m68k_incpci (6);
return 8 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* CMP.B #<data>.B,(d8,PC,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0c3b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 3;
	OpcodeFamily = 25;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr tmppc;
	uaecptr dsta;
	m68k_incpci (4);
{	tmppc = m68k_getpci ();
	dsta = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}}}return 8 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* CMP.W #<data>.W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0c40_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMP.W #<data>.W,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0c50_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMP.W #<data>.W,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0c58_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}}	m68k_incpci (4);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMP.W #<data>.W,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0c60_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}}	m68k_incpci (4);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMP.W #<data>.W,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_0c68_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* CMP.W #<data>.W,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_0c70_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* CMP.W #<data>.W,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_0c78_34)(uae_u32 opcode)
{
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* CMP.W #<data>.W,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_0c79_34)(uae_u32 opcode)
{
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
}}}}}}}	m68k_incpci (8);
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* CMP.W #<data>.W,(d16,PC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0c7a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 2;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_getpci () + 4;
	dsta += (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* CMP.W #<data>.W,(d8,PC,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0c7b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 3;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr tmppc;
	uaecptr dsta;
	m68k_incpci (4);
{	tmppc = m68k_getpci ();
	dsta = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* CMP.L #<data>.L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_0c80_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* CMP.L #<data>.L,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0c90_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* CMP.L #<data>.L,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_0c98_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}}}}	m68k_incpci (6);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* CMP.L #<data>.L,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_0ca0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}}}}	m68k_incpci (6);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* CMP.L #<data>.L,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_0ca8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (6);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
}}}}}}}	m68k_incpci (8);
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* CMP.L #<data>.L,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_0cb0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (6);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 2,0   */

/* CMP.L #<data>.L,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_0cb8_34)(uae_u32 opcode)
{
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (6);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
}}}}}}}	m68k_incpci (8);
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* CMP.L #<data>.L,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_0cb9_34)(uae_u32 opcode)
{
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (6);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (10);
}}}}}}}	m68k_incpci (10);
return 4 * CYCLE_UNIT / 2;
}
/* 10 0,0   */

/* CMP.L #<data>.L,(d16,PC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0cba_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 2;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_getpci () + 6;
	dsta += (uae_s32)(uae_s16)get_iword_mmu030c_state (6);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
}}}}}}}	m68k_incpci (8);
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* CMP.L #<data>.L,(d8,PC,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0cbb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 3;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr tmppc;
	uaecptr dsta;
	m68k_incpci (6);
{	tmppc = m68k_getpci ();
	dsta = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 2,0   */

#endif
/* CAS.W #<data>.W,(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0cd0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 84;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_lrmw_word_mmu030c_state (dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(m68k_dreg (regs, rc)));
{	int flgs = ((uae_s16)(m68k_dreg (regs, rc))) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(m68k_dreg (regs, rc))) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	if (GET_ZFLG ()) {
		regs.irc = get_iword_mmu030c_opcode_state (0);
	put_lrmw_word_mmu030c_state (dsta, (m68k_dreg (regs, ru)));
	}else{
	regs.irc = get_iword_mmu030c_opcode_state (0);
		m68k_dreg(regs, rc) = (m68k_dreg(regs, rc) & ~0xffff) | (dst & 0xffff);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* CAS.W #<data>.W,(An)+ */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0cd8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 84;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_lrmw_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(m68k_dreg (regs, rc)));
{	int flgs = ((uae_s16)(m68k_dreg (regs, rc))) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(m68k_dreg (regs, rc))) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	if (GET_ZFLG ()) {
		regs.irc = get_iword_mmu030c_opcode_state (0);
	put_lrmw_word_mmu030c_state (dsta, (m68k_dreg (regs, ru)));
	}else{
	regs.irc = get_iword_mmu030c_opcode_state (0);
		m68k_dreg(regs, rc) = (m68k_dreg(regs, rc) & ~0xffff) | (dst & 0xffff);
}}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* CAS.W #<data>.W,-(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0ce0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 84;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
{	uae_s16 dst = get_lrmw_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(m68k_dreg (regs, rc)));
{	int flgs = ((uae_s16)(m68k_dreg (regs, rc))) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(m68k_dreg (regs, rc))) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	if (GET_ZFLG ()) {
		regs.irc = get_iword_mmu030c_opcode_state (0);
	put_lrmw_word_mmu030c_state (dsta, (m68k_dreg (regs, ru)));
	}else{
	regs.irc = get_iword_mmu030c_opcode_state (0);
		m68k_dreg(regs, rc) = (m68k_dreg(regs, rc) & ~0xffff) | (dst & 0xffff);
}}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* CAS.W #<data>.W,(d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0ce8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 84;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s16 dst = get_lrmw_word_mmu030c_state (dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(m68k_dreg (regs, rc)));
{	int flgs = ((uae_s16)(m68k_dreg (regs, rc))) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(m68k_dreg (regs, rc))) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	if (GET_ZFLG ()) {
		regs.irc = get_iword_mmu030c_opcode_state (0);
	put_lrmw_word_mmu030c_state (dsta, (m68k_dreg (regs, ru)));
	}else{
	regs.irc = get_iword_mmu030c_opcode_state (0);
		m68k_dreg(regs, rc) = (m68k_dreg(regs, rc) & ~0xffff) | (dst & 0xffff);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* CAS.W #<data>.W,(d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0cf0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 84;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s16 dst = get_lrmw_word_mmu030c_state (dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(m68k_dreg (regs, rc)));
{	int flgs = ((uae_s16)(m68k_dreg (regs, rc))) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(m68k_dreg (regs, rc))) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	if (GET_ZFLG ()) {
		regs.irc = get_iword_mmu030c_opcode_state (0);
	put_lrmw_word_mmu030c_state (dsta, (m68k_dreg (regs, ru)));
	}else{
	regs.irc = get_iword_mmu030c_opcode_state (0);
		m68k_dreg(regs, rc) = (m68k_dreg(regs, rc) & ~0xffff) | (dst & 0xffff);
}}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* CAS.W #<data>.W,(xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0cf8_34)(uae_u32 opcode)
{
	OpcodeFamily = 84;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s16 dst = get_lrmw_word_mmu030c_state (dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(m68k_dreg (regs, rc)));
{	int flgs = ((uae_s16)(m68k_dreg (regs, rc))) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(m68k_dreg (regs, rc))) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	if (GET_ZFLG ()) {
		regs.irc = get_iword_mmu030c_opcode_state (0);
	put_lrmw_word_mmu030c_state (dsta, (m68k_dreg (regs, ru)));
	}else{
	regs.irc = get_iword_mmu030c_opcode_state (0);
		m68k_dreg(regs, rc) = (m68k_dreg(regs, rc) & ~0xffff) | (dst & 0xffff);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* CAS.W #<data>.W,(xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0cf9_34)(uae_u32 opcode)
{
	OpcodeFamily = 84;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_s16 dst = get_lrmw_word_mmu030c_state (dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(m68k_dreg (regs, rc)));
{	int flgs = ((uae_s16)(m68k_dreg (regs, rc))) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(m68k_dreg (regs, rc))) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	if (GET_ZFLG ()) {
		regs.irc = get_iword_mmu030c_opcode_state (0);
	put_lrmw_word_mmu030c_state (dsta, (m68k_dreg (regs, ru)));
	}else{
	regs.irc = get_iword_mmu030c_opcode_state (0);
		m68k_dreg(regs, rc) = (m68k_dreg(regs, rc) & ~0xffff) | (dst & 0xffff);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* CAS2.W #<data>.L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0cfc_34)(uae_u32 opcode)
{
	OpcodeFamily = 85;
	CurrentInstrCycles = 4;  
{{	uae_s32 extra;
	extra = get_ilong_mmu030c_state (2);
	uae_u32 rn1 = regs.regs[(extra >> 28) & 15];
	uae_u32 rn2 = regs.regs[(extra >> 12) & 15];
	uae_u16 dst1 = get_lrmw_word_mmu030c_state (rn1), dst2 = get_lrmw_word_mmu030c_state (rn2);
{uae_u32 newv = ((uae_u16)(dst1)) - ((uae_u16)(m68k_dreg (regs, (extra >> 16) & 7)));
{	int flgs = ((uae_s16)(m68k_dreg (regs, (extra >> 16) & 7))) < 0;
	int flgo = ((uae_s16)(dst1)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(m68k_dreg (regs, (extra >> 16) & 7))) > ((uae_u16)(dst1)));
	SET_NFLG (flgn != 0);
	if (GET_ZFLG ()) {
{uae_u32 newv = ((uae_u16)(dst2)) - ((uae_u16)(m68k_dreg (regs, extra & 7)));
{	int flgs = ((uae_s16)(m68k_dreg (regs, extra & 7))) < 0;
	int flgo = ((uae_s16)(dst2)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(m68k_dreg (regs, extra & 7))) > ((uae_u16)(dst2)));
	SET_NFLG (flgn != 0);
	if (GET_ZFLG ()) {
	put_lrmw_word_mmu030c_state (rn1, m68k_dreg (regs, (extra >> 22) & 7));
	put_lrmw_word_mmu030c_state (rn2, m68k_dreg (regs, (extra >> 6) & 7));
	}}
}}}}	if (! GET_ZFLG ()) {
	m68k_dreg (regs, (extra >> 0) & 7) = (m68k_dreg (regs, (extra >> 6) & 7) & ~0xffff) | (dst2 & 0xffff);
	m68k_dreg (regs, (extra >> 16) & 7) = (m68k_dreg (regs, (extra >> 22) & 7) & ~0xffff) | (dst1 & 0xffff);
	}
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* MOVES.B #<data>.W,(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0e10_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 103;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340275; }
{{	uae_s16 extra = get_iword_mmu030c_state (2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	dfc030c_put_byte_state (dsta, src);
}}else{{	uaecptr srca;
	srca = m68k_areg (regs, dstreg);
{	uae_s8 src = sfc030c_get_byte_state (srca);
	if (extra & 0x8000) {
	m68k_areg (regs, (extra >> 12) & 7) = (uae_s32)(uae_s8)src;
	} else {
	m68k_dreg (regs, (extra >> 12) & 7) = (m68k_dreg (regs, (extra >> 12) & 7) & ~0xff) | ((src) & 0xff);
	}
	m68k_incpci (4);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}l_340275: ;
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* MOVES.B #<data>.W,(An)+ */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0e18_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 103;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340276; }
{{	uae_s16 extra = get_iword_mmu030c_state (2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	dfc030c_put_byte_state (dsta, src);
}}else{{	uaecptr srca;
	srca = m68k_areg (regs, dstreg);
{	uae_s8 src = sfc030c_get_byte_state (srca);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	if (extra & 0x8000) {
	m68k_areg (regs, (extra >> 12) & 7) = (uae_s32)(uae_s8)src;
	} else {
	m68k_dreg (regs, (extra >> 12) & 7) = (m68k_dreg (regs, (extra >> 12) & 7) & ~0xff) | ((src) & 0xff);
	}
	m68k_incpci (4);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}l_340276: ;
	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* MOVES.B #<data>.W,-(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0e20_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 103;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340277; }
{{	uae_s16 extra = get_iword_mmu030c_state (2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	dfc030c_put_byte_state (dsta, src);
}}else{{	uaecptr srca;
	srca = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 src = sfc030c_get_byte_state (srca);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = srca;
	if (extra & 0x8000) {
	m68k_areg (regs, (extra >> 12) & 7) = (uae_s32)(uae_s8)src;
	} else {
	m68k_dreg (regs, (extra >> 12) & 7) = (m68k_dreg (regs, (extra >> 12) & 7) & ~0xff) | ((src) & 0xff);
	}
	m68k_incpci (4);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}l_340277: ;
	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* MOVES.B #<data>.W,(d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0e28_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 103;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340278; }
{{	uae_s16 extra = get_iword_mmu030c_state (2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	dfc030c_put_byte_state (dsta, src);
}}else{{	uaecptr srca;
	srca = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 src = sfc030c_get_byte_state (srca);
	if (extra & 0x8000) {
	m68k_areg (regs, (extra >> 12) & 7) = (uae_s32)(uae_s8)src;
	} else {
	m68k_dreg (regs, (extra >> 12) & 7) = (m68k_dreg (regs, (extra >> 12) & 7) & ~0xff) | ((src) & 0xff);
	}
	m68k_incpci (6);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}l_340278: ;
return 4 * CYCLE_UNIT / 2;
}
/* 12 0,0   */

#endif
/* MOVES.B #<data>.W,(d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0e30_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 103;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340279; }
{{	uae_s16 extra = get_iword_mmu030c_state (2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	dfc030c_put_byte_state (dsta, src);
}}}else{{	uaecptr srca;
	m68k_incpci (4);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 1);
{	uae_s8 src = sfc030c_get_byte_state (srca);
	if (extra & 0x8000) {
	m68k_areg (regs, (extra >> 12) & 7) = (uae_s32)(uae_s8)src;
	} else {
	m68k_dreg (regs, (extra >> 12) & 7) = (m68k_dreg (regs, (extra >> 12) & 7) & ~0xff) | ((src) & 0xff);
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}}l_340279: ;
return 4 * CYCLE_UNIT / 2;
}
/* 8 6,2   */

#endif
/* MOVES.B #<data>.W,(xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0e38_34)(uae_u32 opcode)
{
	OpcodeFamily = 103;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340280; }
{{	uae_s16 extra = get_iword_mmu030c_state (2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	dfc030c_put_byte_state (dsta, src);
}}else{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s8 src = sfc030c_get_byte_state (srca);
	if (extra & 0x8000) {
	m68k_areg (regs, (extra >> 12) & 7) = (uae_s32)(uae_s8)src;
	} else {
	m68k_dreg (regs, (extra >> 12) & 7) = (m68k_dreg (regs, (extra >> 12) & 7) & ~0xff) | ((src) & 0xff);
	}
	m68k_incpci (6);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}l_340280: ;
return 4 * CYCLE_UNIT / 2;
}
/* 12 0,0   */

#endif
/* MOVES.B #<data>.W,(xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0e39_34)(uae_u32 opcode)
{
	OpcodeFamily = 103;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340281; }
{{	uae_s16 extra = get_iword_mmu030c_state (2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	dfc030c_put_byte_state (dsta, src);
}}else{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (4);
{	uae_s8 src = sfc030c_get_byte_state (srca);
	if (extra & 0x8000) {
	m68k_areg (regs, (extra >> 12) & 7) = (uae_s32)(uae_s8)src;
	} else {
	m68k_dreg (regs, (extra >> 12) & 7) = (m68k_dreg (regs, (extra >> 12) & 7) & ~0xff) | ((src) & 0xff);
	}
	m68k_incpci (8);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}l_340281: ;
return 4 * CYCLE_UNIT / 2;
}
/* 16 0,0   */

#endif
/* MOVES.W #<data>.W,(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0e50_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 103;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340282; }
{{	uae_s16 extra = get_iword_mmu030c_state (2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	dfc030c_put_word_state (dsta, src);
}}else{{	uaecptr srca;
	srca = m68k_areg (regs, dstreg);
{	uae_s16 src = sfc030c_get_word_state (srca);
	if (extra & 0x8000) {
	m68k_areg (regs, (extra >> 12) & 7) = (uae_s32)(uae_s16)src;
	} else {
	m68k_dreg (regs, (extra >> 12) & 7) = (m68k_dreg (regs, (extra >> 12) & 7) & ~0xffff) | ((src) & 0xffff);
	}
	m68k_incpci (4);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}l_340282: ;
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* MOVES.W #<data>.W,(An)+ */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0e58_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 103;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340283; }
{{	uae_s16 extra = get_iword_mmu030c_state (2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	dfc030c_put_word_state (dsta, src);
}}else{{	uaecptr srca;
	srca = m68k_areg (regs, dstreg);
{	uae_s16 src = sfc030c_get_word_state (srca);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
	if (extra & 0x8000) {
	m68k_areg (regs, (extra >> 12) & 7) = (uae_s32)(uae_s16)src;
	} else {
	m68k_dreg (regs, (extra >> 12) & 7) = (m68k_dreg (regs, (extra >> 12) & 7) & ~0xffff) | ((src) & 0xffff);
	}
	m68k_incpci (4);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}l_340283: ;
	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* MOVES.W #<data>.W,-(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0e60_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 103;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340284; }
{{	uae_s16 extra = get_iword_mmu030c_state (2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	dfc030c_put_word_state (dsta, src);
}}else{{	uaecptr srca;
	srca = m68k_areg (regs, dstreg) - 2;
{	uae_s16 src = sfc030c_get_word_state (srca);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = srca;
	if (extra & 0x8000) {
	m68k_areg (regs, (extra >> 12) & 7) = (uae_s32)(uae_s16)src;
	} else {
	m68k_dreg (regs, (extra >> 12) & 7) = (m68k_dreg (regs, (extra >> 12) & 7) & ~0xffff) | ((src) & 0xffff);
	}
	m68k_incpci (4);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}l_340284: ;
	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* MOVES.W #<data>.W,(d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0e68_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 103;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340285; }
{{	uae_s16 extra = get_iword_mmu030c_state (2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	dfc030c_put_word_state (dsta, src);
}}else{{	uaecptr srca;
	srca = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s16 src = sfc030c_get_word_state (srca);
	if (extra & 0x8000) {
	m68k_areg (regs, (extra >> 12) & 7) = (uae_s32)(uae_s16)src;
	} else {
	m68k_dreg (regs, (extra >> 12) & 7) = (m68k_dreg (regs, (extra >> 12) & 7) & ~0xffff) | ((src) & 0xffff);
	}
	m68k_incpci (6);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}l_340285: ;
return 4 * CYCLE_UNIT / 2;
}
/* 12 0,0   */

#endif
/* MOVES.W #<data>.W,(d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0e70_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 103;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340286; }
{{	uae_s16 extra = get_iword_mmu030c_state (2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	dfc030c_put_word_state (dsta, src);
}}}else{{	uaecptr srca;
	m68k_incpci (4);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 1);
{	uae_s16 src = sfc030c_get_word_state (srca);
	if (extra & 0x8000) {
	m68k_areg (regs, (extra >> 12) & 7) = (uae_s32)(uae_s16)src;
	} else {
	m68k_dreg (regs, (extra >> 12) & 7) = (m68k_dreg (regs, (extra >> 12) & 7) & ~0xffff) | ((src) & 0xffff);
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}}l_340286: ;
return 4 * CYCLE_UNIT / 2;
}
/* 8 6,2   */

#endif
/* MOVES.W #<data>.W,(xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0e78_34)(uae_u32 opcode)
{
	OpcodeFamily = 103;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340287; }
{{	uae_s16 extra = get_iword_mmu030c_state (2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	dfc030c_put_word_state (dsta, src);
}}else{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s16 src = sfc030c_get_word_state (srca);
	if (extra & 0x8000) {
	m68k_areg (regs, (extra >> 12) & 7) = (uae_s32)(uae_s16)src;
	} else {
	m68k_dreg (regs, (extra >> 12) & 7) = (m68k_dreg (regs, (extra >> 12) & 7) & ~0xffff) | ((src) & 0xffff);
	}
	m68k_incpci (6);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}l_340287: ;
return 4 * CYCLE_UNIT / 2;
}
/* 12 0,0   */

#endif
/* MOVES.W #<data>.W,(xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0e79_34)(uae_u32 opcode)
{
	OpcodeFamily = 103;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340288; }
{{	uae_s16 extra = get_iword_mmu030c_state (2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	dfc030c_put_word_state (dsta, src);
}}else{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (4);
{	uae_s16 src = sfc030c_get_word_state (srca);
	if (extra & 0x8000) {
	m68k_areg (regs, (extra >> 12) & 7) = (uae_s32)(uae_s16)src;
	} else {
	m68k_dreg (regs, (extra >> 12) & 7) = (m68k_dreg (regs, (extra >> 12) & 7) & ~0xffff) | ((src) & 0xffff);
	}
	m68k_incpci (8);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}l_340288: ;
return 4 * CYCLE_UNIT / 2;
}
/* 16 0,0   */

#endif
/* MOVES.L #<data>.W,(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0e90_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 103;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340289; }
{{	uae_s16 extra = get_iword_mmu030c_state (2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	dfc030c_put_long_state (dsta, src);
}}else{{	uaecptr srca;
	srca = m68k_areg (regs, dstreg);
{	uae_s32 src = sfc030c_get_long_state (srca);
	if (extra & 0x8000) {
	m68k_areg (regs, (extra >> 12) & 7) = src;
	} else {
	m68k_dreg (regs, (extra >> 12) & 7) = (src);
	}
	m68k_incpci (4);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}l_340289: ;
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* MOVES.L #<data>.W,(An)+ */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0e98_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 103;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340290; }
{{	uae_s16 extra = get_iword_mmu030c_state (2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	dfc030c_put_long_state (dsta, src);
}}else{{	uaecptr srca;
	srca = m68k_areg (regs, dstreg);
{	uae_s32 src = sfc030c_get_long_state (srca);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
	if (extra & 0x8000) {
	m68k_areg (regs, (extra >> 12) & 7) = src;
	} else {
	m68k_dreg (regs, (extra >> 12) & 7) = (src);
	}
	m68k_incpci (4);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}l_340290: ;
	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* MOVES.L #<data>.W,-(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0ea0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 103;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340291; }
{{	uae_s16 extra = get_iword_mmu030c_state (2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	dfc030c_put_long_state (dsta, src);
}}else{{	uaecptr srca;
	srca = m68k_areg (regs, dstreg) - 4;
{	uae_s32 src = sfc030c_get_long_state (srca);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = srca;
	if (extra & 0x8000) {
	m68k_areg (regs, (extra >> 12) & 7) = src;
	} else {
	m68k_dreg (regs, (extra >> 12) & 7) = (src);
	}
	m68k_incpci (4);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}l_340291: ;
	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* MOVES.L #<data>.W,(d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0ea8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 103;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340292; }
{{	uae_s16 extra = get_iword_mmu030c_state (2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	dfc030c_put_long_state (dsta, src);
}}else{{	uaecptr srca;
	srca = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s32 src = sfc030c_get_long_state (srca);
	if (extra & 0x8000) {
	m68k_areg (regs, (extra >> 12) & 7) = src;
	} else {
	m68k_dreg (regs, (extra >> 12) & 7) = (src);
	}
	m68k_incpci (6);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}l_340292: ;
return 4 * CYCLE_UNIT / 2;
}
/* 12 0,0   */

#endif
/* MOVES.L #<data>.W,(d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0eb0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 103;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340293; }
{{	uae_s16 extra = get_iword_mmu030c_state (2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	dfc030c_put_long_state (dsta, src);
}}}else{{	uaecptr srca;
	m68k_incpci (4);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 1);
{	uae_s32 src = sfc030c_get_long_state (srca);
	if (extra & 0x8000) {
	m68k_areg (regs, (extra >> 12) & 7) = src;
	} else {
	m68k_dreg (regs, (extra >> 12) & 7) = (src);
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}}l_340293: ;
return 4 * CYCLE_UNIT / 2;
}
/* 8 6,2   */

#endif
/* MOVES.L #<data>.W,(xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0eb8_34)(uae_u32 opcode)
{
	OpcodeFamily = 103;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340294; }
{{	uae_s16 extra = get_iword_mmu030c_state (2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	dfc030c_put_long_state (dsta, src);
}}else{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s32 src = sfc030c_get_long_state (srca);
	if (extra & 0x8000) {
	m68k_areg (regs, (extra >> 12) & 7) = src;
	} else {
	m68k_dreg (regs, (extra >> 12) & 7) = (src);
	}
	m68k_incpci (6);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}l_340294: ;
return 4 * CYCLE_UNIT / 2;
}
/* 12 0,0   */

#endif
/* MOVES.L #<data>.W,(xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0eb9_34)(uae_u32 opcode)
{
	OpcodeFamily = 103;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340295; }
{{	uae_s16 extra = get_iword_mmu030c_state (2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	dfc030c_put_long_state (dsta, src);
}}else{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (4);
{	uae_s32 src = sfc030c_get_long_state (srca);
	if (extra & 0x8000) {
	m68k_areg (regs, (extra >> 12) & 7) = src;
	} else {
	m68k_dreg (regs, (extra >> 12) & 7) = (src);
	}
	m68k_incpci (8);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}l_340295: ;
return 4 * CYCLE_UNIT / 2;
}
/* 16 0,0   */

#endif
/* CAS.L #<data>.W,(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0ed0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 84;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_lrmw_long_mmu030c_state (dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(m68k_dreg (regs, rc)));
{	int flgs = ((uae_s32)(m68k_dreg (regs, rc))) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(m68k_dreg (regs, rc))) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	if (GET_ZFLG ()) {
		regs.irc = get_iword_mmu030c_opcode_state (0);
	put_lrmw_long_mmu030c_state (dsta, (m68k_dreg (regs, ru)));
	}else{
	regs.irc = get_iword_mmu030c_opcode_state (0);
		m68k_dreg(regs, rc) = dst;
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* CAS.L #<data>.W,(An)+ */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0ed8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 84;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_lrmw_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(m68k_dreg (regs, rc)));
{	int flgs = ((uae_s32)(m68k_dreg (regs, rc))) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(m68k_dreg (regs, rc))) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	if (GET_ZFLG ()) {
		regs.irc = get_iword_mmu030c_opcode_state (0);
	put_lrmw_long_mmu030c_state (dsta, (m68k_dreg (regs, ru)));
	}else{
	regs.irc = get_iword_mmu030c_opcode_state (0);
		m68k_dreg(regs, rc) = dst;
}}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* CAS.L #<data>.W,-(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0ee0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 84;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
{	uae_s32 dst = get_lrmw_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(m68k_dreg (regs, rc)));
{	int flgs = ((uae_s32)(m68k_dreg (regs, rc))) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(m68k_dreg (regs, rc))) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	if (GET_ZFLG ()) {
		regs.irc = get_iword_mmu030c_opcode_state (0);
	put_lrmw_long_mmu030c_state (dsta, (m68k_dreg (regs, ru)));
	}else{
	regs.irc = get_iword_mmu030c_opcode_state (0);
		m68k_dreg(regs, rc) = dst;
}}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* CAS.L #<data>.W,(d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0ee8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 84;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s32 dst = get_lrmw_long_mmu030c_state (dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(m68k_dreg (regs, rc)));
{	int flgs = ((uae_s32)(m68k_dreg (regs, rc))) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(m68k_dreg (regs, rc))) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	if (GET_ZFLG ()) {
		regs.irc = get_iword_mmu030c_opcode_state (0);
	put_lrmw_long_mmu030c_state (dsta, (m68k_dreg (regs, ru)));
	}else{
	regs.irc = get_iword_mmu030c_opcode_state (0);
		m68k_dreg(regs, rc) = dst;
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* CAS.L #<data>.W,(d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0ef0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 84;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s32 dst = get_lrmw_long_mmu030c_state (dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(m68k_dreg (regs, rc)));
{	int flgs = ((uae_s32)(m68k_dreg (regs, rc))) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(m68k_dreg (regs, rc))) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	if (GET_ZFLG ()) {
		regs.irc = get_iword_mmu030c_opcode_state (0);
	put_lrmw_long_mmu030c_state (dsta, (m68k_dreg (regs, ru)));
	}else{
	regs.irc = get_iword_mmu030c_opcode_state (0);
		m68k_dreg(regs, rc) = dst;
}}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* CAS.L #<data>.W,(xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0ef8_34)(uae_u32 opcode)
{
	OpcodeFamily = 84;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s32 dst = get_lrmw_long_mmu030c_state (dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(m68k_dreg (regs, rc)));
{	int flgs = ((uae_s32)(m68k_dreg (regs, rc))) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(m68k_dreg (regs, rc))) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	if (GET_ZFLG ()) {
		regs.irc = get_iword_mmu030c_opcode_state (0);
	put_lrmw_long_mmu030c_state (dsta, (m68k_dreg (regs, ru)));
	}else{
	regs.irc = get_iword_mmu030c_opcode_state (0);
		m68k_dreg(regs, rc) = dst;
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* CAS.L #<data>.W,(xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0ef9_34)(uae_u32 opcode)
{
	OpcodeFamily = 84;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_s32 dst = get_lrmw_long_mmu030c_state (dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(m68k_dreg (regs, rc)));
{	int flgs = ((uae_s32)(m68k_dreg (regs, rc))) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(m68k_dreg (regs, rc))) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	if (GET_ZFLG ()) {
		regs.irc = get_iword_mmu030c_opcode_state (0);
	put_lrmw_long_mmu030c_state (dsta, (m68k_dreg (regs, ru)));
	}else{
	regs.irc = get_iword_mmu030c_opcode_state (0);
		m68k_dreg(regs, rc) = dst;
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* CAS2.L #<data>.L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_0efc_34)(uae_u32 opcode)
{
	OpcodeFamily = 85;
	CurrentInstrCycles = 4;  
{{	uae_s32 extra;
	extra = get_ilong_mmu030c_state (2);
	uae_u32 rn1 = regs.regs[(extra >> 28) & 15];
	uae_u32 rn2 = regs.regs[(extra >> 12) & 15];
	uae_u32 dst1 = get_lrmw_long_mmu030c_state (rn1), dst2 = get_lrmw_long_mmu030c_state (rn2);
{uae_u32 newv = ((uae_u32)(dst1)) - ((uae_u32)(m68k_dreg (regs, (extra >> 16) & 7)));
{	int flgs = ((uae_s32)(m68k_dreg (regs, (extra >> 16) & 7))) < 0;
	int flgo = ((uae_s32)(dst1)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(m68k_dreg (regs, (extra >> 16) & 7))) > ((uae_u32)(dst1)));
	SET_NFLG (flgn != 0);
	if (GET_ZFLG ()) {
{uae_u32 newv = ((uae_u32)(dst2)) - ((uae_u32)(m68k_dreg (regs, extra & 7)));
{	int flgs = ((uae_s32)(m68k_dreg (regs, extra & 7))) < 0;
	int flgo = ((uae_s32)(dst2)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(m68k_dreg (regs, extra & 7))) > ((uae_u32)(dst2)));
	SET_NFLG (flgn != 0);
	if (GET_ZFLG ()) {
	put_lrmw_long_mmu030c_state (rn1, m68k_dreg (regs, (extra >> 22) & 7));
	put_lrmw_long_mmu030c_state (rn2, m68k_dreg (regs, (extra >> 6) & 7));
	}}
}}}}	if (! GET_ZFLG ()) {
	m68k_dreg (regs, (extra >> 0) & 7) = dst2;
	m68k_dreg (regs, (extra >> 16) & 7) = dst1;
	}
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* MOVE.B Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_1000_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
	m68k_incpci (2);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.B (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_1010_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
	m68k_incpci (2);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.B (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_1018_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
	m68k_incpci (2);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.B -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_1020_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
	m68k_incpci (2);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.B (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_1028_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
	m68k_incpci (4);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_1030_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.B (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_1038_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
	m68k_incpci (4);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_1039_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
	m68k_incpci (6);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.B (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_103a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
	m68k_incpci (4);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_103b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.B #<data>.B,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_103c_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
	m68k_incpci (4);
}}}return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B Dn,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_1080_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.B (An),(An) */
uae_u32 REGPARAM2 CPUFUNC(op_1090_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.B (An)+,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_1098_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.B -(An),(An) */
uae_u32 REGPARAM2 CPUFUNC(op_10a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.B (d16,An),(An) */
uae_u32 REGPARAM2 CPUFUNC(op_10a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B (d8,An,Xn),(An) */
uae_u32 REGPARAM2 CPUFUNC(op_10b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.B (xxx).W,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_10b8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B (xxx).L,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_10b9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.B (d16,PC),(An) */
uae_u32 REGPARAM2 CPUFUNC(op_10ba_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B (d8,PC,Xn),(An) */
uae_u32 REGPARAM2 CPUFUNC(op_10bb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.B #<data>.B,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_10bc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B Dn,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_10c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.B (An),(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_10d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.B (An)+,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_10d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.B -(An),(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_10e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.B (d16,An),(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_10e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B (d8,An,Xn),(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_10f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.B (xxx).W,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_10f8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B (xxx).L,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_10f9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.B (d16,PC),(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_10fa_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B (d8,PC,Xn),(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_10fb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.B #<data>.B,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_10fc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}	mmufixup[0].reg = -1;
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B Dn,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_1100_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.B (An),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_1110_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.B (An)+,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_1118_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.B -(An),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_1120_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.B (d16,An),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_1128_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B (d8,An,Xn),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_1130_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.B (xxx).W,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_1138_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B (xxx).L,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_1139_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.B (d16,PC),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_113a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B (d8,PC,Xn),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_113b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.B #<data>.B,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_113c_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}	mmufixup[0].reg = -1;
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_1140_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B (An),(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_1150_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B (An)+,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_1158_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B -(An),(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_1160_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B (d16,An),(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_1168_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.B (d8,An,Xn),(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_1170_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 4,0   */

/* MOVE.B (xxx).W,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_1178_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.B (xxx).L,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_1179_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (6);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* MOVE.B (d16,PC),(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_117a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.B (d8,PC,Xn),(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_117b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 4,0   */

/* MOVE.B #<data>.B,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_117c_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}return 8 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.B Dn,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_1180_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.B (An),(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_1190_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.B (An)+,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_1198_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.B -(An),(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_11a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.B (d16,An),(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_11a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* MOVE.B (d8,An,Xn),(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_11b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 1);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,2   */

/* MOVE.B (xxx).W,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_11b8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* MOVE.B (xxx).L,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_11b9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	m68k_incpci (6);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 2,0   */

/* MOVE.B (d16,PC),(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_11ba_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* MOVE.B (d8,PC,Xn),(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_11bb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 1);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,2   */

/* MOVE.B #<data>.B,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_11bc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 8 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* MOVE.B Dn,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_11c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B (An),(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_11d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B (An)+,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_11d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B -(An),(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_11e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.B (d16,An),(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_11e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.B (d8,An,Xn),(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_11f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 4,0   */

/* MOVE.B (xxx).W,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_11f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.B (xxx).L,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_11f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (6);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* MOVE.B (d16,PC),(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_11fa_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.B (d8,PC,Xn),(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_11fb_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 4,0   */

/* MOVE.B #<data>.B,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_11fc_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}return 8 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.B Dn,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_13c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.B (An),(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_13d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.B (An)+,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_13d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.B -(An),(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_13e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.B (d16,An),(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_13e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* MOVE.B (d8,An,Xn),(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_13f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 6,0   */

/* MOVE.B (xxx).W,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_13f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* MOVE.B (xxx).L,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_13f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (6);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (10);
	m68k_incpci (10);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 10 0,0   */

/* MOVE.B (d16,PC),(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_13fa_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* MOVE.B (d8,PC,Xn),(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_13fb_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 6,0   */

/* MOVE.B #<data>.B,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_13fc_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}return 8 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* MOVE.L Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_2000_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (src);
	m68k_incpci (2);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.L An,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_2008_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_areg (regs, srcreg);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (src);
	m68k_incpci (2);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.L (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_2010_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (src);
	m68k_incpci (2);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.L (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_2018_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (src);
	m68k_incpci (2);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.L -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_2020_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (src);
	m68k_incpci (2);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.L (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_2028_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (src);
	m68k_incpci (4);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.L (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_2030_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.L (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_2038_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (src);
	m68k_incpci (4);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.L (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_2039_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (src);
	m68k_incpci (6);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.L (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_203a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (src);
	m68k_incpci (4);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.L (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_203b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.L #<data>.L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_203c_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (src);
	m68k_incpci (6);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVEA.L Dn,An */
uae_u32 REGPARAM2 CPUFUNC(op_2040_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (src);
	m68k_incpci (2);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVEA.L An,An */
uae_u32 REGPARAM2 CPUFUNC(op_2048_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_areg (regs, srcreg);
{	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (src);
	m68k_incpci (2);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVEA.L (An),An */
uae_u32 REGPARAM2 CPUFUNC(op_2050_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (src);
	m68k_incpci (2);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVEA.L (An)+,An */
uae_u32 REGPARAM2 CPUFUNC(op_2058_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
{	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (src);
	m68k_incpci (2);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVEA.L -(An),An */
uae_u32 REGPARAM2 CPUFUNC(op_2060_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (src);
	m68k_incpci (2);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVEA.L (d16,An),An */
uae_u32 REGPARAM2 CPUFUNC(op_2068_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (src);
	m68k_incpci (4);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVEA.L (d8,An,Xn),An */
uae_u32 REGPARAM2 CPUFUNC(op_2070_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_areg (regs, dstreg) = (src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVEA.L (xxx).W,An */
uae_u32 REGPARAM2 CPUFUNC(op_2078_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (src);
	m68k_incpci (4);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVEA.L (xxx).L,An */
uae_u32 REGPARAM2 CPUFUNC(op_2079_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_areg (regs, dstreg) = (src);
	m68k_incpci (6);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVEA.L (d16,PC),An */
uae_u32 REGPARAM2 CPUFUNC(op_207a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (src);
	m68k_incpci (4);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVEA.L (d8,PC,Xn),An */
uae_u32 REGPARAM2 CPUFUNC(op_207b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_areg (regs, dstreg) = (src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVEA.L #<data>.L,An */
uae_u32 REGPARAM2 CPUFUNC(op_207c_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_areg (regs, dstreg) = (src);
	m68k_incpci (6);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.L Dn,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_2080_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.L An,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_2088_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_areg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.L (An),(An) */
uae_u32 REGPARAM2 CPUFUNC(op_2090_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.L (An)+,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_2098_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.L -(An),(An) */
uae_u32 REGPARAM2 CPUFUNC(op_20a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.L (d16,An),(An) */
uae_u32 REGPARAM2 CPUFUNC(op_20a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.L (d8,An,Xn),(An) */
uae_u32 REGPARAM2 CPUFUNC(op_20b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.L (xxx).W,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_20b8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.L (xxx).L,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_20b9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.L (d16,PC),(An) */
uae_u32 REGPARAM2 CPUFUNC(op_20ba_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.L (d8,PC,Xn),(An) */
uae_u32 REGPARAM2 CPUFUNC(op_20bb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.L #<data>.L,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_20bc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.L Dn,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_20c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.L An,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_20c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_areg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.L (An),(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_20d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.L (An)+,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_20d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.L -(An),(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_20e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.L (d16,An),(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_20e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.L (d8,An,Xn),(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_20f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.L (xxx).W,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_20f8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.L (xxx).L,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_20f9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.L (d16,PC),(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_20fa_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.L (d8,PC,Xn),(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_20fb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.L #<data>.L,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_20fc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.L Dn,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_2100_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.L An,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_2108_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_areg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.L (An),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_2110_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.L (An)+,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_2118_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.L -(An),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_2120_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.L (d16,An),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_2128_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.L (d8,An,Xn),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_2130_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.L (xxx).W,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_2138_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.L (xxx).L,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_2139_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.L (d16,PC),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_213a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.L (d8,PC,Xn),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_213b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.L #<data>.L,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_213c_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.L Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_2140_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.L An,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_2148_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_areg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.L (An),(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_2150_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.L (An)+,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_2158_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.L -(An),(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_2160_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.L (d16,An),(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_2168_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.L (d8,An,Xn),(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_2170_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 4,0   */

/* MOVE.L (xxx).W,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_2178_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.L (xxx).L,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_2179_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (6);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* MOVE.L (d16,PC),(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_217a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.L (d8,PC,Xn),(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_217b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 4,0   */

/* MOVE.L #<data>.L,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_217c_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (6);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* MOVE.L Dn,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_2180_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.L An,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_2188_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_areg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.L (An),(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_2190_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.L (An)+,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_2198_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

#endif

#ifdef PART_3
/* MOVE.L -(An),(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_21a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.L (d16,An),(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_21a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* MOVE.L (d8,An,Xn),(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_21b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 1);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,2   */

/* MOVE.L (xxx).W,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_21b8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* MOVE.L (xxx).L,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_21b9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	m68k_incpci (6);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 2,0   */

/* MOVE.L (d16,PC),(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_21ba_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* MOVE.L (d8,PC,Xn),(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_21bb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 1);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,2   */

/* MOVE.L #<data>.L,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_21bc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (6);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 2,0   */

/* MOVE.L Dn,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_21c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.L An,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_21c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_areg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.L (An),(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_21d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.L (An)+,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_21d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.L -(An),(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_21e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.L (d16,An),(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_21e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.L (d8,An,Xn),(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_21f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 4,0   */

/* MOVE.L (xxx).W,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_21f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.L (xxx).L,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_21f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (6);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* MOVE.L (d16,PC),(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_21fa_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.L (d8,PC,Xn),(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_21fb_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 4,0   */

/* MOVE.L #<data>.L,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_21fc_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (6);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* MOVE.L Dn,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_23c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.L An,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_23c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_areg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.L (An),(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_23d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.L (An)+,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_23d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.L -(An),(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_23e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.L (d16,An),(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_23e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* MOVE.L (d8,An,Xn),(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_23f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 6,0   */

/* MOVE.L (xxx).W,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_23f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* MOVE.L (xxx).L,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_23f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (6);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (10);
	m68k_incpci (10);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 10 0,0   */

/* MOVE.L (d16,PC),(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_23fa_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* MOVE.L (d8,PC,Xn),(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_23fb_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 6,0   */

/* MOVE.L #<data>.L,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_23fc_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (6);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (10);
	m68k_incpci (10);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 10 0,0   */

/* MOVE.W Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_3000_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
	m68k_incpci (2);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.W An,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_3008_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_areg (regs, srcreg);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
	m68k_incpci (2);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.W (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_3010_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
	m68k_incpci (2);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.W (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_3018_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
	m68k_incpci (2);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.W -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_3020_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
	m68k_incpci (2);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.W (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_3028_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
	m68k_incpci (4);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_3030_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.W (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_3038_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
	m68k_incpci (4);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_3039_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
	m68k_incpci (6);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.W (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_303a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
	m68k_incpci (4);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_303b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.W #<data>.W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_303c_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
	m68k_incpci (4);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVEA.W Dn,An */
uae_u32 REGPARAM2 CPUFUNC(op_3040_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	src = (uae_s32)(uae_s16)src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (uae_s32)(uae_s16)(src);
	m68k_incpci (2);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVEA.W An,An */
uae_u32 REGPARAM2 CPUFUNC(op_3048_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_areg (regs, srcreg);
{	src = (uae_s32)(uae_s16)src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (uae_s32)(uae_s16)(src);
	m68k_incpci (2);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVEA.W (An),An */
uae_u32 REGPARAM2 CPUFUNC(op_3050_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	src = (uae_s32)(uae_s16)src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (uae_s32)(uae_s16)(src);
	m68k_incpci (2);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVEA.W (An)+,An */
uae_u32 REGPARAM2 CPUFUNC(op_3058_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	src = (uae_s32)(uae_s16)src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (uae_s32)(uae_s16)(src);
	m68k_incpci (2);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVEA.W -(An),An */
uae_u32 REGPARAM2 CPUFUNC(op_3060_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	src = (uae_s32)(uae_s16)src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (uae_s32)(uae_s16)(src);
	m68k_incpci (2);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVEA.W (d16,An),An */
uae_u32 REGPARAM2 CPUFUNC(op_3068_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	src = (uae_s32)(uae_s16)src;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (uae_s32)(uae_s16)(src);
	m68k_incpci (4);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVEA.W (d8,An,Xn),An */
uae_u32 REGPARAM2 CPUFUNC(op_3070_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	src = (uae_s32)(uae_s16)src;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_areg (regs, dstreg) = (uae_s32)(uae_s16)(src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVEA.W (xxx).W,An */
uae_u32 REGPARAM2 CPUFUNC(op_3078_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	src = (uae_s32)(uae_s16)src;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (uae_s32)(uae_s16)(src);
	m68k_incpci (4);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVEA.W (xxx).L,An */
uae_u32 REGPARAM2 CPUFUNC(op_3079_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	src = (uae_s32)(uae_s16)src;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_areg (regs, dstreg) = (uae_s32)(uae_s16)(src);
	m68k_incpci (6);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVEA.W (d16,PC),An */
uae_u32 REGPARAM2 CPUFUNC(op_307a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	src = (uae_s32)(uae_s16)src;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (uae_s32)(uae_s16)(src);
	m68k_incpci (4);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVEA.W (d8,PC,Xn),An */
uae_u32 REGPARAM2 CPUFUNC(op_307b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	src = (uae_s32)(uae_s16)src;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_areg (regs, dstreg) = (uae_s32)(uae_s16)(src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVEA.W #<data>.W,An */
uae_u32 REGPARAM2 CPUFUNC(op_307c_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 31;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	src = (uae_s32)(uae_s16)src;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (uae_s32)(uae_s16)(src);
	m68k_incpci (4);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W Dn,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_3080_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.W An,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_3088_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_areg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.W (An),(An) */
uae_u32 REGPARAM2 CPUFUNC(op_3090_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.W (An)+,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_3098_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.W -(An),(An) */
uae_u32 REGPARAM2 CPUFUNC(op_30a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.W (d16,An),(An) */
uae_u32 REGPARAM2 CPUFUNC(op_30a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W (d8,An,Xn),(An) */
uae_u32 REGPARAM2 CPUFUNC(op_30b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.W (xxx).W,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_30b8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W (xxx).L,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_30b9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.W (d16,PC),(An) */
uae_u32 REGPARAM2 CPUFUNC(op_30ba_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W (d8,PC,Xn),(An) */
uae_u32 REGPARAM2 CPUFUNC(op_30bb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.W #<data>.W,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_30bc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W Dn,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_30c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.W An,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_30c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_areg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.W (An),(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_30d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.W (An)+,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_30d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.W -(An),(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_30e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.W (d16,An),(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_30e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W (d8,An,Xn),(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_30f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.W (xxx).W,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_30f8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W (xxx).L,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_30f9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.W (d16,PC),(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_30fa_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W (d8,PC,Xn),(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_30fb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.W #<data>.W,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_30fc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W Dn,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_3100_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.W An,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_3108_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_areg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.W (An),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_3110_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.W (An)+,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_3118_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.W -(An),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_3120_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MOVE.W (d16,An),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_3128_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W (d8,An,Xn),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_3130_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.W (xxx).W,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_3138_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W (xxx).L,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_3139_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.W (d16,PC),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_313a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W (d8,PC,Xn),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_313b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.W #<data>.W,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_313c_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_3140_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W An,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_3148_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_areg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W (An),(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_3150_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W (An)+,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_3158_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W -(An),(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_3160_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W (d16,An),(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_3168_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.W (d8,An,Xn),(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_3170_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 4,0   */

/* MOVE.W (xxx).W,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_3178_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.W (xxx).L,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_3179_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (6);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* MOVE.W (d16,PC),(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_317a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.W (d8,PC,Xn),(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_317b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 4,0   */

/* MOVE.W #<data>.W,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_317c_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.W Dn,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_3180_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.W An,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_3188_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_areg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.W (An),(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_3190_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.W (An)+,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_3198_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.W -(An),(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_31a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MOVE.W (d16,An),(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_31a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* MOVE.W (d8,An,Xn),(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_31b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 1);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,2   */

/* MOVE.W (xxx).W,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_31b8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* MOVE.W (xxx).L,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_31b9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	m68k_incpci (6);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 2,0   */

/* MOVE.W (d16,PC),(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_31ba_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* MOVE.W (d8,PC,Xn),(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_31bb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 1);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,2   */

/* MOVE.W #<data>.W,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_31bc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* MOVE.W Dn,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_31c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W An,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_31c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_areg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W (An),(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_31d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W (An)+,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_31d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W -(An),(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_31e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MOVE.W (d16,An),(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_31e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.W (d8,An,Xn),(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_31f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 4,0   */

/* MOVE.W (xxx).W,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_31f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.W (xxx).L,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_31f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (6);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* MOVE.W (d16,PC),(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_31fa_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.W (d8,PC,Xn),(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_31fb_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 4,0   */

/* MOVE.W #<data>.W,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_31fc_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.W Dn,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_33c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.W An,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_33c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_areg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.W (An),(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_33d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.W (An)+,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_33d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.W -(An),(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_33e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MOVE.W (d16,An),(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_33e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* MOVE.W (d8,An,Xn),(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_33f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 6,0   */

/* MOVE.W (xxx).W,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_33f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* MOVE.W (xxx).L,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_33f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (6);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (10);
	m68k_incpci (10);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 10 0,0   */

/* MOVE.W (d16,PC),(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_33fa_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* MOVE.W (d8,PC,Xn),(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_33fb_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 6,0   */

/* MOVE.W #<data>.W,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_33fc_34)(uae_u32 opcode)
{
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* NEGX.B Dn */
uae_u32 REGPARAM2 CPUFUNC(op_4000_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xff) | ((newv) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEGX.B (An) */
uae_u32 REGPARAM2 CPUFUNC(op_4010_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, newv);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEGX.B (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_4018_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, newv);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEGX.B -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_4020_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, newv);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEGX.B (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_4028_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, newv);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* NEGX.B (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_4030_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, newv);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* NEGX.B (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_4038_34)(uae_u32 opcode)
{
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, newv);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* NEGX.B (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_4039_34)(uae_u32 opcode)
{
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, newv);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* NEGX.W Dn */
uae_u32 REGPARAM2 CPUFUNC(op_4040_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s16)(newv)) == 0));
	SET_NFLG (((uae_s16)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | ((newv) & 0xffff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEGX.W (An) */
uae_u32 REGPARAM2 CPUFUNC(op_4050_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s16)(newv)) == 0));
	SET_NFLG (((uae_s16)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, newv);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEGX.W (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_4058_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s16)(newv)) == 0));
	SET_NFLG (((uae_s16)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, newv);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEGX.W -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_4060_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s16)(newv)) == 0));
	SET_NFLG (((uae_s16)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, newv);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEGX.W (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_4068_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s16)(newv)) == 0));
	SET_NFLG (((uae_s16)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, newv);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* NEGX.W (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_4070_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s16)(newv)) == 0));
	SET_NFLG (((uae_s16)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, newv);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* NEGX.W (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_4078_34)(uae_u32 opcode)
{
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s16)(newv)) == 0));
	SET_NFLG (((uae_s16)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, newv);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* NEGX.W (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_4079_34)(uae_u32 opcode)
{
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s16)(newv)) == 0));
	SET_NFLG (((uae_s16)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, newv);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* NEGX.L Dn */
uae_u32 REGPARAM2 CPUFUNC(op_4080_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s32)(newv)) == 0));
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (newv);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEGX.L (An) */
uae_u32 REGPARAM2 CPUFUNC(op_4090_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s32)(newv)) == 0));
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, newv);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEGX.L (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_4098_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s32)(newv)) == 0));
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, newv);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEGX.L -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_40a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s32)(newv)) == 0));
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, newv);
}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEGX.L (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_40a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s32)(newv)) == 0));
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, newv);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* NEGX.L (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_40b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s32)(newv)) == 0));
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, newv);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* NEGX.L (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_40b8_34)(uae_u32 opcode)
{
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s32)(newv)) == 0));
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, newv);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* NEGX.L (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_40b9_34)(uae_u32 opcode)
{
	OpcodeFamily = 16;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_u32 newv = 0 - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s32)(newv)) == 0));
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, newv);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MVSR2.W Dn */
uae_u32 REGPARAM2 CPUFUNC(op_40c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 32;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340632; }
{{	MakeSR ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | ((regs.sr) & 0xffff);
}}}	m68k_incpci (2);
l_340632: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MVSR2.W (An) */
uae_u32 REGPARAM2 CPUFUNC(op_40d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 32;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340633; }
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	MakeSR ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, regs.sr);
}}}l_340633: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MVSR2.W (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_40d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 32;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340634; }
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
	MakeSR ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, regs.sr);
}}}l_340634: ;
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MVSR2.W -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_40e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 32;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340635; }
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
	MakeSR ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, regs.sr);
}}}l_340635: ;
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MVSR2.W (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_40e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 32;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340636; }
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	MakeSR ();
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, regs.sr);
}}}l_340636: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MVSR2.W (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_40f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 32;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340637; }
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
	MakeSR ();
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, regs.sr);
}}}}l_340637: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MVSR2.W (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_40f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 32;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340638; }
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	MakeSR ();
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, regs.sr);
}}}l_340638: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MVSR2.W (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_40f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 32;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340639; }
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
	MakeSR ();
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, regs.sr);
}}}l_340639: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* CHK.L Dn,Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4100_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 80;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	m68k_incpci (2);
	if (dst > src) {
		SET_NFLG (0);
		Exception_cpu(6);
		goto l_340640;
	}
	if ((uae_s32)dst < 0) {
		SET_NFLG (1);
		Exception_cpu(6);
		goto l_340640;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}l_340640: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* CHK.L (An),Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4110_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 80;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	m68k_incpci (2);
	if (dst > src) {
		SET_NFLG (0);
		Exception_cpu(6);
		goto l_340641;
	}
	if ((uae_s32)dst < 0) {
		SET_NFLG (1);
		Exception_cpu(6);
		goto l_340641;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340641: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* CHK.L (An)+,Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4118_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 80;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	m68k_incpci (2);
	if (dst > src) {
		SET_NFLG (0);
		Exception_cpu(6);
		goto l_340642;
	}
	if ((uae_s32)dst < 0) {
		SET_NFLG (1);
		Exception_cpu(6);
		goto l_340642;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340642: ;
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* CHK.L -(An),Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4120_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 80;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	m68k_incpci (2);
	if (dst > src) {
		SET_NFLG (0);
		Exception_cpu(6);
		goto l_340643;
	}
	if ((uae_s32)dst < 0) {
		SET_NFLG (1);
		Exception_cpu(6);
		goto l_340643;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340643: ;
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* CHK.L (d16,An),Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4128_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 80;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	m68k_incpci (4);
	if (dst > src) {
		SET_NFLG (0);
		Exception_cpu(6);
		goto l_340644;
	}
	if ((uae_s32)dst < 0) {
		SET_NFLG (1);
		Exception_cpu(6);
		goto l_340644;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340644: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* CHK.L (d8,An,Xn),Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4130_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 80;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	if (dst > src) {
		SET_NFLG (0);
		Exception_cpu(6);
		goto l_340645;
	}
	if ((uae_s32)dst < 0) {
		SET_NFLG (1);
		Exception_cpu(6);
		goto l_340645;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}l_340645: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

#endif
/* CHK.L (xxx).W,Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4138_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 80;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	m68k_incpci (4);
	if (dst > src) {
		SET_NFLG (0);
		Exception_cpu(6);
		goto l_340646;
	}
	if ((uae_s32)dst < 0) {
		SET_NFLG (1);
		Exception_cpu(6);
		goto l_340646;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340646: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* CHK.L (xxx).L,Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4139_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 80;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	m68k_incpci (6);
	if (dst > src) {
		SET_NFLG (0);
		Exception_cpu(6);
		goto l_340647;
	}
	if ((uae_s32)dst < 0) {
		SET_NFLG (1);
		Exception_cpu(6);
		goto l_340647;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340647: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* CHK.L (d16,PC),Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_413a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 80;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	m68k_incpci (4);
	if (dst > src) {
		SET_NFLG (0);
		Exception_cpu(6);
		goto l_340648;
	}
	if ((uae_s32)dst < 0) {
		SET_NFLG (1);
		Exception_cpu(6);
		goto l_340648;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340648: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* CHK.L (d8,PC,Xn),Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_413b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 80;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	if (dst > src) {
		SET_NFLG (0);
		Exception_cpu(6);
		goto l_340649;
	}
	if ((uae_s32)dst < 0) {
		SET_NFLG (1);
		Exception_cpu(6);
		goto l_340649;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}l_340649: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

#endif
/* CHK.L #<data>.L,Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_413c_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 80;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	m68k_incpci (6);
	if (dst > src) {
		SET_NFLG (0);
		Exception_cpu(6);
		goto l_340650;
	}
	if ((uae_s32)dst < 0) {
		SET_NFLG (1);
		Exception_cpu(6);
		goto l_340650;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}l_340650: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* CHK.W Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_4180_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 80;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	m68k_incpci (2);
	if (dst > src) {
		SET_NFLG (0);
		Exception_cpu(6);
		goto l_340651;
	}
	if ((uae_s32)dst < 0) {
		SET_NFLG (1);
		Exception_cpu(6);
		goto l_340651;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}l_340651: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CHK.W (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_4190_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 80;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	m68k_incpci (2);
	if (dst > src) {
		SET_NFLG (0);
		Exception_cpu(6);
		goto l_340652;
	}
	if ((uae_s32)dst < 0) {
		SET_NFLG (1);
		Exception_cpu(6);
		goto l_340652;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340652: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CHK.W (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_4198_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 80;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	m68k_incpci (2);
	if (dst > src) {
		SET_NFLG (0);
		Exception_cpu(6);
		goto l_340653;
	}
	if ((uae_s32)dst < 0) {
		SET_NFLG (1);
		Exception_cpu(6);
		goto l_340653;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340653: ;
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CHK.W -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_41a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 80;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	m68k_incpci (2);
	if (dst > src) {
		SET_NFLG (0);
		Exception_cpu(6);
		goto l_340654;
	}
	if ((uae_s32)dst < 0) {
		SET_NFLG (1);
		Exception_cpu(6);
		goto l_340654;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340654: ;
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CHK.W (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_41a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 80;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	m68k_incpci (4);
	if (dst > src) {
		SET_NFLG (0);
		Exception_cpu(6);
		goto l_340655;
	}
	if ((uae_s32)dst < 0) {
		SET_NFLG (1);
		Exception_cpu(6);
		goto l_340655;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340655: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CHK.W (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_41b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 80;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	if (dst > src) {
		SET_NFLG (0);
		Exception_cpu(6);
		goto l_340656;
	}
	if ((uae_s32)dst < 0) {
		SET_NFLG (1);
		Exception_cpu(6);
		goto l_340656;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}l_340656: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* CHK.W (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_41b8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 80;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	m68k_incpci (4);
	if (dst > src) {
		SET_NFLG (0);
		Exception_cpu(6);
		goto l_340657;
	}
	if ((uae_s32)dst < 0) {
		SET_NFLG (1);
		Exception_cpu(6);
		goto l_340657;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340657: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CHK.W (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_41b9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 80;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	m68k_incpci (6);
	if (dst > src) {
		SET_NFLG (0);
		Exception_cpu(6);
		goto l_340658;
	}
	if ((uae_s32)dst < 0) {
		SET_NFLG (1);
		Exception_cpu(6);
		goto l_340658;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340658: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* CHK.W (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_41ba_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 80;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	m68k_incpci (4);
	if (dst > src) {
		SET_NFLG (0);
		Exception_cpu(6);
		goto l_340659;
	}
	if ((uae_s32)dst < 0) {
		SET_NFLG (1);
		Exception_cpu(6);
		goto l_340659;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340659: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CHK.W (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_41bb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 80;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	if (dst > src) {
		SET_NFLG (0);
		Exception_cpu(6);
		goto l_340660;
	}
	if ((uae_s32)dst < 0) {
		SET_NFLG (1);
		Exception_cpu(6);
		goto l_340660;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}l_340660: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* CHK.W #<data>.W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_41bc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 80;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	m68k_incpci (4);
	if (dst > src) {
		SET_NFLG (0);
		Exception_cpu(6);
		goto l_340661;
	}
	if ((uae_s32)dst < 0) {
		SET_NFLG (1);
		Exception_cpu(6);
		goto l_340661;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}l_340661: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* LEA.L (An),An */
uae_u32 REGPARAM2 CPUFUNC(op_41d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 56;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (srca);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* LEA.L (d16,An),An */
uae_u32 REGPARAM2 CPUFUNC(op_41e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 56;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (srca);
}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* LEA.L (d8,An,Xn),An */
uae_u32 REGPARAM2 CPUFUNC(op_41f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 56;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_areg (regs, dstreg) = (srca);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* LEA.L (xxx).W,An */
uae_u32 REGPARAM2 CPUFUNC(op_41f8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 56;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (srca);
}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* LEA.L (xxx).L,An */
uae_u32 REGPARAM2 CPUFUNC(op_41f9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 56;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_areg (regs, dstreg) = (srca);
}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* LEA.L (d16,PC),An */
uae_u32 REGPARAM2 CPUFUNC(op_41fa_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 56;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (srca);
}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* LEA.L (d8,PC,Xn),An */
uae_u32 REGPARAM2 CPUFUNC(op_41fb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 56;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_areg (regs, dstreg) = (srca);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* CLR.B Dn */
uae_u32 REGPARAM2 CPUFUNC(op_4200_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(0)) == 0);
	SET_NFLG (((uae_s8)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xff) | ((0) & 0xff);
}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CLR.B (An) */
uae_u32 REGPARAM2 CPUFUNC(op_4210_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(0)) == 0);
	SET_NFLG (((uae_s8)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, 0);
}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CLR.B (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_4218_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(0)) == 0);
	SET_NFLG (((uae_s8)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, 0);
}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CLR.B -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_4220_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(0)) == 0);
	SET_NFLG (((uae_s8)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, 0);
}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CLR.B (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_4228_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(0)) == 0);
	SET_NFLG (((uae_s8)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, 0);
}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CLR.B (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_4230_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(0)) == 0);
	SET_NFLG (((uae_s8)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, 0);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* CLR.B (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_4238_34)(uae_u32 opcode)
{
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(0)) == 0);
	SET_NFLG (((uae_s8)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, 0);
}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CLR.B (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_4239_34)(uae_u32 opcode)
{
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(0)) == 0);
	SET_NFLG (((uae_s8)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, 0);
}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* CLR.W Dn */
uae_u32 REGPARAM2 CPUFUNC(op_4240_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(0)) == 0);
	SET_NFLG (((uae_s16)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | ((0) & 0xffff);
}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CLR.W (An) */
uae_u32 REGPARAM2 CPUFUNC(op_4250_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(0)) == 0);
	SET_NFLG (((uae_s16)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, 0);
}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CLR.W (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_4258_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(0)) == 0);
	SET_NFLG (((uae_s16)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, 0);
}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CLR.W -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_4260_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(0)) == 0);
	SET_NFLG (((uae_s16)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, 0);
}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CLR.W (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_4268_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(0)) == 0);
	SET_NFLG (((uae_s16)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, 0);
}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CLR.W (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_4270_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(0)) == 0);
	SET_NFLG (((uae_s16)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, 0);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* CLR.W (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_4278_34)(uae_u32 opcode)
{
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(0)) == 0);
	SET_NFLG (((uae_s16)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, 0);
}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CLR.W (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_4279_34)(uae_u32 opcode)
{
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(0)) == 0);
	SET_NFLG (((uae_s16)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, 0);
}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* CLR.L Dn */
uae_u32 REGPARAM2 CPUFUNC(op_4280_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(0)) == 0);
	SET_NFLG (((uae_s32)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (0);
}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CLR.L (An) */
uae_u32 REGPARAM2 CPUFUNC(op_4290_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(0)) == 0);
	SET_NFLG (((uae_s32)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, 0);
}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CLR.L (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_4298_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(0)) == 0);
	SET_NFLG (((uae_s32)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, 0);
}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CLR.L -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_42a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(0)) == 0);
	SET_NFLG (((uae_s32)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, 0);
}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CLR.L (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_42a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(0)) == 0);
	SET_NFLG (((uae_s32)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, 0);
}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CLR.L (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_42b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(0)) == 0);
	SET_NFLG (((uae_s32)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, 0);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* CLR.L (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_42b8_34)(uae_u32 opcode)
{
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(0)) == 0);
	SET_NFLG (((uae_s32)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, 0);
}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CLR.L (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_42b9_34)(uae_u32 opcode)
{
	OpcodeFamily = 18;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(0)) == 0);
	SET_NFLG (((uae_s32)(0)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, 0);
}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MVSR2.B Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_42c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 32;
	CurrentInstrCycles = 4;  
{{	MakeSR ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | ((regs.sr & 0xff) & 0xffff);
}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* MVSR2.B (An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_42d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 32;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	MakeSR ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, regs.sr & 0xff);
}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* MVSR2.B (An)+ */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_42d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 32;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
	MakeSR ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, regs.sr & 0xff);
}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* MVSR2.B -(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_42e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 32;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
	MakeSR ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, regs.sr & 0xff);
}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* MVSR2.B (d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_42e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 32;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	MakeSR ();
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, regs.sr & 0xff);
}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* MVSR2.B (d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_42f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 32;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
	MakeSR ();
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, regs.sr & 0xff);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

#endif
/* MVSR2.B (xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_42f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 32;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	MakeSR ();
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, regs.sr & 0xff);
}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* MVSR2.B (xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_42f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 32;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
	MakeSR ();
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, regs.sr & 0xff);
}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* NEG.B Dn */
uae_u32 REGPARAM2 CPUFUNC(op_4400_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{{uae_u32 dst = ((uae_u8)(0)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(dst)) < 0;
	SET_ZFLG (((uae_s8)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xff) | ((dst) & 0xff);
}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif

#ifdef PART_4
/* NEG.B (An) */
uae_u32 REGPARAM2 CPUFUNC(op_4410_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{{uae_u32 dst = ((uae_u8)(0)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(dst)) < 0;
	SET_ZFLG (((uae_s8)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, dst);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEG.B (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_4418_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{{uae_u32 dst = ((uae_u8)(0)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(dst)) < 0;
	SET_ZFLG (((uae_s8)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, dst);
}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEG.B -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_4420_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{{uae_u32 dst = ((uae_u8)(0)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(dst)) < 0;
	SET_ZFLG (((uae_s8)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, dst);
}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEG.B (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_4428_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{{uae_u32 dst = ((uae_u8)(0)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(dst)) < 0;
	SET_ZFLG (((uae_s8)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, dst);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* NEG.B (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_4430_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{{uae_u32 dst = ((uae_u8)(0)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(dst)) < 0;
	SET_ZFLG (((uae_s8)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, dst);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* NEG.B (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_4438_34)(uae_u32 opcode)
{
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{{uae_u32 dst = ((uae_u8)(0)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(dst)) < 0;
	SET_ZFLG (((uae_s8)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, dst);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* NEG.B (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_4439_34)(uae_u32 opcode)
{
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{{uae_u32 dst = ((uae_u8)(0)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(dst)) < 0;
	SET_ZFLG (((uae_s8)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, dst);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* NEG.W Dn */
uae_u32 REGPARAM2 CPUFUNC(op_4440_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{{uae_u32 dst = ((uae_u16)(0)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(dst)) < 0;
	SET_ZFLG (((uae_s16)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | ((dst) & 0xffff);
}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEG.W (An) */
uae_u32 REGPARAM2 CPUFUNC(op_4450_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{{uae_u32 dst = ((uae_u16)(0)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(dst)) < 0;
	SET_ZFLG (((uae_s16)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, dst);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEG.W (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_4458_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{{uae_u32 dst = ((uae_u16)(0)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(dst)) < 0;
	SET_ZFLG (((uae_s16)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, dst);
}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEG.W -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_4460_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{{uae_u32 dst = ((uae_u16)(0)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(dst)) < 0;
	SET_ZFLG (((uae_s16)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, dst);
}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEG.W (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_4468_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{{uae_u32 dst = ((uae_u16)(0)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(dst)) < 0;
	SET_ZFLG (((uae_s16)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, dst);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* NEG.W (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_4470_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{{uae_u32 dst = ((uae_u16)(0)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(dst)) < 0;
	SET_ZFLG (((uae_s16)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, dst);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* NEG.W (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_4478_34)(uae_u32 opcode)
{
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{{uae_u32 dst = ((uae_u16)(0)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(dst)) < 0;
	SET_ZFLG (((uae_s16)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, dst);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* NEG.W (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_4479_34)(uae_u32 opcode)
{
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{{uae_u32 dst = ((uae_u16)(0)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(dst)) < 0;
	SET_ZFLG (((uae_s16)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, dst);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* NEG.L Dn */
uae_u32 REGPARAM2 CPUFUNC(op_4480_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{{uae_u32 dst = ((uae_u32)(0)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(dst)) < 0;
	SET_ZFLG (((uae_s32)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (dst);
}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEG.L (An) */
uae_u32 REGPARAM2 CPUFUNC(op_4490_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
{{uae_u32 dst = ((uae_u32)(0)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(dst)) < 0;
	SET_ZFLG (((uae_s32)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, dst);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEG.L (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_4498_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
{{uae_u32 dst = ((uae_u32)(0)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(dst)) < 0;
	SET_ZFLG (((uae_s32)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, dst);
}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEG.L -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_44a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{{uae_u32 dst = ((uae_u32)(0)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(dst)) < 0;
	SET_ZFLG (((uae_s32)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, dst);
}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NEG.L (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_44a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{{uae_u32 dst = ((uae_u32)(0)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(dst)) < 0;
	SET_ZFLG (((uae_s32)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, dst);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* NEG.L (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_44b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{{uae_u32 dst = ((uae_u32)(0)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(dst)) < 0;
	SET_ZFLG (((uae_s32)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, dst);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* NEG.L (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_44b8_34)(uae_u32 opcode)
{
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{{uae_u32 dst = ((uae_u32)(0)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(dst)) < 0;
	SET_ZFLG (((uae_s32)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, dst);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* NEG.L (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_44b9_34)(uae_u32 opcode)
{
	OpcodeFamily = 15;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{{uae_u32 dst = ((uae_u32)(0)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(dst)) < 0;
	SET_ZFLG (((uae_s32)(dst)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(0)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, dst);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MV2SR.B Dn */
uae_u32 REGPARAM2 CPUFUNC(op_44c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 33;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
	MakeSR ();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR_T0();
	m68k_incpci (2);
	fill_prefetch_030_ntx();
}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MV2SR.B (An) */
uae_u32 REGPARAM2 CPUFUNC(op_44d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 33;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	MakeSR ();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR_T0();
	m68k_incpci (2);
	fill_prefetch_030_ntx();
}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MV2SR.B (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_44d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 33;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
	MakeSR ();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR_T0();
	m68k_incpci (2);
	fill_prefetch_030_ntx();
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MV2SR.B -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_44e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 33;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
	MakeSR ();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR_T0();
	m68k_incpci (2);
	fill_prefetch_030_ntx();
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MV2SR.B (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_44e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 33;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
	MakeSR ();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR_T0();
	m68k_incpci (4);
	fill_prefetch_030_ntx();
}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MV2SR.B (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_44f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 33;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
	MakeSR ();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR_T0();
	fill_prefetch_030_ntx();
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MV2SR.B (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_44f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 33;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
	MakeSR ();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR_T0();
	m68k_incpci (4);
	fill_prefetch_030_ntx();
}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MV2SR.B (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_44f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 33;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
	MakeSR ();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR_T0();
	m68k_incpci (6);
	fill_prefetch_030_ntx();
}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MV2SR.B (d16,PC) */
uae_u32 REGPARAM2 CPUFUNC(op_44fa_34)(uae_u32 opcode)
{
	OpcodeFamily = 33;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
	MakeSR ();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR_T0();
	m68k_incpci (4);
	fill_prefetch_030_ntx();
}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MV2SR.B (d8,PC,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_44fb_34)(uae_u32 opcode)
{
	OpcodeFamily = 33;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
	MakeSR ();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR_T0();
	fill_prefetch_030_ntx();
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MV2SR.B #<data>.B */
uae_u32 REGPARAM2 CPUFUNC(op_44fc_34)(uae_u32 opcode)
{
	OpcodeFamily = 33;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
	MakeSR ();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR_T0();
	m68k_incpci (4);
	fill_prefetch_030_ntx();
}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* NOT.B Dn */
uae_u32 REGPARAM2 CPUFUNC(op_4600_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(dst)) == 0);
	SET_NFLG (((uae_s8)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xff) | ((dst) & 0xff);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NOT.B (An) */
uae_u32 REGPARAM2 CPUFUNC(op_4610_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(dst)) == 0);
	SET_NFLG (((uae_s8)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, dst);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NOT.B (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_4618_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(dst)) == 0);
	SET_NFLG (((uae_s8)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, dst);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NOT.B -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_4620_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(dst)) == 0);
	SET_NFLG (((uae_s8)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, dst);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NOT.B (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_4628_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(dst)) == 0);
	SET_NFLG (((uae_s8)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, dst);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* NOT.B (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_4630_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(dst)) == 0);
	SET_NFLG (((uae_s8)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, dst);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* NOT.B (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_4638_34)(uae_u32 opcode)
{
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(dst)) == 0);
	SET_NFLG (((uae_s8)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, dst);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* NOT.B (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_4639_34)(uae_u32 opcode)
{
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(dst)) == 0);
	SET_NFLG (((uae_s8)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, dst);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* NOT.W Dn */
uae_u32 REGPARAM2 CPUFUNC(op_4640_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(dst)) == 0);
	SET_NFLG (((uae_s16)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | ((dst) & 0xffff);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NOT.W (An) */
uae_u32 REGPARAM2 CPUFUNC(op_4650_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(dst)) == 0);
	SET_NFLG (((uae_s16)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, dst);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NOT.W (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_4658_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(dst)) == 0);
	SET_NFLG (((uae_s16)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, dst);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NOT.W -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_4660_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(dst)) == 0);
	SET_NFLG (((uae_s16)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, dst);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NOT.W (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_4668_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(dst)) == 0);
	SET_NFLG (((uae_s16)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, dst);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* NOT.W (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_4670_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(dst)) == 0);
	SET_NFLG (((uae_s16)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, dst);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* NOT.W (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_4678_34)(uae_u32 opcode)
{
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(dst)) == 0);
	SET_NFLG (((uae_s16)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, dst);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* NOT.W (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_4679_34)(uae_u32 opcode)
{
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(dst)) == 0);
	SET_NFLG (((uae_s16)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (srca, dst);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* NOT.L Dn */
uae_u32 REGPARAM2 CPUFUNC(op_4680_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(dst)) == 0);
	SET_NFLG (((uae_s32)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (dst);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NOT.L (An) */
uae_u32 REGPARAM2 CPUFUNC(op_4690_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(dst)) == 0);
	SET_NFLG (((uae_s32)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, dst);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NOT.L (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_4698_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(dst)) == 0);
	SET_NFLG (((uae_s32)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, dst);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NOT.L -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_46a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(dst)) == 0);
	SET_NFLG (((uae_s32)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, dst);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NOT.L (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_46a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(dst)) == 0);
	SET_NFLG (((uae_s32)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, dst);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* NOT.L (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_46b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(dst)) == 0);
	SET_NFLG (((uae_s32)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, dst);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* NOT.L (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_46b8_34)(uae_u32 opcode)
{
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(dst)) == 0);
	SET_NFLG (((uae_s32)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, dst);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* NOT.L (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_46b9_34)(uae_u32 opcode)
{
	OpcodeFamily = 19;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_u32 dst = ~src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(dst)) == 0);
	SET_NFLG (((uae_s32)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (srca, dst);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MV2SR.W Dn */
uae_u32 REGPARAM2 CPUFUNC(op_46c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 33;
	CurrentInstrCycles = 8;  
{if (!regs.s) { Exception (8); goto l_340760; }
{{	uae_s16 src = m68k_dreg (regs, srcreg);
	regs.sr = src;
	MakeFromSR_T0();
	m68k_incpci (2);
	fill_prefetch_030_ntx();
}}}l_340760: ;
return 8 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MV2SR.W (An) */
uae_u32 REGPARAM2 CPUFUNC(op_46d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 33;
	CurrentInstrCycles = 8;  
{if (!regs.s) { Exception (8); goto l_340761; }
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	regs.sr = src;
	MakeFromSR_T0();
	m68k_incpci (2);
	fill_prefetch_030_ntx();
}}}}l_340761: ;
return 8 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MV2SR.W (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_46d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 33;
	CurrentInstrCycles = 8;  
{if (!regs.s) { Exception (8); goto l_340762; }
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
	regs.sr = src;
	MakeFromSR_T0();
	m68k_incpci (2);
	fill_prefetch_030_ntx();
}}}}l_340762: ;
	mmufixup[0].reg = -1;
return 8 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MV2SR.W -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_46e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 33;
	CurrentInstrCycles = 8;  
{if (!regs.s) { Exception (8); goto l_340763; }
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
	regs.sr = src;
	MakeFromSR_T0();
	m68k_incpci (2);
	fill_prefetch_030_ntx();
}}}}l_340763: ;
	mmufixup[0].reg = -1;
return 8 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MV2SR.W (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_46e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 33;
	CurrentInstrCycles = 8;  
{if (!regs.s) { Exception (8); goto l_340764; }
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
	regs.sr = src;
	MakeFromSR_T0();
	m68k_incpci (4);
	fill_prefetch_030_ntx();
}}}}l_340764: ;
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MV2SR.W (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_46f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 33;
	CurrentInstrCycles = 8;  
{if (!regs.s) { Exception (8); goto l_340765; }
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
	regs.sr = src;
	MakeFromSR_T0();
	fill_prefetch_030_ntx();
}}}}}l_340765: ;
return 8 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MV2SR.W (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_46f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 33;
	CurrentInstrCycles = 8;  
{if (!regs.s) { Exception (8); goto l_340766; }
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
	regs.sr = src;
	MakeFromSR_T0();
	m68k_incpci (4);
	fill_prefetch_030_ntx();
}}}}l_340766: ;
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MV2SR.W (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_46f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 33;
	CurrentInstrCycles = 8;  
{if (!regs.s) { Exception (8); goto l_340767; }
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
	regs.sr = src;
	MakeFromSR_T0();
	m68k_incpci (6);
	fill_prefetch_030_ntx();
}}}}l_340767: ;
return 8 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MV2SR.W (d16,PC) */
uae_u32 REGPARAM2 CPUFUNC(op_46fa_34)(uae_u32 opcode)
{
	OpcodeFamily = 33;
	CurrentInstrCycles = 8;  
{if (!regs.s) { Exception (8); goto l_340768; }
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
	regs.sr = src;
	MakeFromSR_T0();
	m68k_incpci (4);
	fill_prefetch_030_ntx();
}}}}l_340768: ;
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MV2SR.W (d8,PC,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_46fb_34)(uae_u32 opcode)
{
	OpcodeFamily = 33;
	CurrentInstrCycles = 8;  
{if (!regs.s) { Exception (8); goto l_340769; }
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
	regs.sr = src;
	MakeFromSR_T0();
	fill_prefetch_030_ntx();
}}}}}l_340769: ;
return 8 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MV2SR.W #<data>.W */
uae_u32 REGPARAM2 CPUFUNC(op_46fc_34)(uae_u32 opcode)
{
	OpcodeFamily = 33;
	CurrentInstrCycles = 8;  
{if (!regs.s) { Exception (8); goto l_340770; }
{{	uae_s16 src = get_iword_mmu030c_state (2);
	regs.sr = src;
	MakeFromSR_T0();
	m68k_incpci (4);
	fill_prefetch_030_ntx();
}}}l_340770: ;
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* NBCD.B Dn */
uae_u32 REGPARAM2 CPUFUNC(op_4800_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 17;
	CurrentInstrCycles = 6;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uae_u16 newv_lo = - (src & 0xF) - (GET_XFLG () ? 1 : 0);
	uae_u16 newv_hi = - (src & 0xF0);
	uae_u16 newv;
	int cflg, tmp_newv;
	tmp_newv = newv_hi + newv_lo;
	if (newv_lo > 9) { newv_lo -= 6; }
	newv = newv_hi + newv_lo;
	cflg = (newv & 0x1F0) > 0x90;
	if (cflg) newv -= 0x60;
	SET_CFLG (cflg);
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xff) | ((newv) & 0xff);
}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* LINK.L An,#<data>.L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4808_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 47;
	CurrentInstrCycles = 6;  
{	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
{	uae_s32 offs;
	offs = get_ilong_mmu030c_state (2);
{	uaecptr olda;
	olda = m68k_areg (regs, 7) - 4;
	mmufixup[1].reg = 7;
	mmufixup[1].value = m68k_areg (regs, 7);
	m68k_areg (regs, 7) = olda;
{	uae_s32 src = m68k_areg (regs, srcreg);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_areg (regs, srcreg) = (m68k_areg(regs, 7));
	m68k_areg(regs, 7) += offs;
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (olda, src);
}}}}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 6 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* NBCD.B (An) */
uae_u32 REGPARAM2 CPUFUNC(op_4810_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 17;
	CurrentInstrCycles = 6;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_u16 newv_lo = - (src & 0xF) - (GET_XFLG () ? 1 : 0);
	uae_u16 newv_hi = - (src & 0xF0);
	uae_u16 newv;
	int cflg, tmp_newv;
	tmp_newv = newv_hi + newv_lo;
	if (newv_lo > 9) { newv_lo -= 6; }
	newv = newv_hi + newv_lo;
	cflg = (newv & 0x1F0) > 0x90;
	if (cflg) newv -= 0x60;
	SET_CFLG (cflg);
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, newv);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NBCD.B (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_4818_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 17;
	CurrentInstrCycles = 6;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{	uae_u16 newv_lo = - (src & 0xF) - (GET_XFLG () ? 1 : 0);
	uae_u16 newv_hi = - (src & 0xF0);
	uae_u16 newv;
	int cflg, tmp_newv;
	tmp_newv = newv_hi + newv_lo;
	if (newv_lo > 9) { newv_lo -= 6; }
	newv = newv_hi + newv_lo;
	cflg = (newv & 0x1F0) > 0x90;
	if (cflg) newv -= 0x60;
	SET_CFLG (cflg);
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, newv);
}}}}	mmufixup[0].reg = -1;
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NBCD.B -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_4820_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 17;
	CurrentInstrCycles = 6;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_u16 newv_lo = - (src & 0xF) - (GET_XFLG () ? 1 : 0);
	uae_u16 newv_hi = - (src & 0xF0);
	uae_u16 newv;
	int cflg, tmp_newv;
	tmp_newv = newv_hi + newv_lo;
	if (newv_lo > 9) { newv_lo -= 6; }
	newv = newv_hi + newv_lo;
	cflg = (newv & 0x1F0) > 0x90;
	if (cflg) newv -= 0x60;
	SET_CFLG (cflg);
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, newv);
}}}}	mmufixup[0].reg = -1;
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NBCD.B (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_4828_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 17;
	CurrentInstrCycles = 6;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_u16 newv_lo = - (src & 0xF) - (GET_XFLG () ? 1 : 0);
	uae_u16 newv_hi = - (src & 0xF0);
	uae_u16 newv;
	int cflg, tmp_newv;
	tmp_newv = newv_hi + newv_lo;
	if (newv_lo > 9) { newv_lo -= 6; }
	newv = newv_hi + newv_lo;
	cflg = (newv & 0x1F0) > 0x90;
	if (cflg) newv -= 0x60;
	SET_CFLG (cflg);
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, newv);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* NBCD.B (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_4830_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 17;
	CurrentInstrCycles = 6;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_u16 newv_lo = - (src & 0xF) - (GET_XFLG () ? 1 : 0);
	uae_u16 newv_hi = - (src & 0xF0);
	uae_u16 newv;
	int cflg, tmp_newv;
	tmp_newv = newv_hi + newv_lo;
	if (newv_lo > 9) { newv_lo -= 6; }
	newv = newv_hi + newv_lo;
	cflg = (newv & 0x1F0) > 0x90;
	if (cflg) newv -= 0x60;
	SET_CFLG (cflg);
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, newv);
}}}}}return 6 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* NBCD.B (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_4838_34)(uae_u32 opcode)
{
	OpcodeFamily = 17;
	CurrentInstrCycles = 6;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_u16 newv_lo = - (src & 0xF) - (GET_XFLG () ? 1 : 0);
	uae_u16 newv_hi = - (src & 0xF0);
	uae_u16 newv;
	int cflg, tmp_newv;
	tmp_newv = newv_hi + newv_lo;
	if (newv_lo > 9) { newv_lo -= 6; }
	newv = newv_hi + newv_lo;
	cflg = (newv & 0x1F0) > 0x90;
	if (cflg) newv -= 0x60;
	SET_CFLG (cflg);
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, newv);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* NBCD.B (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_4839_34)(uae_u32 opcode)
{
	OpcodeFamily = 17;
	CurrentInstrCycles = 6;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_u16 newv_lo = - (src & 0xF) - (GET_XFLG () ? 1 : 0);
	uae_u16 newv_hi = - (src & 0xF0);
	uae_u16 newv;
	int cflg, tmp_newv;
	tmp_newv = newv_hi + newv_lo;
	if (newv_lo > 9) { newv_lo -= 6; }
	newv = newv_hi + newv_lo;
	cflg = (newv & 0x1F0) > 0x90;
	if (cflg) newv -= 0x60;
	SET_CFLG (cflg);
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, newv);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* SWAP.W Dn */
uae_u32 REGPARAM2 CPUFUNC(op_4840_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 34;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_u32 dst = ((src >> 16)&0xFFFF) | ((src&0xFFFF)<<16);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(dst)) == 0);
	SET_NFLG (((uae_s32)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (dst);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* BKPTQ.L #<data> */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4848_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 99;
	CurrentInstrCycles = 4;  
{	m68k_incpci (2);
	op_illg (opcode);
}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* PEA.L (An) */
uae_u32 REGPARAM2 CPUFUNC(op_4850_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 57;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, 7) - 4;
	mmufixup[0].reg = 7;
	mmufixup[0].value = m68k_areg (regs, 7);
	m68k_areg (regs, 7) = dsta;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, srca);
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* PEA.L (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_4868_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 57;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, 7) - 4;
	mmufixup[0].reg = 7;
	mmufixup[0].value = m68k_areg (regs, 7);
	m68k_areg (regs, 7) = dsta;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, srca);
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* PEA.L (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_4870_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 57;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uaecptr dsta;
	dsta = m68k_areg (regs, 7) - 4;
	mmufixup[0].reg = 7;
	mmufixup[0].value = m68k_areg (regs, 7);
	m68k_areg (regs, 7) = dsta;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, srca);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* PEA.L (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_4878_34)(uae_u32 opcode)
{
	OpcodeFamily = 57;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, 7) - 4;
	mmufixup[0].reg = 7;
	mmufixup[0].value = m68k_areg (regs, 7);
	m68k_areg (regs, 7) = dsta;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, srca);
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* PEA.L (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_4879_34)(uae_u32 opcode)
{
	OpcodeFamily = 57;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, 7) - 4;
	mmufixup[0].reg = 7;
	mmufixup[0].value = m68k_areg (regs, 7);
	m68k_areg (regs, 7) = dsta;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, srca);
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* PEA.L (d16,PC) */
uae_u32 REGPARAM2 CPUFUNC(op_487a_34)(uae_u32 opcode)
{
	OpcodeFamily = 57;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, 7) - 4;
	mmufixup[0].reg = 7;
	mmufixup[0].value = m68k_areg (regs, 7);
	m68k_areg (regs, 7) = dsta;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, srca);
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* PEA.L (d8,PC,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_487b_34)(uae_u32 opcode)
{
	OpcodeFamily = 57;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uaecptr dsta;
	dsta = m68k_areg (regs, 7) - 4;
	mmufixup[0].reg = 7;
	mmufixup[0].value = m68k_areg (regs, 7);
	m68k_areg (regs, 7) = dsta;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, srca);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* EXT.W Dn */
uae_u32 REGPARAM2 CPUFUNC(op_4880_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 36;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_u16 dst = (uae_s16)(uae_s8)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(dst)) == 0);
	SET_NFLG (((uae_s16)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | ((dst) & 0xffff);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MVMLE.W #<data>.W,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_4890_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 38;
	CurrentInstrCycles = 8;  
{	uae_u16 mask = get_iword_mmu030c_state (2);
{	uaecptr srca;
	srca = m68k_areg (regs, dstreg);
{	uae_u16 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
	int prefetch = 0;
	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_dreg(regs, movem_index1[dmask]);
				if(!amask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
				}
				put_word_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_areg(regs, movem_index1[amask]);
				if(!dmask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
				}
				put_word_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		amask = nextmask;
	}
	if(prefetch == 0) {
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	}
}}}return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MVMLE.W #<data>.W,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_48a0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 38;
	CurrentInstrCycles = 8;  
{	uae_u16 mask = get_iword_mmu030c_state (2);
{	uaecptr srca;
	srca = m68k_areg (regs, dstreg) - 0;
{	uae_u16 amask = mask & 0xff, dmask = (mask >> 8) & 0xff;
	int prefetch = 0;
	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		srca -= 2;
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_areg(regs, movem_index2[amask]);
				if(!dmask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
	m68k_areg (regs, dstreg) = srca;
				}
				put_word_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		movem_cnt++;
		amask = nextmask;
	}
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		srca -= 2;
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_dreg(regs, movem_index2[dmask]);
				if(!amask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
	m68k_areg (regs, dstreg) = srca;
				}
				put_word_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		movem_cnt++;
		dmask = nextmask;
	}
	m68k_areg (regs, dstreg) = srca;
	if(prefetch == 0) {
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	}
}}}return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MVMLE.W #<data>.W,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_48a8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 38;
	CurrentInstrCycles = 8;  
{	uae_u16 mask = get_iword_mmu030c_state (2);
{	uaecptr srca;
	srca = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u16 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
	int prefetch = 0;
	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_dreg(regs, movem_index1[dmask]);
				if(!amask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
				}
				put_word_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_areg(regs, movem_index1[amask]);
				if(!dmask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
				}
				put_word_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		amask = nextmask;
	}
	if(prefetch == 0) {
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	}
}}}return 8 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MVMLE.W #<data>.W,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_48b0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 38;
	CurrentInstrCycles = 8;  
{	uae_u16 mask = get_iword_mmu030c_state (2);
{	uaecptr srca;
	m68k_incpci (4);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_u16 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
	int prefetch = 0;
	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_dreg(regs, movem_index1[dmask]);
				if(!amask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
				}
				put_word_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_areg(regs, movem_index1[amask]);
				if(!dmask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
				}
				put_word_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		amask = nextmask;
	}
	if(prefetch == 0) {
	regs.irc = get_iword_mmu030c_opcode_state (0);
	}
}}}}return 8 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* MVMLE.W #<data>.W,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_48b8_34)(uae_u32 opcode)
{
	OpcodeFamily = 38;
	CurrentInstrCycles = 8;  
{	uae_u16 mask = get_iword_mmu030c_state (2);
{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u16 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
	int prefetch = 0;
	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_dreg(regs, movem_index1[dmask]);
				if(!amask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
				}
				put_word_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_areg(regs, movem_index1[amask]);
				if(!dmask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
				}
				put_word_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		amask = nextmask;
	}
	if(prefetch == 0) {
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	}
}}}return 8 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MVMLE.W #<data>.W,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_48b9_34)(uae_u32 opcode)
{
	OpcodeFamily = 38;
	CurrentInstrCycles = 8;  
{	uae_u16 mask = get_iword_mmu030c_state (2);
{	uaecptr srca;
	srca = get_ilong_mmu030c_state (4);
{	uae_u16 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
	int prefetch = 0;
	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_dreg(regs, movem_index1[dmask]);
				if(!amask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
				}
				put_word_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_areg(regs, movem_index1[amask]);
				if(!dmask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
				}
				put_word_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		amask = nextmask;
	}
	if(prefetch == 0) {
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	}
}}}return 8 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* EXT.L Dn */
uae_u32 REGPARAM2 CPUFUNC(op_48c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 36;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_u32 dst = (uae_s32)(uae_s16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(dst)) == 0);
	SET_NFLG (((uae_s32)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (dst);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MVMLE.L #<data>.W,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_48d0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 38;
	CurrentInstrCycles = 12; 
{	uae_u16 mask = get_iword_mmu030c_state (2);
{	uaecptr srca;
	srca = m68k_areg (regs, dstreg);
{	uae_u16 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
	int prefetch = 0;
	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_dreg(regs, movem_index1[dmask]);
				if(!amask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
				}
				put_long_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_areg(regs, movem_index1[amask]);
				if(!dmask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
				}
				put_long_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		amask = nextmask;
	}
	if(prefetch == 0) {
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	}
}}}return 12 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MVMLE.L #<data>.W,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_48e0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 38;
	CurrentInstrCycles = 12; 
{	uae_u16 mask = get_iword_mmu030c_state (2);
{	uaecptr srca;
	srca = m68k_areg (regs, dstreg) - 0;
{	uae_u16 amask = mask & 0xff, dmask = (mask >> 8) & 0xff;
	int prefetch = 0;
	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		srca -= 4;
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_areg(regs, movem_index2[amask]);
				if(!dmask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
	m68k_areg (regs, dstreg) = srca;
				}
				put_long_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		movem_cnt++;
		amask = nextmask;
	}
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		srca -= 4;
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_dreg(regs, movem_index2[dmask]);
				if(!amask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
	m68k_areg (regs, dstreg) = srca;
				}
				put_long_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		movem_cnt++;
		dmask = nextmask;
	}
	m68k_areg (regs, dstreg) = srca;
	if(prefetch == 0) {
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	}
}}}return 12 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MVMLE.L #<data>.W,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_48e8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 38;
	CurrentInstrCycles = 12; 
{	uae_u16 mask = get_iword_mmu030c_state (2);
{	uaecptr srca;
	srca = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u16 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
	int prefetch = 0;
	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_dreg(regs, movem_index1[dmask]);
				if(!amask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
				}
				put_long_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_areg(regs, movem_index1[amask]);
				if(!dmask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
				}
				put_long_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		amask = nextmask;
	}
	if(prefetch == 0) {
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	}
}}}return 12 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MVMLE.L #<data>.W,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_48f0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 38;
	CurrentInstrCycles = 12; 
{	uae_u16 mask = get_iword_mmu030c_state (2);
{	uaecptr srca;
	m68k_incpci (4);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_u16 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
	int prefetch = 0;
	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_dreg(regs, movem_index1[dmask]);
				if(!amask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
				}
				put_long_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_areg(regs, movem_index1[amask]);
				if(!dmask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
				}
				put_long_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		amask = nextmask;
	}
	if(prefetch == 0) {
	regs.irc = get_iword_mmu030c_opcode_state (0);
	}
}}}}return 12 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* MVMLE.L #<data>.W,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_48f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 38;
	CurrentInstrCycles = 12; 
{	uae_u16 mask = get_iword_mmu030c_state (2);
{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u16 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
	int prefetch = 0;
	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_dreg(regs, movem_index1[dmask]);
				if(!amask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
				}
				put_long_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_areg(regs, movem_index1[amask]);
				if(!dmask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
				}
				put_long_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		amask = nextmask;
	}
	if(prefetch == 0) {
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	}
}}}return 12 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MVMLE.L #<data>.W,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_48f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 38;
	CurrentInstrCycles = 12; 
{	uae_u16 mask = get_iword_mmu030c_state (2);
{	uaecptr srca;
	srca = get_ilong_mmu030c_state (4);
{	uae_u16 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
	int prefetch = 0;
	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_dreg(regs, movem_index1[dmask]);
				if(!amask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
				}
				put_long_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
			} else {
				mmu030_data_buffer_out = m68k_areg(regs, movem_index1[amask]);
				if(!dmask && !nextmask) {
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
					mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM1;
					prefetch = 1;
				}
				put_long_mmu030c (srca, mmu030_data_buffer_out);
			}
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		amask = nextmask;
	}
	if(prefetch == 0) {
	regs.irc = get_iword_mmu030c_opcode_state (8);
	m68k_incpci (8);
	}
}}}return 12 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* EXT.B Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_49c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 36;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_u32 dst = (uae_s32)(uae_s8)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(dst)) == 0);
	SET_NFLG (((uae_s32)(dst)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (dst);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* TST.B Dn */
uae_u32 REGPARAM2 CPUFUNC(op_4a00_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* TST.B (An) */
uae_u32 REGPARAM2 CPUFUNC(op_4a10_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* TST.B (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_4a18_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* TST.B -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_4a20_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* TST.B (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_4a28_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* TST.B (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_4a30_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* TST.B (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_4a38_34)(uae_u32 opcode)
{
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* TST.B (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_4a39_34)(uae_u32 opcode)
{
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* TST.B (d16,PC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4a3a_34)(uae_u32 opcode)
{
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* TST.B (d8,PC,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4a3b_34)(uae_u32 opcode)
{
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

#endif
/* TST.B #<data>.B */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4a3c_34)(uae_u32 opcode)
{
	OpcodeFamily = 20;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}	m68k_incpci (4);
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* TST.W Dn */
uae_u32 REGPARAM2 CPUFUNC(op_4a40_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* TST.W An */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4a48_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_areg (regs, srcreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* TST.W (An) */
uae_u32 REGPARAM2 CPUFUNC(op_4a50_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* TST.W (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_4a58_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* TST.W -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_4a60_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* TST.W (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_4a68_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* TST.W (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_4a70_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* TST.W (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_4a78_34)(uae_u32 opcode)
{
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* TST.W (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_4a79_34)(uae_u32 opcode)
{
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* TST.W (d16,PC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4a7a_34)(uae_u32 opcode)
{
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* TST.W (d8,PC,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4a7b_34)(uae_u32 opcode)
{
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

#endif
/* TST.W #<data>.W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4a7c_34)(uae_u32 opcode)
{
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* TST.L Dn */
uae_u32 REGPARAM2 CPUFUNC(op_4a80_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* TST.L An */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4a88_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_areg (regs, srcreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* TST.L (An) */
uae_u32 REGPARAM2 CPUFUNC(op_4a90_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* TST.L (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_4a98_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* TST.L -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_4aa0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* TST.L (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_4aa8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* TST.L (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_4ab0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* TST.L (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_4ab8_34)(uae_u32 opcode)
{
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* TST.L (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_4ab9_34)(uae_u32 opcode)
{
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* TST.L (d16,PC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4aba_34)(uae_u32 opcode)
{
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* TST.L (d8,PC,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4abb_34)(uae_u32 opcode)
{
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

#endif
/* TST.L #<data>.L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4abc_34)(uae_u32 opcode)
{
	OpcodeFamily = 20;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* TAS.B Dn */
uae_u32 REGPARAM2 CPUFUNC(op_4ac0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 98;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	src |= 0x80;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xff) | ((src) & 0xff);
}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* TAS.B (An) */
uae_u32 REGPARAM2 CPUFUNC(op_4ad0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 98;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_lrmw_byte_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	src |= 0x80;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_lrmw_byte_mmu030c_state (srca, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* TAS.B (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_4ad8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 98;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_lrmw_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	src |= 0x80;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_lrmw_byte_mmu030c_state (srca, src);
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* TAS.B -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_4ae0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 98;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_lrmw_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	src |= 0x80;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_lrmw_byte_mmu030c_state (srca, src);
}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* TAS.B (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_4ae8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 98;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_lrmw_byte_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	src |= 0x80;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_lrmw_byte_mmu030c_state (srca, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* TAS.B (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_4af0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 98;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s8 src = get_lrmw_byte_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	src |= 0x80;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_lrmw_byte_mmu030c_state (srca, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* TAS.B (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_4af8_34)(uae_u32 opcode)
{
	OpcodeFamily = 98;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_lrmw_byte_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	src |= 0x80;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_lrmw_byte_mmu030c_state (srca, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* TAS.B (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_4af9_34)(uae_u32 opcode)
{
	OpcodeFamily = 98;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s8 src = get_lrmw_byte_mmu030c_state (srca);
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	src |= 0x80;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_lrmw_byte_mmu030c_state (srca, src);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MULL.L #<data>.W,Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4c00_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 87;
	CurrentInstrCycles = 30; 
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	m68k_incpci (4);
	if (!m68k_mull(opcode, dst, extra)) goto l_340847;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}l_340847: ;
return 30 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* MULL.L #<data>.W,(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4c10_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 87;
	CurrentInstrCycles = 30; 
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	m68k_incpci (4);
	if (!m68k_mull(opcode, dst, extra)) goto l_340848;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340848: ;
return 30 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* MULL.L #<data>.W,(An)+ */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4c18_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 87;
	CurrentInstrCycles = 30; 
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
	m68k_incpci (4);
	if (!m68k_mull(opcode, dst, extra)) goto l_340849;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340849: ;
	mmufixup[0].reg = -1;
return 30 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* MULL.L #<data>.W,-(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4c20_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 87;
	CurrentInstrCycles = 30; 
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	m68k_incpci (4);
	if (!m68k_mull(opcode, dst, extra)) goto l_340850;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340850: ;
	mmufixup[0].reg = -1;
return 30 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* MULL.L #<data>.W,(d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4c28_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 87;
	CurrentInstrCycles = 30; 
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	m68k_incpci (6);
	if (!m68k_mull(opcode, dst, extra)) goto l_340851;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340851: ;
return 30 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* MULL.L #<data>.W,(d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4c30_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 87;
	CurrentInstrCycles = 30; 
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	if (!m68k_mull(opcode, dst, extra)) goto l_340852;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}l_340852: ;
return 30 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* MULL.L #<data>.W,(xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4c38_34)(uae_u32 opcode)
{
	OpcodeFamily = 87;
	CurrentInstrCycles = 30; 
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	m68k_incpci (6);
	if (!m68k_mull(opcode, dst, extra)) goto l_340853;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340853: ;
return 30 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* MULL.L #<data>.W,(xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4c39_34)(uae_u32 opcode)
{
	OpcodeFamily = 87;
	CurrentInstrCycles = 30; 
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	m68k_incpci (8);
	if (!m68k_mull(opcode, dst, extra)) goto l_340854;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340854: ;
return 30 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* MULL.L #<data>.W,(d16,PC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4c3a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 2;
	OpcodeFamily = 87;
	CurrentInstrCycles = 30; 
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_getpci () + 4;
	dsta += (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	m68k_incpci (6);
	if (!m68k_mull(opcode, dst, extra)) goto l_340855;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340855: ;
return 30 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* MULL.L #<data>.W,(d8,PC,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4c3b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 3;
	OpcodeFamily = 87;
	CurrentInstrCycles = 30; 
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr tmppc;
	uaecptr dsta;
	m68k_incpci (4);
{	tmppc = m68k_getpci ();
	dsta = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	if (!m68k_mull(opcode, dst, extra)) goto l_340856;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}l_340856: ;
return 30 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* MULL.L #<data>.W,#<data>.L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4c3c_34)(uae_u32 opcode)
{
	OpcodeFamily = 87;
	CurrentInstrCycles = 30; 
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uae_s32 dst;
	dst = get_ilong_mmu030c_state (4);
	m68k_incpci (8);
	if (!m68k_mull(opcode, dst, extra)) goto l_340857;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}l_340857: ;
return 30 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* DIVL.L #<data>.W,Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4c40_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 86;
	CurrentInstrCycles = 50; 
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	m68k_incpci (4);
	if (!m68k_divl(opcode, dst, extra)) goto l_340858;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}l_340858: ;
return 50 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* DIVL.L #<data>.W,(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4c50_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 86;
	CurrentInstrCycles = 50; 
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	m68k_incpci (4);
	if (!m68k_divl(opcode, dst, extra)) goto l_340859;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340859: ;
return 50 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* DIVL.L #<data>.W,(An)+ */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4c58_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 86;
	CurrentInstrCycles = 50; 
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
	m68k_incpci (4);
	if (!m68k_divl(opcode, dst, extra)) goto l_340860;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340860: ;
	mmufixup[0].reg = -1;
return 50 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* DIVL.L #<data>.W,-(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4c60_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 86;
	CurrentInstrCycles = 50; 
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	m68k_incpci (4);
	if (!m68k_divl(opcode, dst, extra)) goto l_340861;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340861: ;
	mmufixup[0].reg = -1;
return 50 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* DIVL.L #<data>.W,(d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4c68_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 86;
	CurrentInstrCycles = 50; 
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	m68k_incpci (6);
	if (!m68k_divl(opcode, dst, extra)) goto l_340862;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340862: ;
return 50 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* DIVL.L #<data>.W,(d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4c70_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 86;
	CurrentInstrCycles = 50; 
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	if (!m68k_divl(opcode, dst, extra)) goto l_340863;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}l_340863: ;
return 50 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* DIVL.L #<data>.W,(xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4c78_34)(uae_u32 opcode)
{
	OpcodeFamily = 86;
	CurrentInstrCycles = 50; 
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	m68k_incpci (6);
	if (!m68k_divl(opcode, dst, extra)) goto l_340864;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340864: ;
return 50 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* DIVL.L #<data>.W,(xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4c79_34)(uae_u32 opcode)
{
	OpcodeFamily = 86;
	CurrentInstrCycles = 50; 
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	m68k_incpci (8);
	if (!m68k_divl(opcode, dst, extra)) goto l_340865;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340865: ;
return 50 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* DIVL.L #<data>.W,(d16,PC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4c7a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 2;
	OpcodeFamily = 86;
	CurrentInstrCycles = 50; 
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_getpci () + 4;
	dsta += (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	m68k_incpci (6);
	if (!m68k_divl(opcode, dst, extra)) goto l_340866;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_340866: ;
return 50 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* DIVL.L #<data>.W,(d8,PC,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4c7b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 3;
	OpcodeFamily = 86;
	CurrentInstrCycles = 50; 
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr tmppc;
	uaecptr dsta;
	m68k_incpci (4);
{	tmppc = m68k_getpci ();
	dsta = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	if (!m68k_divl(opcode, dst, extra)) goto l_340867;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}l_340867: ;
return 50 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* DIVL.L #<data>.W,#<data>.L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4c7c_34)(uae_u32 opcode)
{
	OpcodeFamily = 86;
	CurrentInstrCycles = 50; 
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uae_s32 dst;
	dst = get_ilong_mmu030c_state (4);
	m68k_incpci (8);
	if (!m68k_divl(opcode, dst, extra)) goto l_340868;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}l_340868: ;
return 50 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* MVMEL.W #<data>.W,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_4c90_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 37;
	CurrentInstrCycles = 8;  
{	uae_u16 mask = get_iword_mmu030c_state (2);
	uae_u32 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca;
	srca = m68k_areg (regs, dstreg);
{	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	uae_u32 val;
	srca = state_store_mmu030(srca);
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = (uae_s32)(uae_s16)mmu030_data_buffer_out;
			} else {
				val = (uae_s32)(uae_s16)get_word_mmu030c (srca);
			}
			m68k_dreg (regs, movem_index1[dmask]) = val;
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = (uae_s32)(uae_s16)mmu030_data_buffer_out;
			} else {
				val = (uae_s32)(uae_s16)get_word_mmu030c (srca);
			}
			m68k_areg (regs, movem_index1[amask]) = val;
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		amask = nextmask;
	}
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}	m68k_incpci (4);
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MVMEL.W #<data>.W,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_4c98_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 37;
	CurrentInstrCycles = 8;  
{	uae_u16 mask = get_iword_mmu030c_state (2);
	uae_u32 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca;
	srca = m68k_areg (regs, dstreg);
{	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	uae_u32 val;
	srca = state_store_mmu030(srca);
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = (uae_s32)(uae_s16)mmu030_data_buffer_out;
			} else {
				val = (uae_s32)(uae_s16)get_word_mmu030c (srca);
			}
			m68k_dreg (regs, movem_index1[dmask]) = val;
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = (uae_s32)(uae_s16)mmu030_data_buffer_out;
			} else {
				val = (uae_s32)(uae_s16)get_word_mmu030c (srca);
			}
			m68k_areg (regs, movem_index1[amask]) = val;
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		amask = nextmask;
	}
	m68k_areg (regs, dstreg) = srca;
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}	m68k_incpci (4);
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MVMEL.W #<data>.W,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_4ca8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 37;
	CurrentInstrCycles = 8;  
{	uae_u16 mask = get_iword_mmu030c_state (2);
	uae_u32 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca;
	srca = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	uae_u32 val;
	srca = state_store_mmu030(srca);
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = (uae_s32)(uae_s16)mmu030_data_buffer_out;
			} else {
				val = (uae_s32)(uae_s16)get_word_mmu030c (srca);
			}
			m68k_dreg (regs, movem_index1[dmask]) = val;
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = (uae_s32)(uae_s16)mmu030_data_buffer_out;
			} else {
				val = (uae_s32)(uae_s16)get_word_mmu030c (srca);
			}
			m68k_areg (regs, movem_index1[amask]) = val;
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		amask = nextmask;
	}
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}	m68k_incpci (6);
return 8 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MVMEL.W #<data>.W,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_4cb0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 37;
	CurrentInstrCycles = 8;  
{	uae_u16 mask = get_iword_mmu030c_state (2);
	uae_u32 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca;
	m68k_incpci (4);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	uae_u32 val;
	srca = state_store_mmu030(srca);
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = (uae_s32)(uae_s16)mmu030_data_buffer_out;
			} else {
				val = (uae_s32)(uae_s16)get_word_mmu030c (srca);
			}
			m68k_dreg (regs, movem_index1[dmask]) = val;
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = (uae_s32)(uae_s16)mmu030_data_buffer_out;
			} else {
				val = (uae_s32)(uae_s16)get_word_mmu030c (srca);
			}
			m68k_areg (regs, movem_index1[amask]) = val;
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		amask = nextmask;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}return 8 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* MVMEL.W #<data>.W,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_4cb8_34)(uae_u32 opcode)
{
	OpcodeFamily = 37;
	CurrentInstrCycles = 8;  
{	uae_u16 mask = get_iword_mmu030c_state (2);
	uae_u32 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	uae_u32 val;
	srca = state_store_mmu030(srca);
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = (uae_s32)(uae_s16)mmu030_data_buffer_out;
			} else {
				val = (uae_s32)(uae_s16)get_word_mmu030c (srca);
			}
			m68k_dreg (regs, movem_index1[dmask]) = val;
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = (uae_s32)(uae_s16)mmu030_data_buffer_out;
			} else {
				val = (uae_s32)(uae_s16)get_word_mmu030c (srca);
			}
			m68k_areg (regs, movem_index1[amask]) = val;
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		amask = nextmask;
	}
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}	m68k_incpci (6);
return 8 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MVMEL.W #<data>.W,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_4cb9_34)(uae_u32 opcode)
{
	OpcodeFamily = 37;
	CurrentInstrCycles = 8;  
{	uae_u16 mask = get_iword_mmu030c_state (2);
	uae_u32 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca;
	srca = get_ilong_mmu030c_state (4);
{	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	uae_u32 val;
	srca = state_store_mmu030(srca);
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = (uae_s32)(uae_s16)mmu030_data_buffer_out;
			} else {
				val = (uae_s32)(uae_s16)get_word_mmu030c (srca);
			}
			m68k_dreg (regs, movem_index1[dmask]) = val;
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = (uae_s32)(uae_s16)mmu030_data_buffer_out;
			} else {
				val = (uae_s32)(uae_s16)get_word_mmu030c (srca);
			}
			m68k_areg (regs, movem_index1[amask]) = val;
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		amask = nextmask;
	}
	regs.irc = get_iword_mmu030c_opcode_state (8);
}}}	m68k_incpci (8);
return 8 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* MVMEL.W #<data>.W,(d16,PC) */
uae_u32 REGPARAM2 CPUFUNC(op_4cba_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 2;
	OpcodeFamily = 37;
	CurrentInstrCycles = 8;  
{	uae_u16 mask = get_iword_mmu030c_state (2);
	uae_u32 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca;
	srca = m68k_getpci () + 4;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	uae_u32 val;
	srca = state_store_mmu030(srca);
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = (uae_s32)(uae_s16)mmu030_data_buffer_out;
			} else {
				val = (uae_s32)(uae_s16)get_word_mmu030c (srca);
			}
			m68k_dreg (regs, movem_index1[dmask]) = val;
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = (uae_s32)(uae_s16)mmu030_data_buffer_out;
			} else {
				val = (uae_s32)(uae_s16)get_word_mmu030c (srca);
			}
			m68k_areg (regs, movem_index1[amask]) = val;
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		amask = nextmask;
	}
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}	m68k_incpci (6);
return 8 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MVMEL.W #<data>.W,(d8,PC,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_4cbb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 3;
	OpcodeFamily = 37;
	CurrentInstrCycles = 8;  
{	uae_u16 mask = get_iword_mmu030c_state (2);
	uae_u32 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (4);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	uae_u32 val;
	srca = state_store_mmu030(srca);
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = (uae_s32)(uae_s16)mmu030_data_buffer_out;
			} else {
				val = (uae_s32)(uae_s16)get_word_mmu030c (srca);
			}
			m68k_dreg (regs, movem_index1[dmask]) = val;
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = (uae_s32)(uae_s16)mmu030_data_buffer_out;
			} else {
				val = (uae_s32)(uae_s16)get_word_mmu030c (srca);
			}
			m68k_areg (regs, movem_index1[amask]) = val;
			mmu030_state[0]++;
		}
		srca += 2;
		movem_cnt++;
		amask = nextmask;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}return 8 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* MVMEL.L #<data>.W,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_4cd0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 37;
	CurrentInstrCycles = 12; 
{	uae_u16 mask = get_iword_mmu030c_state (2);
	uae_u32 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca;
	srca = m68k_areg (regs, dstreg);
{	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	uae_u32 val;
	srca = state_store_mmu030(srca);
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = mmu030_data_buffer_out;
			} else {
				val = get_long_mmu030c (srca);
			}
			m68k_dreg (regs, movem_index1[dmask]) = val;
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = mmu030_data_buffer_out;
			} else {
				val = get_long_mmu030c (srca);
			}
			m68k_areg (regs, movem_index1[amask]) = val;
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		amask = nextmask;
	}
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}	m68k_incpci (4);
return 12 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MVMEL.L #<data>.W,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_4cd8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 37;
	CurrentInstrCycles = 12; 
{	uae_u16 mask = get_iword_mmu030c_state (2);
	uae_u32 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca;
	srca = m68k_areg (regs, dstreg);
{	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	uae_u32 val;
	srca = state_store_mmu030(srca);
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = mmu030_data_buffer_out;
			} else {
				val = get_long_mmu030c (srca);
			}
			m68k_dreg (regs, movem_index1[dmask]) = val;
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = mmu030_data_buffer_out;
			} else {
				val = get_long_mmu030c (srca);
			}
			m68k_areg (regs, movem_index1[amask]) = val;
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		amask = nextmask;
	}
	m68k_areg (regs, dstreg) = srca;
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}	m68k_incpci (4);
return 12 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MVMEL.L #<data>.W,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_4ce8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 37;
	CurrentInstrCycles = 12; 
{	uae_u16 mask = get_iword_mmu030c_state (2);
	uae_u32 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca;
	srca = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	uae_u32 val;
	srca = state_store_mmu030(srca);
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = mmu030_data_buffer_out;
			} else {
				val = get_long_mmu030c (srca);
			}
			m68k_dreg (regs, movem_index1[dmask]) = val;
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = mmu030_data_buffer_out;
			} else {
				val = get_long_mmu030c (srca);
			}
			m68k_areg (regs, movem_index1[amask]) = val;
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		amask = nextmask;
	}
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}	m68k_incpci (6);
return 12 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MVMEL.L #<data>.W,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_4cf0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 37;
	CurrentInstrCycles = 12; 
{	uae_u16 mask = get_iword_mmu030c_state (2);
	uae_u32 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca;
	m68k_incpci (4);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	uae_u32 val;
	srca = state_store_mmu030(srca);
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = mmu030_data_buffer_out;
			} else {
				val = get_long_mmu030c (srca);
			}
			m68k_dreg (regs, movem_index1[dmask]) = val;
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = mmu030_data_buffer_out;
			} else {
				val = get_long_mmu030c (srca);
			}
			m68k_areg (regs, movem_index1[amask]) = val;
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		amask = nextmask;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}return 12 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* MVMEL.L #<data>.W,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_4cf8_34)(uae_u32 opcode)
{
	OpcodeFamily = 37;
	CurrentInstrCycles = 12; 
{	uae_u16 mask = get_iword_mmu030c_state (2);
	uae_u32 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	uae_u32 val;
	srca = state_store_mmu030(srca);
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = mmu030_data_buffer_out;
			} else {
				val = get_long_mmu030c (srca);
			}
			m68k_dreg (regs, movem_index1[dmask]) = val;
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = mmu030_data_buffer_out;
			} else {
				val = get_long_mmu030c (srca);
			}
			m68k_areg (regs, movem_index1[amask]) = val;
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		amask = nextmask;
	}
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}	m68k_incpci (6);
return 12 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MVMEL.L #<data>.W,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_4cf9_34)(uae_u32 opcode)
{
	OpcodeFamily = 37;
	CurrentInstrCycles = 12; 
{	uae_u16 mask = get_iword_mmu030c_state (2);
	uae_u32 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca;
	srca = get_ilong_mmu030c_state (4);
{	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	uae_u32 val;
	srca = state_store_mmu030(srca);
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = mmu030_data_buffer_out;
			} else {
				val = get_long_mmu030c (srca);
			}
			m68k_dreg (regs, movem_index1[dmask]) = val;
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = mmu030_data_buffer_out;
			} else {
				val = get_long_mmu030c (srca);
			}
			m68k_areg (regs, movem_index1[amask]) = val;
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		amask = nextmask;
	}
	regs.irc = get_iword_mmu030c_opcode_state (8);
}}}	m68k_incpci (8);
return 12 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

/* MVMEL.L #<data>.W,(d16,PC) */
uae_u32 REGPARAM2 CPUFUNC(op_4cfa_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 2;
	OpcodeFamily = 37;
	CurrentInstrCycles = 12; 
{	uae_u16 mask = get_iword_mmu030c_state (2);
	uae_u32 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca;
	srca = m68k_getpci () + 4;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	uae_u32 val;
	srca = state_store_mmu030(srca);
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = mmu030_data_buffer_out;
			} else {
				val = get_long_mmu030c (srca);
			}
			m68k_dreg (regs, movem_index1[dmask]) = val;
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = mmu030_data_buffer_out;
			} else {
				val = get_long_mmu030c (srca);
			}
			m68k_areg (regs, movem_index1[amask]) = val;
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		amask = nextmask;
	}
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}	m68k_incpci (6);
return 12 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MVMEL.L #<data>.W,(d8,PC,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_4cfb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 3;
	OpcodeFamily = 37;
	CurrentInstrCycles = 12; 
{	uae_u16 mask = get_iword_mmu030c_state (2);
	uae_u32 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (4);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	mmu030_state[1] |= MMU030_STATEFLAG1_MOVEM1;
	int movem_cnt = 0;
	uae_u32 val;
	srca = state_store_mmu030(srca);
	while (dmask) {
		uae_u16 nextmask = movem_next[dmask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = mmu030_data_buffer_out;
			} else {
				val = get_long_mmu030c (srca);
			}
			m68k_dreg (regs, movem_index1[dmask]) = val;
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		dmask = nextmask;
	}
	while (amask) {
		uae_u16 nextmask = movem_next[amask];
		if (mmu030_state[0] == movem_cnt) {
			if (mmu030_state[1] & MMU030_STATEFLAG1_MOVEM2) {
				mmu030_state[1] &= ~MMU030_STATEFLAG1_MOVEM2;
				val = mmu030_data_buffer_out;
			} else {
				val = get_long_mmu030c (srca);
			}
			m68k_areg (regs, movem_index1[amask]) = val;
			mmu030_state[0]++;
		}
		srca += 4;
		movem_cnt++;
		amask = nextmask;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}return 12 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

/* TRAPQ.L #<data> */
uae_u32 REGPARAM2 CPUFUNC(op_4e40_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 15);
	OpcodeFamily = 39;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	Exception_cpu(src + 32);
}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* LINK.W An,#<data>.W */
uae_u32 REGPARAM2 CPUFUNC(op_4e50_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 47;
	CurrentInstrCycles = 4;  
{	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
{	uae_s16 offs = get_iword_mmu030c_state (2);
{	uaecptr olda;
	olda = m68k_areg (regs, 7) - 4;
	mmufixup[1].reg = 7;
	mmufixup[1].value = m68k_areg (regs, 7);
	m68k_areg (regs, 7) = olda;
{	uae_s32 src = m68k_areg (regs, srcreg);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, srcreg) = (m68k_areg(regs, 7));
	m68k_areg(regs, 7) += offs;
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (olda, src);
}}}}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* UNLK.L An */
uae_u32 REGPARAM2 CPUFUNC(op_4e58_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 48;
	CurrentInstrCycles = 5;  
{{	uae_s32 src = m68k_areg (regs, srcreg);
	uae_s32 old = get_long_mmu030c_state (src);
	m68k_areg (regs, 7) = src + 4;
	m68k_areg (regs, srcreg) = old;
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}	m68k_incpci (2);
return 5 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MVR2USP.L An */
uae_u32 REGPARAM2 CPUFUNC(op_4e60_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 40;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340888; }
{{	uae_s32 src = m68k_areg (regs, srcreg);
	regs.usp = src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}	m68k_incpci (2);
l_340888: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MVUSP2R.L An */
uae_u32 REGPARAM2 CPUFUNC(op_4e68_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 41;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_340889; }
{{	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, srcreg) = (regs.usp);
}}}	m68k_incpci (2);
l_340889: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* RESET.L  */
uae_u32 REGPARAM2 CPUFUNC(op_4e70_34)(uae_u32 opcode)
{
	OpcodeFamily = 42;
	CurrentInstrCycles = 6;  
{if (!regs.s) { Exception (8); goto l_340890; }
{	cpureset ();
	m68k_incpci (2);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}l_340890: ;
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* NOP.L  */
uae_u32 REGPARAM2 CPUFUNC(op_4e71_34)(uae_u32 opcode)
{
	OpcodeFamily = 43;
	CurrentInstrCycles = 4;  
{	regs.irc = get_iword_mmu030c_opcode_state (2);
}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* STOP.L #<data>.W */
uae_u32 REGPARAM2 CPUFUNC(op_4e72_34)(uae_u32 opcode)
{
	OpcodeFamily = 44;
	CurrentInstrCycles = 8;  
{if (!regs.s) { Exception (8); goto l_340892; }
{{	uae_s16 src = get_iword_mmu030c_state (2);
	uae_u16 sr = src;
	regs.sr = sr;
	MakeFromSR();
	m68k_setstopped ();
	m68k_incpci (4);
}}}l_340892: ;
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* RTE.L  */
uae_u32 REGPARAM2 CPUFUNC(op_4e73_34)(uae_u32 opcode)
{
	OpcodeFamily = 45;
	CurrentInstrCycles = 34; 
{if (!regs.s) { Exception (8); goto l_340893; }
{	uaecptr oldpc = m68k_getpci ();
	uae_u16 newsr; uae_u32 newpc;
	for (;;) {
		uaecptr a = m68k_areg (regs, 7);
		uae_u16 sr = get_word_mmu030c_state (a);
		uae_u32 pc = get_long_mmu030c_state (a + 2);
		uae_u16 format = get_word_mmu030c_state (a + 2 + 4);
		int frame = format >> 12;
		int offset = 8;
		newsr = sr; newpc = pc;
		if (frame == 0x0) { m68k_areg (regs, 7) += offset; break; }
		else if (frame == 0x1) { m68k_areg (regs, 7) += offset; }
		else if (frame == 0x2) { m68k_areg (regs, 7) += offset + 4; break; }
		else if (frame == 0x9) { m68k_areg (regs, 7) += offset + 12; break; }
		else if (frame == 0xa) { m68k_do_rte_mmu030c (a); break; }
		else if (frame == 0xb) { m68k_do_rte_mmu030c (a); goto l_340893; }
		else { m68k_areg (regs, 7) += offset; Exception_cpu(14); goto l_340893; }
		regs.sr = newsr;
	MakeFromSR_T0();
}
	regs.sr = newsr;
	MakeFromSR_T0();
	if (newpc & 1) {
		exception3i (0x4E73, newpc);
		goto l_340893;
	}
	m68k_setpci(newpc);
	branch_stack_pop_rte(oldpc);
	fill_prefetch_030_ntx();
}}l_340893: ;
return 34 * CYCLE_UNIT / 2;
}
/* 2 0,0 B */

/* RTD.L #<data>.W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4e74_34)(uae_u32 opcode)
{
	OpcodeFamily = 46;
	CurrentInstrCycles = 10; 
{{	uae_s16 offs = get_iword_mmu030c_state (2);
{	uaecptr pca;
	pca = m68k_areg (regs, 7);
{	uae_s32 pc = get_long_mmu030c_state (pca);
	mmufixup[0].reg = 7;
	mmufixup[0].value = m68k_areg (regs, 7);
	m68k_areg (regs, 7) += 4;
	m68k_areg(regs, 7) += offs;
	if (pc & 1) {
		exception3i (0x4E74, pc);
		goto l_340894;
	}
	m68k_setpci(pc);
	fill_prefetch_030();
}}}}l_340894: ;
	mmufixup[0].reg = -1;
return 10 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

#endif
/* RTS.L  */
uae_u32 REGPARAM2 CPUFUNC(op_4e75_34)(uae_u32 opcode)
{
	OpcodeFamily = 49;
	CurrentInstrCycles = 17; 
{	uaecptr pc = m68k_getpci ();
	m68k_do_rts_mmu030c ();
	if (debugmem_trace)
		branch_stack_pop_rts(pc);
	if (m68k_getpci () & 1) {
		uaecptr faultpc = m68k_getpci ();
	m68k_setpci(pc);
		exception3i (0x4E75, faultpc);
		goto l_340895;
	}
	fill_prefetch_030();
}l_340895: ;
return 17 * CYCLE_UNIT / 2;
}
/* 2 0,0 B */

/* TRAPV.L  */
uae_u32 REGPARAM2 CPUFUNC(op_4e76_34)(uae_u32 opcode)
{
	OpcodeFamily = 50;
	CurrentInstrCycles = 4;  
{	m68k_incpci (2);
	if (GET_VFLG ()) {
		Exception_cpu(7);
		goto l_340896;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}l_340896: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* RTR.L  */
uae_u32 REGPARAM2 CPUFUNC(op_4e77_34)(uae_u32 opcode)
{
	OpcodeFamily = 51;
	CurrentInstrCycles = 12; 
{	uaecptr oldpc = m68k_getpci ();
	MakeSR ();
{	uaecptr sra;
	sra = m68k_areg (regs, 7);
{	uae_s16 sr = get_word_mmu030c_state (sra);
	mmufixup[0].reg = 7;
	mmufixup[0].value = m68k_areg (regs, 7);
	m68k_areg (regs, 7) += 2;
{	uaecptr pca;
	pca = m68k_areg (regs, 7);
{	uae_s32 pc = get_long_mmu030c_state (pca);
	mmufixup[1].reg = 7;
	mmufixup[1].value = m68k_areg (regs, 7);
	m68k_areg (regs, 7) += 4;
	regs.sr &= 0xFF00; sr &= 0xFF;
	regs.sr |= sr;
	m68k_setpci(pc);
	MakeFromSR();
	if (m68k_getpci () & 1) {
		uaecptr faultpc = m68k_getpci ();
	m68k_setpci(oldpc);
		exception3i (0x4E77, faultpc);
		goto l_340897;
	}
	fill_prefetch_030();
}}}}}l_340897: ;
	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 12 * CYCLE_UNIT / 2;
}
/* 2 0,0 B */

/* MOVEC2.L #<data>.W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4e7a_34)(uae_u32 opcode)
{
	OpcodeFamily = 82;
	CurrentInstrCycles = 6;  
{if (!regs.s) { Exception (8); goto l_340898; }
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	int regno = (src >> 12) & 15;
	uae_u32 *regp = regs.regs + regno;
	if (! m68k_movec2(src & 0xFFF, regp)) goto l_340898;
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
l_340898: ;
return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* MOVE2C.L #<data>.W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_4e7b_34)(uae_u32 opcode)
{
	OpcodeFamily = 83;
	CurrentInstrCycles = 6;  
{if (!regs.s) { Exception (8); goto l_340899; }
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	int regno = (src >> 12) & 15;
	uae_u32 *regp = regs.regs + regno;
	if (! m68k_move2c(src & 0xFFF, regp)) goto l_340899;
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
l_340899: ;
return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* JSR.L (An) */
uae_u32 REGPARAM2 CPUFUNC(op_4e90_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 52;
	CurrentInstrCycles = 12; 
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uaecptr oldpc = m68k_getpci ();
	uaecptr nextpc = oldpc + 2;
	if (srca & 1) {
		exception3i (opcode, srca);
		goto l_340900;
	}
	put_long_mmu030c_state (m68k_areg (regs, 7) - 4, nextpc);
	m68k_areg (regs, 7) -= 4;
	m68k_setpci(srca);
	fill_prefetch_030();
}}}l_340900: ;
return 12 * CYCLE_UNIT / 2;
}
/* 2 0,0 B */

/* JSR.L (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_4ea8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 52;
	CurrentInstrCycles = 12; 
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uaecptr oldpc = m68k_getpci ();
	uaecptr nextpc = oldpc + 4;
	if (srca & 1) {
		exception3i (opcode, srca);
		goto l_340901;
	}
	put_long_mmu030c_state (m68k_areg (regs, 7) - 4, nextpc);
	m68k_areg (regs, 7) -= 4;
	m68k_setpci(srca);
	fill_prefetch_030();
}}}l_340901: ;
return 12 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* JSR.L (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_4eb0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 52;
	CurrentInstrCycles = 12; 
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uaecptr oldpc = m68k_getpci ();
	uaecptr nextpc = oldpc + 0;
	if (srca & 1) {
		exception3i (opcode, srca);
		goto l_340902;
	}
	put_long_mmu030c_state (m68k_areg (regs, 7) - 4, nextpc);
	m68k_areg (regs, 7) -= 4;
	m68k_setpci(srca);
	fill_prefetch_030();
}}}}l_340902: ;
return 12 * CYCLE_UNIT / 2;
}
/* 2 2,0 B */

/* JSR.L (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_4eb8_34)(uae_u32 opcode)
{
	OpcodeFamily = 52;
	CurrentInstrCycles = 12; 
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uaecptr oldpc = m68k_getpci ();
	uaecptr nextpc = oldpc + 4;
	if (srca & 1) {
		exception3i (opcode, srca);
		goto l_340903;
	}
	put_long_mmu030c_state (m68k_areg (regs, 7) - 4, nextpc);
	m68k_areg (regs, 7) -= 4;
	m68k_setpci(srca);
	fill_prefetch_030();
}}}l_340903: ;
return 12 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* JSR.L (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_4eb9_34)(uae_u32 opcode)
{
	OpcodeFamily = 52;
	CurrentInstrCycles = 12; 
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uaecptr oldpc = m68k_getpci ();
	uaecptr nextpc = oldpc + 6;
	if (srca & 1) {
		exception3i (opcode, srca);
		goto l_340904;
	}
	put_long_mmu030c_state (m68k_areg (regs, 7) - 4, nextpc);
	m68k_areg (regs, 7) -= 4;
	m68k_setpci(srca);
	fill_prefetch_030();
}}}l_340904: ;
return 12 * CYCLE_UNIT / 2;
}
/* 6 0,0 B */

/* JSR.L (d16,PC) */
uae_u32 REGPARAM2 CPUFUNC(op_4eba_34)(uae_u32 opcode)
{
	OpcodeFamily = 52;
	CurrentInstrCycles = 12; 
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uaecptr oldpc = m68k_getpci ();
	uaecptr nextpc = oldpc + 4;
	if (srca & 1) {
		exception3i (opcode, srca);
		goto l_340905;
	}
	put_long_mmu030c_state (m68k_areg (regs, 7) - 4, nextpc);
	m68k_areg (regs, 7) -= 4;
	m68k_setpci(srca);
	fill_prefetch_030();
}}}l_340905: ;
return 12 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* JSR.L (d8,PC,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_4ebb_34)(uae_u32 opcode)
{
	OpcodeFamily = 52;
	CurrentInstrCycles = 12; 
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uaecptr oldpc = m68k_getpci ();
	uaecptr nextpc = oldpc + 0;
	if (srca & 1) {
		exception3i (opcode, srca);
		goto l_340906;
	}
	put_long_mmu030c_state (m68k_areg (regs, 7) - 4, nextpc);
	m68k_areg (regs, 7) -= 4;
	m68k_setpci(srca);
	fill_prefetch_030();
}}}}l_340906: ;
return 12 * CYCLE_UNIT / 2;
}
/* 2 2,0 B */

/* JMP.L (An) */
uae_u32 REGPARAM2 CPUFUNC(op_4ed0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 53;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	if (srca & 1) {
		exception3i (opcode, srca);
		goto l_340907;
	}
	m68k_setpci(srca);
	fill_prefetch_030();
}}l_340907: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0 B */

/* JMP.L (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_4ee8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 53;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	if (srca & 1) {
		exception3i (opcode, srca);
		goto l_340908;
	}
	m68k_setpci(srca);
	fill_prefetch_030();
}}l_340908: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* JMP.L (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_4ef0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 53;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
	if (srca & 1) {
		exception3i (opcode, srca);
		goto l_340909;
	}
	m68k_setpci(srca);
	fill_prefetch_030();
}}}l_340909: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0 B */

/* JMP.L (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_4ef8_34)(uae_u32 opcode)
{
	OpcodeFamily = 53;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	if (srca & 1) {
		exception3i (opcode, srca);
		goto l_340910;
	}
	m68k_setpci(srca);
	fill_prefetch_030();
}}l_340910: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* JMP.L (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_4ef9_34)(uae_u32 opcode)
{
	OpcodeFamily = 53;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
	if (srca & 1) {
		exception3i (opcode, srca);
		goto l_340911;
	}
	m68k_setpci(srca);
	fill_prefetch_030();
}}l_340911: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0 B */

/* JMP.L (d16,PC) */
uae_u32 REGPARAM2 CPUFUNC(op_4efa_34)(uae_u32 opcode)
{
	OpcodeFamily = 53;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
	if (srca & 1) {
		exception3i (opcode, srca);
		goto l_340912;
	}
	m68k_setpci(srca);
	fill_prefetch_030();
}}l_340912: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* JMP.L (d8,PC,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_4efb_34)(uae_u32 opcode)
{
	OpcodeFamily = 53;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
	if (srca & 1) {
		exception3i (opcode, srca);
		goto l_340913;
	}
	m68k_setpci(srca);
	fill_prefetch_030();
}}}l_340913: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0 B */

/* ADDQ.B #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_5000_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDQ.B #<data>,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_5010_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDQ.B #<data>,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_5018_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDQ.B #<data>,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_5020_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDQ.B #<data>,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_5028_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADDQ.B #<data>,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_5030_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* ADDQ.B #<data>,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_5038_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADDQ.B #<data>,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_5039_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ADDQ.W #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_5040_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDAQ.W #<data>,An */
uae_u32 REGPARAM2 CPUFUNC(op_5048_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDQ.W #<data>,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_5050_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDQ.W #<data>,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_5058_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDQ.W #<data>,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_5060_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDQ.W #<data>,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_5068_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADDQ.W #<data>,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_5070_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* ADDQ.W #<data>,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_5078_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADDQ.W #<data>,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_5079_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ADDQ.L #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_5080_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDAQ.L #<data>,An */
uae_u32 REGPARAM2 CPUFUNC(op_5088_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDQ.L #<data>,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_5090_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDQ.L #<data>,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_5098_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDQ.L #<data>,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_50a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif

#ifdef PART_5
/* ADDQ.L #<data>,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_50a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADDQ.L #<data>,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_50b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* ADDQ.L #<data>,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_50b8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADDQ.L #<data>,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_50b9_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* Scc.B Dn (T) */
uae_u32 REGPARAM2 CPUFUNC(op_50c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{{{	int val = cctrue (0) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DBcc.W Dn,#<data>.W (T) */
uae_u32 REGPARAM2 CPUFUNC(op_50c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 58;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 offs = get_iword_mmu030c_state (2);
	uaecptr oldpc = m68k_getpci ();
	if (!cctrue (0)) {
	m68k_incpci ((uae_s32)offs + 2);
			m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | (((src - 1)) & 0xffff);
		if (src) {
			if (offs & 1) {
				exception3i (opcode, m68k_getpci () + 2 + (uae_s32)offs + 2);
				goto l_340941;
			}
	fill_prefetch_030();
			return 10 * CYCLE_UNIT / 2;
		}
	} else {
	}
	m68k_setpci(oldpc + 4);
	continue_030_prefetch();
}}}l_340941: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* Scc.B (An) (T) */
uae_u32 REGPARAM2 CPUFUNC(op_50d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{{	int val = cctrue (0) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (An)+ (T) */
uae_u32 REGPARAM2 CPUFUNC(op_50d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{{	int val = cctrue (0) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B -(An) (T) */
uae_u32 REGPARAM2 CPUFUNC(op_50e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{{	int val = cctrue (0) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (d16,An) (T) */
uae_u32 REGPARAM2 CPUFUNC(op_50e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (0) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (d8,An,Xn) (T) */
uae_u32 REGPARAM2 CPUFUNC(op_50f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{{	int val = cctrue (0) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* Scc.B (xxx).W (T) */
uae_u32 REGPARAM2 CPUFUNC(op_50f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (0) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (xxx).L (T) */
uae_u32 REGPARAM2 CPUFUNC(op_50f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{{	int val = cctrue (0) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* TRAPcc.L #<data>.W (T) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_50fa_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s16 dummy = get_iword_mmu030c_state (2);
	if (cctrue (0)) { Exception_cpu(7); goto l_340949; }
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}	m68k_incpci (4);
l_340949: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* TRAPcc.L #<data>.L (T) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_50fb_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s32 dummy;
	dummy = get_ilong_mmu030c_state (2);
	if (cctrue (0)) { Exception_cpu(7); goto l_340950; }
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}	m68k_incpci (6);
l_340950: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* TRAPcc.L  (T) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_50fc_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{	if (cctrue (0)) { Exception_cpu(7); goto l_340951; }
	regs.irc = get_iword_mmu030c_opcode_state (2);
}	m68k_incpci (2);
l_340951: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* SUBQ.B #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_5100_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBQ.B #<data>,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_5110_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBQ.B #<data>,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_5118_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBQ.B #<data>,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_5120_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBQ.B #<data>,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_5128_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUBQ.B #<data>,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_5130_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* SUBQ.B #<data>,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_5138_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUBQ.B #<data>,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_5139_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* SUBQ.W #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_5140_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBAQ.W #<data>,An */
uae_u32 REGPARAM2 CPUFUNC(op_5148_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBQ.W #<data>,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_5150_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBQ.W #<data>,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_5158_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBQ.W #<data>,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_5160_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBQ.W #<data>,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_5168_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUBQ.W #<data>,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_5170_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* SUBQ.W #<data>,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_5178_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUBQ.W #<data>,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_5179_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* SUBQ.L #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_5180_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBAQ.L #<data>,An */
uae_u32 REGPARAM2 CPUFUNC(op_5188_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBQ.L #<data>,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_5190_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBQ.L #<data>,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_5198_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBQ.L #<data>,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_51a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBQ.L #<data>,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_51a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUBQ.L #<data>,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_51b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* SUBQ.L #<data>,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_51b8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUBQ.L #<data>,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_51b9_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* Scc.B Dn (F) */
uae_u32 REGPARAM2 CPUFUNC(op_51c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{{{	int val = cctrue (1) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DBcc.W Dn,#<data>.W (F) */
uae_u32 REGPARAM2 CPUFUNC(op_51c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 58;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 offs = get_iword_mmu030c_state (2);
	uaecptr oldpc = m68k_getpci ();
	if (!cctrue (1)) {
	m68k_incpci ((uae_s32)offs + 2);
			m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | (((src - 1)) & 0xffff);
		if (src) {
			if (offs & 1) {
				exception3i (opcode, m68k_getpci () + 2 + (uae_s32)offs + 2);
				goto l_340979;
			}
	fill_prefetch_030();
			return 10 * CYCLE_UNIT / 2;
		}
	} else {
	}
	m68k_setpci(oldpc + 4);
	continue_030_prefetch();
}}}l_340979: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* Scc.B (An) (F) */
uae_u32 REGPARAM2 CPUFUNC(op_51d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{{	int val = cctrue (1) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (An)+ (F) */
uae_u32 REGPARAM2 CPUFUNC(op_51d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{{	int val = cctrue (1) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B -(An) (F) */
uae_u32 REGPARAM2 CPUFUNC(op_51e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{{	int val = cctrue (1) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (d16,An) (F) */
uae_u32 REGPARAM2 CPUFUNC(op_51e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (1) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (d8,An,Xn) (F) */
uae_u32 REGPARAM2 CPUFUNC(op_51f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{{	int val = cctrue (1) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* Scc.B (xxx).W (F) */
uae_u32 REGPARAM2 CPUFUNC(op_51f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (1) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (xxx).L (F) */
uae_u32 REGPARAM2 CPUFUNC(op_51f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{{	int val = cctrue (1) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* TRAPcc.L #<data>.W (F) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_51fa_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s16 dummy = get_iword_mmu030c_state (2);
	if (cctrue (1)) { Exception_cpu(7); goto l_340987; }
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}	m68k_incpci (4);
l_340987: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* TRAPcc.L #<data>.L (F) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_51fb_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s32 dummy;
	dummy = get_ilong_mmu030c_state (2);
	if (cctrue (1)) { Exception_cpu(7); goto l_340988; }
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}	m68k_incpci (6);
l_340988: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* TRAPcc.L  (F) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_51fc_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{	if (cctrue (1)) { Exception_cpu(7); goto l_340989; }
	regs.irc = get_iword_mmu030c_opcode_state (2);
}	m68k_incpci (2);
l_340989: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* Scc.B Dn (HI) */
uae_u32 REGPARAM2 CPUFUNC(op_52c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{{{	int val = cctrue (2) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DBcc.W Dn,#<data>.W (HI) */
uae_u32 REGPARAM2 CPUFUNC(op_52c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 58;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 offs = get_iword_mmu030c_state (2);
	uaecptr oldpc = m68k_getpci ();
	if (!cctrue (2)) {
	m68k_incpci ((uae_s32)offs + 2);
			m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | (((src - 1)) & 0xffff);
		if (src) {
			if (offs & 1) {
				exception3i (opcode, m68k_getpci () + 2 + (uae_s32)offs + 2);
				goto l_340991;
			}
	fill_prefetch_030();
			return 10 * CYCLE_UNIT / 2;
		}
	} else {
	}
	m68k_setpci(oldpc + 4);
	continue_030_prefetch();
}}}l_340991: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* Scc.B (An) (HI) */
uae_u32 REGPARAM2 CPUFUNC(op_52d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{{	int val = cctrue (2) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (An)+ (HI) */
uae_u32 REGPARAM2 CPUFUNC(op_52d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{{	int val = cctrue (2) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B -(An) (HI) */
uae_u32 REGPARAM2 CPUFUNC(op_52e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{{	int val = cctrue (2) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (d16,An) (HI) */
uae_u32 REGPARAM2 CPUFUNC(op_52e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (2) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (d8,An,Xn) (HI) */
uae_u32 REGPARAM2 CPUFUNC(op_52f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{{	int val = cctrue (2) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* Scc.B (xxx).W (HI) */
uae_u32 REGPARAM2 CPUFUNC(op_52f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (2) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (xxx).L (HI) */
uae_u32 REGPARAM2 CPUFUNC(op_52f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{{	int val = cctrue (2) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* TRAPcc.L #<data>.W (HI) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_52fa_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s16 dummy = get_iword_mmu030c_state (2);
	if (cctrue (2)) { Exception_cpu(7); goto l_340999; }
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}	m68k_incpci (4);
l_340999: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* TRAPcc.L #<data>.L (HI) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_52fb_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s32 dummy;
	dummy = get_ilong_mmu030c_state (2);
	if (cctrue (2)) { Exception_cpu(7); goto l_341000; }
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}	m68k_incpci (6);
l_341000: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* TRAPcc.L  (HI) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_52fc_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{	if (cctrue (2)) { Exception_cpu(7); goto l_341001; }
	regs.irc = get_iword_mmu030c_opcode_state (2);
}	m68k_incpci (2);
l_341001: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* Scc.B Dn (LS) */
uae_u32 REGPARAM2 CPUFUNC(op_53c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{{{	int val = cctrue (3) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DBcc.W Dn,#<data>.W (LS) */
uae_u32 REGPARAM2 CPUFUNC(op_53c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 58;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 offs = get_iword_mmu030c_state (2);
	uaecptr oldpc = m68k_getpci ();
	if (!cctrue (3)) {
	m68k_incpci ((uae_s32)offs + 2);
			m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | (((src - 1)) & 0xffff);
		if (src) {
			if (offs & 1) {
				exception3i (opcode, m68k_getpci () + 2 + (uae_s32)offs + 2);
				goto l_341003;
			}
	fill_prefetch_030();
			return 10 * CYCLE_UNIT / 2;
		}
	} else {
	}
	m68k_setpci(oldpc + 4);
	continue_030_prefetch();
}}}l_341003: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* Scc.B (An) (LS) */
uae_u32 REGPARAM2 CPUFUNC(op_53d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{{	int val = cctrue (3) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (An)+ (LS) */
uae_u32 REGPARAM2 CPUFUNC(op_53d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{{	int val = cctrue (3) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B -(An) (LS) */
uae_u32 REGPARAM2 CPUFUNC(op_53e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{{	int val = cctrue (3) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (d16,An) (LS) */
uae_u32 REGPARAM2 CPUFUNC(op_53e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (3) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (d8,An,Xn) (LS) */
uae_u32 REGPARAM2 CPUFUNC(op_53f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{{	int val = cctrue (3) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* Scc.B (xxx).W (LS) */
uae_u32 REGPARAM2 CPUFUNC(op_53f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (3) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (xxx).L (LS) */
uae_u32 REGPARAM2 CPUFUNC(op_53f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{{	int val = cctrue (3) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* TRAPcc.L #<data>.W (LS) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_53fa_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s16 dummy = get_iword_mmu030c_state (2);
	if (cctrue (3)) { Exception_cpu(7); goto l_341011; }
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}	m68k_incpci (4);
l_341011: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* TRAPcc.L #<data>.L (LS) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_53fb_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s32 dummy;
	dummy = get_ilong_mmu030c_state (2);
	if (cctrue (3)) { Exception_cpu(7); goto l_341012; }
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}	m68k_incpci (6);
l_341012: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* TRAPcc.L  (LS) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_53fc_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{	if (cctrue (3)) { Exception_cpu(7); goto l_341013; }
	regs.irc = get_iword_mmu030c_opcode_state (2);
}	m68k_incpci (2);
l_341013: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* Scc.B Dn (CC) */
uae_u32 REGPARAM2 CPUFUNC(op_54c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{{{	int val = cctrue (4) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DBcc.W Dn,#<data>.W (CC) */
uae_u32 REGPARAM2 CPUFUNC(op_54c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 58;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 offs = get_iword_mmu030c_state (2);
	uaecptr oldpc = m68k_getpci ();
	if (!cctrue (4)) {
	m68k_incpci ((uae_s32)offs + 2);
			m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | (((src - 1)) & 0xffff);
		if (src) {
			if (offs & 1) {
				exception3i (opcode, m68k_getpci () + 2 + (uae_s32)offs + 2);
				goto l_341015;
			}
	fill_prefetch_030();
			return 10 * CYCLE_UNIT / 2;
		}
	} else {
	}
	m68k_setpci(oldpc + 4);
	continue_030_prefetch();
}}}l_341015: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* Scc.B (An) (CC) */
uae_u32 REGPARAM2 CPUFUNC(op_54d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{{	int val = cctrue (4) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (An)+ (CC) */
uae_u32 REGPARAM2 CPUFUNC(op_54d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{{	int val = cctrue (4) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B -(An) (CC) */
uae_u32 REGPARAM2 CPUFUNC(op_54e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{{	int val = cctrue (4) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (d16,An) (CC) */
uae_u32 REGPARAM2 CPUFUNC(op_54e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (4) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (d8,An,Xn) (CC) */
uae_u32 REGPARAM2 CPUFUNC(op_54f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{{	int val = cctrue (4) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* Scc.B (xxx).W (CC) */
uae_u32 REGPARAM2 CPUFUNC(op_54f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (4) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (xxx).L (CC) */
uae_u32 REGPARAM2 CPUFUNC(op_54f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{{	int val = cctrue (4) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* TRAPcc.L #<data>.W (CC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_54fa_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s16 dummy = get_iword_mmu030c_state (2);
	if (cctrue (4)) { Exception_cpu(7); goto l_341023; }
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}	m68k_incpci (4);
l_341023: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* TRAPcc.L #<data>.L (CC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_54fb_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s32 dummy;
	dummy = get_ilong_mmu030c_state (2);
	if (cctrue (4)) { Exception_cpu(7); goto l_341024; }
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}	m68k_incpci (6);
l_341024: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* TRAPcc.L  (CC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_54fc_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{	if (cctrue (4)) { Exception_cpu(7); goto l_341025; }
	regs.irc = get_iword_mmu030c_opcode_state (2);
}	m68k_incpci (2);
l_341025: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* Scc.B Dn (CS) */
uae_u32 REGPARAM2 CPUFUNC(op_55c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{{{	int val = cctrue (5) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DBcc.W Dn,#<data>.W (CS) */
uae_u32 REGPARAM2 CPUFUNC(op_55c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 58;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 offs = get_iword_mmu030c_state (2);
	uaecptr oldpc = m68k_getpci ();
	if (!cctrue (5)) {
	m68k_incpci ((uae_s32)offs + 2);
			m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | (((src - 1)) & 0xffff);
		if (src) {
			if (offs & 1) {
				exception3i (opcode, m68k_getpci () + 2 + (uae_s32)offs + 2);
				goto l_341027;
			}
	fill_prefetch_030();
			return 10 * CYCLE_UNIT / 2;
		}
	} else {
	}
	m68k_setpci(oldpc + 4);
	continue_030_prefetch();
}}}l_341027: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* Scc.B (An) (CS) */
uae_u32 REGPARAM2 CPUFUNC(op_55d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{{	int val = cctrue (5) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (An)+ (CS) */
uae_u32 REGPARAM2 CPUFUNC(op_55d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{{	int val = cctrue (5) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B -(An) (CS) */
uae_u32 REGPARAM2 CPUFUNC(op_55e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{{	int val = cctrue (5) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (d16,An) (CS) */
uae_u32 REGPARAM2 CPUFUNC(op_55e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (5) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (d8,An,Xn) (CS) */
uae_u32 REGPARAM2 CPUFUNC(op_55f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{{	int val = cctrue (5) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* Scc.B (xxx).W (CS) */
uae_u32 REGPARAM2 CPUFUNC(op_55f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (5) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (xxx).L (CS) */
uae_u32 REGPARAM2 CPUFUNC(op_55f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{{	int val = cctrue (5) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* TRAPcc.L #<data>.W (CS) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_55fa_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s16 dummy = get_iword_mmu030c_state (2);
	if (cctrue (5)) { Exception_cpu(7); goto l_341035; }
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}	m68k_incpci (4);
l_341035: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* TRAPcc.L #<data>.L (CS) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_55fb_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s32 dummy;
	dummy = get_ilong_mmu030c_state (2);
	if (cctrue (5)) { Exception_cpu(7); goto l_341036; }
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}	m68k_incpci (6);
l_341036: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* TRAPcc.L  (CS) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_55fc_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{	if (cctrue (5)) { Exception_cpu(7); goto l_341037; }
	regs.irc = get_iword_mmu030c_opcode_state (2);
}	m68k_incpci (2);
l_341037: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* Scc.B Dn (NE) */
uae_u32 REGPARAM2 CPUFUNC(op_56c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{{{	int val = cctrue (6) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DBcc.W Dn,#<data>.W (NE) */
uae_u32 REGPARAM2 CPUFUNC(op_56c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 58;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 offs = get_iword_mmu030c_state (2);
	uaecptr oldpc = m68k_getpci ();
	if (!cctrue (6)) {
	m68k_incpci ((uae_s32)offs + 2);
			m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | (((src - 1)) & 0xffff);
		if (src) {
			if (offs & 1) {
				exception3i (opcode, m68k_getpci () + 2 + (uae_s32)offs + 2);
				goto l_341039;
			}
	fill_prefetch_030();
			return 10 * CYCLE_UNIT / 2;
		}
	} else {
	}
	m68k_setpci(oldpc + 4);
	continue_030_prefetch();
}}}l_341039: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* Scc.B (An) (NE) */
uae_u32 REGPARAM2 CPUFUNC(op_56d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{{	int val = cctrue (6) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (An)+ (NE) */
uae_u32 REGPARAM2 CPUFUNC(op_56d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{{	int val = cctrue (6) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B -(An) (NE) */
uae_u32 REGPARAM2 CPUFUNC(op_56e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{{	int val = cctrue (6) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (d16,An) (NE) */
uae_u32 REGPARAM2 CPUFUNC(op_56e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (6) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (d8,An,Xn) (NE) */
uae_u32 REGPARAM2 CPUFUNC(op_56f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{{	int val = cctrue (6) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* Scc.B (xxx).W (NE) */
uae_u32 REGPARAM2 CPUFUNC(op_56f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (6) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (xxx).L (NE) */
uae_u32 REGPARAM2 CPUFUNC(op_56f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{{	int val = cctrue (6) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* TRAPcc.L #<data>.W (NE) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_56fa_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s16 dummy = get_iword_mmu030c_state (2);
	if (cctrue (6)) { Exception_cpu(7); goto l_341047; }
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}	m68k_incpci (4);
l_341047: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* TRAPcc.L #<data>.L (NE) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_56fb_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s32 dummy;
	dummy = get_ilong_mmu030c_state (2);
	if (cctrue (6)) { Exception_cpu(7); goto l_341048; }
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}	m68k_incpci (6);
l_341048: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* TRAPcc.L  (NE) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_56fc_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{	if (cctrue (6)) { Exception_cpu(7); goto l_341049; }
	regs.irc = get_iword_mmu030c_opcode_state (2);
}	m68k_incpci (2);
l_341049: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* Scc.B Dn (EQ) */
uae_u32 REGPARAM2 CPUFUNC(op_57c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{{{	int val = cctrue (7) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DBcc.W Dn,#<data>.W (EQ) */
uae_u32 REGPARAM2 CPUFUNC(op_57c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 58;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 offs = get_iword_mmu030c_state (2);
	uaecptr oldpc = m68k_getpci ();
	if (!cctrue (7)) {
	m68k_incpci ((uae_s32)offs + 2);
			m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | (((src - 1)) & 0xffff);
		if (src) {
			if (offs & 1) {
				exception3i (opcode, m68k_getpci () + 2 + (uae_s32)offs + 2);
				goto l_341051;
			}
	fill_prefetch_030();
			return 10 * CYCLE_UNIT / 2;
		}
	} else {
	}
	m68k_setpci(oldpc + 4);
	continue_030_prefetch();
}}}l_341051: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* Scc.B (An) (EQ) */
uae_u32 REGPARAM2 CPUFUNC(op_57d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{{	int val = cctrue (7) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (An)+ (EQ) */
uae_u32 REGPARAM2 CPUFUNC(op_57d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{{	int val = cctrue (7) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B -(An) (EQ) */
uae_u32 REGPARAM2 CPUFUNC(op_57e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{{	int val = cctrue (7) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (d16,An) (EQ) */
uae_u32 REGPARAM2 CPUFUNC(op_57e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (7) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (d8,An,Xn) (EQ) */
uae_u32 REGPARAM2 CPUFUNC(op_57f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{{	int val = cctrue (7) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* Scc.B (xxx).W (EQ) */
uae_u32 REGPARAM2 CPUFUNC(op_57f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (7) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (xxx).L (EQ) */
uae_u32 REGPARAM2 CPUFUNC(op_57f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{{	int val = cctrue (7) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* TRAPcc.L #<data>.W (EQ) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_57fa_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s16 dummy = get_iword_mmu030c_state (2);
	if (cctrue (7)) { Exception_cpu(7); goto l_341059; }
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}	m68k_incpci (4);
l_341059: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* TRAPcc.L #<data>.L (EQ) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_57fb_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s32 dummy;
	dummy = get_ilong_mmu030c_state (2);
	if (cctrue (7)) { Exception_cpu(7); goto l_341060; }
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}	m68k_incpci (6);
l_341060: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* TRAPcc.L  (EQ) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_57fc_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{	if (cctrue (7)) { Exception_cpu(7); goto l_341061; }
	regs.irc = get_iword_mmu030c_opcode_state (2);
}	m68k_incpci (2);
l_341061: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* Scc.B Dn (VC) */
uae_u32 REGPARAM2 CPUFUNC(op_58c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{{{	int val = cctrue (8) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DBcc.W Dn,#<data>.W (VC) */
uae_u32 REGPARAM2 CPUFUNC(op_58c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 58;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 offs = get_iword_mmu030c_state (2);
	uaecptr oldpc = m68k_getpci ();
	if (!cctrue (8)) {
	m68k_incpci ((uae_s32)offs + 2);
			m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | (((src - 1)) & 0xffff);
		if (src) {
			if (offs & 1) {
				exception3i (opcode, m68k_getpci () + 2 + (uae_s32)offs + 2);
				goto l_341063;
			}
	fill_prefetch_030();
			return 10 * CYCLE_UNIT / 2;
		}
	} else {
	}
	m68k_setpci(oldpc + 4);
	continue_030_prefetch();
}}}l_341063: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* Scc.B (An) (VC) */
uae_u32 REGPARAM2 CPUFUNC(op_58d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{{	int val = cctrue (8) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (An)+ (VC) */
uae_u32 REGPARAM2 CPUFUNC(op_58d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{{	int val = cctrue (8) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B -(An) (VC) */
uae_u32 REGPARAM2 CPUFUNC(op_58e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{{	int val = cctrue (8) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (d16,An) (VC) */
uae_u32 REGPARAM2 CPUFUNC(op_58e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (8) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (d8,An,Xn) (VC) */
uae_u32 REGPARAM2 CPUFUNC(op_58f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{{	int val = cctrue (8) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* Scc.B (xxx).W (VC) */
uae_u32 REGPARAM2 CPUFUNC(op_58f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (8) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (xxx).L (VC) */
uae_u32 REGPARAM2 CPUFUNC(op_58f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{{	int val = cctrue (8) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* TRAPcc.L #<data>.W (VC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_58fa_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s16 dummy = get_iword_mmu030c_state (2);
	if (cctrue (8)) { Exception_cpu(7); goto l_341071; }
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}	m68k_incpci (4);
l_341071: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* TRAPcc.L #<data>.L (VC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_58fb_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s32 dummy;
	dummy = get_ilong_mmu030c_state (2);
	if (cctrue (8)) { Exception_cpu(7); goto l_341072; }
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}	m68k_incpci (6);
l_341072: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* TRAPcc.L  (VC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_58fc_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{	if (cctrue (8)) { Exception_cpu(7); goto l_341073; }
	regs.irc = get_iword_mmu030c_opcode_state (2);
}	m68k_incpci (2);
l_341073: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* Scc.B Dn (VS) */
uae_u32 REGPARAM2 CPUFUNC(op_59c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{{{	int val = cctrue (9) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DBcc.W Dn,#<data>.W (VS) */
uae_u32 REGPARAM2 CPUFUNC(op_59c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 58;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 offs = get_iword_mmu030c_state (2);
	uaecptr oldpc = m68k_getpci ();
	if (!cctrue (9)) {
	m68k_incpci ((uae_s32)offs + 2);
			m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | (((src - 1)) & 0xffff);
		if (src) {
			if (offs & 1) {
				exception3i (opcode, m68k_getpci () + 2 + (uae_s32)offs + 2);
				goto l_341075;
			}
	fill_prefetch_030();
			return 10 * CYCLE_UNIT / 2;
		}
	} else {
	}
	m68k_setpci(oldpc + 4);
	continue_030_prefetch();
}}}l_341075: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* Scc.B (An) (VS) */
uae_u32 REGPARAM2 CPUFUNC(op_59d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{{	int val = cctrue (9) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (An)+ (VS) */
uae_u32 REGPARAM2 CPUFUNC(op_59d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{{	int val = cctrue (9) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B -(An) (VS) */
uae_u32 REGPARAM2 CPUFUNC(op_59e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{{	int val = cctrue (9) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (d16,An) (VS) */
uae_u32 REGPARAM2 CPUFUNC(op_59e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (9) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (d8,An,Xn) (VS) */
uae_u32 REGPARAM2 CPUFUNC(op_59f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{{	int val = cctrue (9) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* Scc.B (xxx).W (VS) */
uae_u32 REGPARAM2 CPUFUNC(op_59f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (9) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (xxx).L (VS) */
uae_u32 REGPARAM2 CPUFUNC(op_59f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{{	int val = cctrue (9) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* TRAPcc.L #<data>.W (VS) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_59fa_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s16 dummy = get_iword_mmu030c_state (2);
	if (cctrue (9)) { Exception_cpu(7); goto l_341083; }
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}	m68k_incpci (4);
l_341083: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* TRAPcc.L #<data>.L (VS) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_59fb_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s32 dummy;
	dummy = get_ilong_mmu030c_state (2);
	if (cctrue (9)) { Exception_cpu(7); goto l_341084; }
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}	m68k_incpci (6);
l_341084: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* TRAPcc.L  (VS) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_59fc_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{	if (cctrue (9)) { Exception_cpu(7); goto l_341085; }
	regs.irc = get_iword_mmu030c_opcode_state (2);
}	m68k_incpci (2);
l_341085: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* Scc.B Dn (PL) */
uae_u32 REGPARAM2 CPUFUNC(op_5ac0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{{{	int val = cctrue (10) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DBcc.W Dn,#<data>.W (PL) */
uae_u32 REGPARAM2 CPUFUNC(op_5ac8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 58;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 offs = get_iword_mmu030c_state (2);
	uaecptr oldpc = m68k_getpci ();
	if (!cctrue (10)) {
	m68k_incpci ((uae_s32)offs + 2);
			m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | (((src - 1)) & 0xffff);
		if (src) {
			if (offs & 1) {
				exception3i (opcode, m68k_getpci () + 2 + (uae_s32)offs + 2);
				goto l_341087;
			}
	fill_prefetch_030();
			return 10 * CYCLE_UNIT / 2;
		}
	} else {
	}
	m68k_setpci(oldpc + 4);
	continue_030_prefetch();
}}}l_341087: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* Scc.B (An) (PL) */
uae_u32 REGPARAM2 CPUFUNC(op_5ad0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{{	int val = cctrue (10) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (An)+ (PL) */
uae_u32 REGPARAM2 CPUFUNC(op_5ad8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{{	int val = cctrue (10) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B -(An) (PL) */
uae_u32 REGPARAM2 CPUFUNC(op_5ae0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{{	int val = cctrue (10) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (d16,An) (PL) */
uae_u32 REGPARAM2 CPUFUNC(op_5ae8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (10) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (d8,An,Xn) (PL) */
uae_u32 REGPARAM2 CPUFUNC(op_5af0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{{	int val = cctrue (10) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* Scc.B (xxx).W (PL) */
uae_u32 REGPARAM2 CPUFUNC(op_5af8_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (10) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (xxx).L (PL) */
uae_u32 REGPARAM2 CPUFUNC(op_5af9_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{{	int val = cctrue (10) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* TRAPcc.L #<data>.W (PL) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_5afa_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s16 dummy = get_iword_mmu030c_state (2);
	if (cctrue (10)) { Exception_cpu(7); goto l_341095; }
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}	m68k_incpci (4);
l_341095: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* TRAPcc.L #<data>.L (PL) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_5afb_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s32 dummy;
	dummy = get_ilong_mmu030c_state (2);
	if (cctrue (10)) { Exception_cpu(7); goto l_341096; }
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}	m68k_incpci (6);
l_341096: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* TRAPcc.L  (PL) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_5afc_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{	if (cctrue (10)) { Exception_cpu(7); goto l_341097; }
	regs.irc = get_iword_mmu030c_opcode_state (2);
}	m68k_incpci (2);
l_341097: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* Scc.B Dn (MI) */
uae_u32 REGPARAM2 CPUFUNC(op_5bc0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{{{	int val = cctrue (11) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DBcc.W Dn,#<data>.W (MI) */
uae_u32 REGPARAM2 CPUFUNC(op_5bc8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 58;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 offs = get_iword_mmu030c_state (2);
	uaecptr oldpc = m68k_getpci ();
	if (!cctrue (11)) {
	m68k_incpci ((uae_s32)offs + 2);
			m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | (((src - 1)) & 0xffff);
		if (src) {
			if (offs & 1) {
				exception3i (opcode, m68k_getpci () + 2 + (uae_s32)offs + 2);
				goto l_341099;
			}
	fill_prefetch_030();
			return 10 * CYCLE_UNIT / 2;
		}
	} else {
	}
	m68k_setpci(oldpc + 4);
	continue_030_prefetch();
}}}l_341099: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* Scc.B (An) (MI) */
uae_u32 REGPARAM2 CPUFUNC(op_5bd0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{{	int val = cctrue (11) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (An)+ (MI) */
uae_u32 REGPARAM2 CPUFUNC(op_5bd8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{{	int val = cctrue (11) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B -(An) (MI) */
uae_u32 REGPARAM2 CPUFUNC(op_5be0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{{	int val = cctrue (11) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (d16,An) (MI) */
uae_u32 REGPARAM2 CPUFUNC(op_5be8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (11) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (d8,An,Xn) (MI) */
uae_u32 REGPARAM2 CPUFUNC(op_5bf0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{{	int val = cctrue (11) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* Scc.B (xxx).W (MI) */
uae_u32 REGPARAM2 CPUFUNC(op_5bf8_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (11) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (xxx).L (MI) */
uae_u32 REGPARAM2 CPUFUNC(op_5bf9_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{{	int val = cctrue (11) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* TRAPcc.L #<data>.W (MI) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_5bfa_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s16 dummy = get_iword_mmu030c_state (2);
	if (cctrue (11)) { Exception_cpu(7); goto l_341107; }
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}	m68k_incpci (4);
l_341107: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* TRAPcc.L #<data>.L (MI) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_5bfb_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s32 dummy;
	dummy = get_ilong_mmu030c_state (2);
	if (cctrue (11)) { Exception_cpu(7); goto l_341108; }
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}	m68k_incpci (6);
l_341108: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* TRAPcc.L  (MI) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_5bfc_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{	if (cctrue (11)) { Exception_cpu(7); goto l_341109; }
	regs.irc = get_iword_mmu030c_opcode_state (2);
}	m68k_incpci (2);
l_341109: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* Scc.B Dn (GE) */
uae_u32 REGPARAM2 CPUFUNC(op_5cc0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{{{	int val = cctrue (12) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DBcc.W Dn,#<data>.W (GE) */
uae_u32 REGPARAM2 CPUFUNC(op_5cc8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 58;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 offs = get_iword_mmu030c_state (2);
	uaecptr oldpc = m68k_getpci ();
	if (!cctrue (12)) {
	m68k_incpci ((uae_s32)offs + 2);
			m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | (((src - 1)) & 0xffff);
		if (src) {
			if (offs & 1) {
				exception3i (opcode, m68k_getpci () + 2 + (uae_s32)offs + 2);
				goto l_341111;
			}
	fill_prefetch_030();
			return 10 * CYCLE_UNIT / 2;
		}
	} else {
	}
	m68k_setpci(oldpc + 4);
	continue_030_prefetch();
}}}l_341111: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* Scc.B (An) (GE) */
uae_u32 REGPARAM2 CPUFUNC(op_5cd0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{{	int val = cctrue (12) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (An)+ (GE) */
uae_u32 REGPARAM2 CPUFUNC(op_5cd8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{{	int val = cctrue (12) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B -(An) (GE) */
uae_u32 REGPARAM2 CPUFUNC(op_5ce0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{{	int val = cctrue (12) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (d16,An) (GE) */
uae_u32 REGPARAM2 CPUFUNC(op_5ce8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (12) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (d8,An,Xn) (GE) */
uae_u32 REGPARAM2 CPUFUNC(op_5cf0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{{	int val = cctrue (12) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* Scc.B (xxx).W (GE) */
uae_u32 REGPARAM2 CPUFUNC(op_5cf8_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (12) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (xxx).L (GE) */
uae_u32 REGPARAM2 CPUFUNC(op_5cf9_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{{	int val = cctrue (12) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* TRAPcc.L #<data>.W (GE) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_5cfa_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s16 dummy = get_iword_mmu030c_state (2);
	if (cctrue (12)) { Exception_cpu(7); goto l_341119; }
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}	m68k_incpci (4);
l_341119: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* TRAPcc.L #<data>.L (GE) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_5cfb_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s32 dummy;
	dummy = get_ilong_mmu030c_state (2);
	if (cctrue (12)) { Exception_cpu(7); goto l_341120; }
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}	m68k_incpci (6);
l_341120: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* TRAPcc.L  (GE) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_5cfc_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{	if (cctrue (12)) { Exception_cpu(7); goto l_341121; }
	regs.irc = get_iword_mmu030c_opcode_state (2);
}	m68k_incpci (2);
l_341121: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* Scc.B Dn (LT) */
uae_u32 REGPARAM2 CPUFUNC(op_5dc0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{{{	int val = cctrue (13) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DBcc.W Dn,#<data>.W (LT) */
uae_u32 REGPARAM2 CPUFUNC(op_5dc8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 58;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 offs = get_iword_mmu030c_state (2);
	uaecptr oldpc = m68k_getpci ();
	if (!cctrue (13)) {
	m68k_incpci ((uae_s32)offs + 2);
			m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | (((src - 1)) & 0xffff);
		if (src) {
			if (offs & 1) {
				exception3i (opcode, m68k_getpci () + 2 + (uae_s32)offs + 2);
				goto l_341123;
			}
	fill_prefetch_030();
			return 10 * CYCLE_UNIT / 2;
		}
	} else {
	}
	m68k_setpci(oldpc + 4);
	continue_030_prefetch();
}}}l_341123: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* Scc.B (An) (LT) */
uae_u32 REGPARAM2 CPUFUNC(op_5dd0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{{	int val = cctrue (13) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (An)+ (LT) */
uae_u32 REGPARAM2 CPUFUNC(op_5dd8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{{	int val = cctrue (13) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B -(An) (LT) */
uae_u32 REGPARAM2 CPUFUNC(op_5de0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{{	int val = cctrue (13) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (d16,An) (LT) */
uae_u32 REGPARAM2 CPUFUNC(op_5de8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (13) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (d8,An,Xn) (LT) */
uae_u32 REGPARAM2 CPUFUNC(op_5df0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{{	int val = cctrue (13) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* Scc.B (xxx).W (LT) */
uae_u32 REGPARAM2 CPUFUNC(op_5df8_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (13) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (xxx).L (LT) */
uae_u32 REGPARAM2 CPUFUNC(op_5df9_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{{	int val = cctrue (13) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* TRAPcc.L #<data>.W (LT) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_5dfa_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s16 dummy = get_iword_mmu030c_state (2);
	if (cctrue (13)) { Exception_cpu(7); goto l_341131; }
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}	m68k_incpci (4);
l_341131: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* TRAPcc.L #<data>.L (LT) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_5dfb_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s32 dummy;
	dummy = get_ilong_mmu030c_state (2);
	if (cctrue (13)) { Exception_cpu(7); goto l_341132; }
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}	m68k_incpci (6);
l_341132: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* TRAPcc.L  (LT) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_5dfc_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{	if (cctrue (13)) { Exception_cpu(7); goto l_341133; }
	regs.irc = get_iword_mmu030c_opcode_state (2);
}	m68k_incpci (2);
l_341133: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* Scc.B Dn (GT) */
uae_u32 REGPARAM2 CPUFUNC(op_5ec0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{{{	int val = cctrue (14) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DBcc.W Dn,#<data>.W (GT) */
uae_u32 REGPARAM2 CPUFUNC(op_5ec8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 58;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 offs = get_iword_mmu030c_state (2);
	uaecptr oldpc = m68k_getpci ();
	if (!cctrue (14)) {
	m68k_incpci ((uae_s32)offs + 2);
			m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | (((src - 1)) & 0xffff);
		if (src) {
			if (offs & 1) {
				exception3i (opcode, m68k_getpci () + 2 + (uae_s32)offs + 2);
				goto l_341135;
			}
	fill_prefetch_030();
			return 10 * CYCLE_UNIT / 2;
		}
	} else {
	}
	m68k_setpci(oldpc + 4);
	continue_030_prefetch();
}}}l_341135: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* Scc.B (An) (GT) */
uae_u32 REGPARAM2 CPUFUNC(op_5ed0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{{	int val = cctrue (14) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (An)+ (GT) */
uae_u32 REGPARAM2 CPUFUNC(op_5ed8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{{	int val = cctrue (14) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B -(An) (GT) */
uae_u32 REGPARAM2 CPUFUNC(op_5ee0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{{	int val = cctrue (14) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (d16,An) (GT) */
uae_u32 REGPARAM2 CPUFUNC(op_5ee8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (14) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (d8,An,Xn) (GT) */
uae_u32 REGPARAM2 CPUFUNC(op_5ef0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{{	int val = cctrue (14) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* Scc.B (xxx).W (GT) */
uae_u32 REGPARAM2 CPUFUNC(op_5ef8_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (14) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (xxx).L (GT) */
uae_u32 REGPARAM2 CPUFUNC(op_5ef9_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{{	int val = cctrue (14) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* TRAPcc.L #<data>.W (GT) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_5efa_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s16 dummy = get_iword_mmu030c_state (2);
	if (cctrue (14)) { Exception_cpu(7); goto l_341143; }
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}	m68k_incpci (4);
l_341143: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* TRAPcc.L #<data>.L (GT) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_5efb_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s32 dummy;
	dummy = get_ilong_mmu030c_state (2);
	if (cctrue (14)) { Exception_cpu(7); goto l_341144; }
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}	m68k_incpci (6);
l_341144: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* TRAPcc.L  (GT) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_5efc_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{	if (cctrue (14)) { Exception_cpu(7); goto l_341145; }
	regs.irc = get_iword_mmu030c_opcode_state (2);
}	m68k_incpci (2);
l_341145: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* Scc.B Dn (LE) */
uae_u32 REGPARAM2 CPUFUNC(op_5fc0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{{{	int val = cctrue (15) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DBcc.W Dn,#<data>.W (LE) */
uae_u32 REGPARAM2 CPUFUNC(op_5fc8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 58;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 offs = get_iword_mmu030c_state (2);
	uaecptr oldpc = m68k_getpci ();
	if (!cctrue (15)) {
	m68k_incpci ((uae_s32)offs + 2);
			m68k_dreg (regs, srcreg) = (m68k_dreg (regs, srcreg) & ~0xffff) | (((src - 1)) & 0xffff);
		if (src) {
			if (offs & 1) {
				exception3i (opcode, m68k_getpci () + 2 + (uae_s32)offs + 2);
				goto l_341147;
			}
	fill_prefetch_030();
			return 10 * CYCLE_UNIT / 2;
		}
	} else {
	}
	m68k_setpci(oldpc + 4);
	continue_030_prefetch();
}}}l_341147: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* Scc.B (An) (LE) */
uae_u32 REGPARAM2 CPUFUNC(op_5fd0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{{	int val = cctrue (15) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (An)+ (LE) */
uae_u32 REGPARAM2 CPUFUNC(op_5fd8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{{	int val = cctrue (15) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B -(An) (LE) */
uae_u32 REGPARAM2 CPUFUNC(op_5fe0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{{	int val = cctrue (15) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* Scc.B (d16,An) (LE) */
uae_u32 REGPARAM2 CPUFUNC(op_5fe8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (15) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (d8,An,Xn) (LE) */
uae_u32 REGPARAM2 CPUFUNC(op_5ff0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{{	int val = cctrue (15) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* Scc.B (xxx).W (LE) */
uae_u32 REGPARAM2 CPUFUNC(op_5ff8_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{{	int val = cctrue (15) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* Scc.B (xxx).L (LE) */
uae_u32 REGPARAM2 CPUFUNC(op_5ff9_34)(uae_u32 opcode)
{
	OpcodeFamily = 59;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{{	int val = cctrue (15) ? 0xff : 0;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (srca, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* TRAPcc.L #<data>.W (LE) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_5ffa_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s16 dummy = get_iword_mmu030c_state (2);
	if (cctrue (15)) { Exception_cpu(7); goto l_341155; }
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}	m68k_incpci (4);
l_341155: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* TRAPcc.L #<data>.L (LE) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_5ffb_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{{	uae_s32 dummy;
	dummy = get_ilong_mmu030c_state (2);
	if (cctrue (15)) { Exception_cpu(7); goto l_341156; }
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}	m68k_incpci (6);
l_341156: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* TRAPcc.L  (LE) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_5ffc_34)(uae_u32 opcode)
{
	OpcodeFamily = 102;
	CurrentInstrCycles = 4;  
{	if (cctrue (15)) { Exception_cpu(7); goto l_341157; }
	regs.irc = get_iword_mmu030c_opcode_state (2);
}	m68k_incpci (2);
l_341157: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif
/* Bcc.W #<data>.W (T) */
uae_u32 REGPARAM2 CPUFUNC(op_6000_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
	if (!cctrue (0)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341158;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (4);
	continue_030_prefetch();
}}l_341158: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* BccQ.B #<data> (T) */
uae_u32 REGPARAM2 CPUFUNC(op_6001_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
	if (!cctrue (0)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341159;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (2);
	continue_030_prefetch();
}}l_341159: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0 B */

/* Bcc.L #<data>.L (T) */
uae_u32 REGPARAM2 CPUFUNC(op_60ff_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
	if (!cctrue (0)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341160;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (6);
	continue_030_prefetch();
}}l_341160: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0 B */

/* BSR.W #<data>.W */
uae_u32 REGPARAM2 CPUFUNC(op_6100_34)(uae_u32 opcode)
{
	OpcodeFamily = 54;
	CurrentInstrCycles = 14; 
{	uae_s32 s;
{	uae_s16 src = get_iword_mmu030c_state (2);
	s = (uae_s32)src + 2;
	if (src & 1) {
		exception3b (opcode, m68k_getpci () + s, 0, 1, m68k_getpci () + s);
		goto l_341161;
	}
	uaecptr oldpc = m68k_getpci ();
	uaecptr nextpc = oldpc + 4;
	m68k_do_bsr_mmu030c (nextpc, s);
	if (debugmem_trace)
		branch_stack_push(oldpc, nextpc);
	fill_prefetch_030();
}}l_341161: ;
return 14 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* BSRQ.B #<data> */
uae_u32 REGPARAM2 CPUFUNC(op_6101_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
	OpcodeFamily = 54;
	CurrentInstrCycles = 14; 
{	uae_s32 s;
{	uae_u32 src = srcreg;
	s = (uae_s32)src + 2;
	if (src & 1) {
		exception3b (opcode, m68k_getpci () + s, 0, 1, m68k_getpci () + s);
		goto l_341162;
	}
	uaecptr oldpc = m68k_getpci ();
	uaecptr nextpc = oldpc + 2;
	m68k_do_bsr_mmu030c (nextpc, s);
	if (debugmem_trace)
		branch_stack_push(oldpc, nextpc);
	fill_prefetch_030();
}}l_341162: ;
return 14 * CYCLE_UNIT / 2;
}
/* 2 0,0 B */

/* BSR.L #<data>.L */
uae_u32 REGPARAM2 CPUFUNC(op_61ff_34)(uae_u32 opcode)
{
	OpcodeFamily = 54;
	CurrentInstrCycles = 14; 
{	uae_s32 s;
{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
	s = (uae_s32)src + 2;
	if (src & 1) {
		exception3b (opcode, m68k_getpci () + s, 0, 1, m68k_getpci () + s);
		goto l_341163;
	}
	uaecptr oldpc = m68k_getpci ();
	uaecptr nextpc = oldpc + 6;
	m68k_do_bsr_mmu030c (nextpc, s);
	if (debugmem_trace)
		branch_stack_push(oldpc, nextpc);
	fill_prefetch_030();
}}l_341163: ;
return 14 * CYCLE_UNIT / 2;
}
/* 6 0,0 B */

/* Bcc.W #<data>.W (HI) */
uae_u32 REGPARAM2 CPUFUNC(op_6200_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
	if (!cctrue (2)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341164;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (4);
	continue_030_prefetch();
}}l_341164: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* BccQ.B #<data> (HI) */
uae_u32 REGPARAM2 CPUFUNC(op_6201_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
	if (!cctrue (2)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341165;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (2);
	continue_030_prefetch();
}}l_341165: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0 B */

/* Bcc.L #<data>.L (HI) */
uae_u32 REGPARAM2 CPUFUNC(op_62ff_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
	if (!cctrue (2)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341166;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (6);
	continue_030_prefetch();
}}l_341166: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0 B */

/* Bcc.W #<data>.W (LS) */
uae_u32 REGPARAM2 CPUFUNC(op_6300_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
	if (!cctrue (3)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341167;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (4);
	continue_030_prefetch();
}}l_341167: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* BccQ.B #<data> (LS) */
uae_u32 REGPARAM2 CPUFUNC(op_6301_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
	if (!cctrue (3)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341168;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (2);
	continue_030_prefetch();
}}l_341168: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0 B */

#endif

#ifdef PART_6
/* Bcc.L #<data>.L (LS) */
uae_u32 REGPARAM2 CPUFUNC(op_63ff_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
	if (!cctrue (3)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341169;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (6);
	continue_030_prefetch();
}}l_341169: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0 B */

/* Bcc.W #<data>.W (CC) */
uae_u32 REGPARAM2 CPUFUNC(op_6400_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
	if (!cctrue (4)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341170;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (4);
	continue_030_prefetch();
}}l_341170: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* BccQ.B #<data> (CC) */
uae_u32 REGPARAM2 CPUFUNC(op_6401_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
	if (!cctrue (4)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341171;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (2);
	continue_030_prefetch();
}}l_341171: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0 B */

/* Bcc.L #<data>.L (CC) */
uae_u32 REGPARAM2 CPUFUNC(op_64ff_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
	if (!cctrue (4)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341172;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (6);
	continue_030_prefetch();
}}l_341172: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0 B */

/* Bcc.W #<data>.W (CS) */
uae_u32 REGPARAM2 CPUFUNC(op_6500_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
	if (!cctrue (5)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341173;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (4);
	continue_030_prefetch();
}}l_341173: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* BccQ.B #<data> (CS) */
uae_u32 REGPARAM2 CPUFUNC(op_6501_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
	if (!cctrue (5)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341174;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (2);
	continue_030_prefetch();
}}l_341174: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0 B */

/* Bcc.L #<data>.L (CS) */
uae_u32 REGPARAM2 CPUFUNC(op_65ff_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
	if (!cctrue (5)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341175;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (6);
	continue_030_prefetch();
}}l_341175: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0 B */

/* Bcc.W #<data>.W (NE) */
uae_u32 REGPARAM2 CPUFUNC(op_6600_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
	if (!cctrue (6)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341176;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (4);
	continue_030_prefetch();
}}l_341176: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* BccQ.B #<data> (NE) */
uae_u32 REGPARAM2 CPUFUNC(op_6601_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
	if (!cctrue (6)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341177;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (2);
	continue_030_prefetch();
}}l_341177: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0 B */

/* Bcc.L #<data>.L (NE) */
uae_u32 REGPARAM2 CPUFUNC(op_66ff_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
	if (!cctrue (6)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341178;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (6);
	continue_030_prefetch();
}}l_341178: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0 B */

/* Bcc.W #<data>.W (EQ) */
uae_u32 REGPARAM2 CPUFUNC(op_6700_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
	if (!cctrue (7)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341179;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (4);
	continue_030_prefetch();
}}l_341179: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* BccQ.B #<data> (EQ) */
uae_u32 REGPARAM2 CPUFUNC(op_6701_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
	if (!cctrue (7)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341180;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (2);
	continue_030_prefetch();
}}l_341180: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0 B */

/* Bcc.L #<data>.L (EQ) */
uae_u32 REGPARAM2 CPUFUNC(op_67ff_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
	if (!cctrue (7)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341181;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (6);
	continue_030_prefetch();
}}l_341181: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0 B */

/* Bcc.W #<data>.W (VC) */
uae_u32 REGPARAM2 CPUFUNC(op_6800_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
	if (!cctrue (8)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341182;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (4);
	continue_030_prefetch();
}}l_341182: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* BccQ.B #<data> (VC) */
uae_u32 REGPARAM2 CPUFUNC(op_6801_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
	if (!cctrue (8)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341183;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (2);
	continue_030_prefetch();
}}l_341183: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0 B */

/* Bcc.L #<data>.L (VC) */
uae_u32 REGPARAM2 CPUFUNC(op_68ff_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
	if (!cctrue (8)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341184;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (6);
	continue_030_prefetch();
}}l_341184: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0 B */

/* Bcc.W #<data>.W (VS) */
uae_u32 REGPARAM2 CPUFUNC(op_6900_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
	if (!cctrue (9)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341185;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (4);
	continue_030_prefetch();
}}l_341185: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* BccQ.B #<data> (VS) */
uae_u32 REGPARAM2 CPUFUNC(op_6901_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
	if (!cctrue (9)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341186;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (2);
	continue_030_prefetch();
}}l_341186: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0 B */

/* Bcc.L #<data>.L (VS) */
uae_u32 REGPARAM2 CPUFUNC(op_69ff_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
	if (!cctrue (9)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341187;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (6);
	continue_030_prefetch();
}}l_341187: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0 B */

/* Bcc.W #<data>.W (PL) */
uae_u32 REGPARAM2 CPUFUNC(op_6a00_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
	if (!cctrue (10)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341188;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (4);
	continue_030_prefetch();
}}l_341188: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* BccQ.B #<data> (PL) */
uae_u32 REGPARAM2 CPUFUNC(op_6a01_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
	if (!cctrue (10)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341189;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (2);
	continue_030_prefetch();
}}l_341189: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0 B */

/* Bcc.L #<data>.L (PL) */
uae_u32 REGPARAM2 CPUFUNC(op_6aff_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
	if (!cctrue (10)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341190;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (6);
	continue_030_prefetch();
}}l_341190: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0 B */

/* Bcc.W #<data>.W (MI) */
uae_u32 REGPARAM2 CPUFUNC(op_6b00_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
	if (!cctrue (11)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341191;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (4);
	continue_030_prefetch();
}}l_341191: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* BccQ.B #<data> (MI) */
uae_u32 REGPARAM2 CPUFUNC(op_6b01_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
	if (!cctrue (11)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341192;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (2);
	continue_030_prefetch();
}}l_341192: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0 B */

/* Bcc.L #<data>.L (MI) */
uae_u32 REGPARAM2 CPUFUNC(op_6bff_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
	if (!cctrue (11)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341193;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (6);
	continue_030_prefetch();
}}l_341193: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0 B */

/* Bcc.W #<data>.W (GE) */
uae_u32 REGPARAM2 CPUFUNC(op_6c00_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
	if (!cctrue (12)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341194;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (4);
	continue_030_prefetch();
}}l_341194: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* BccQ.B #<data> (GE) */
uae_u32 REGPARAM2 CPUFUNC(op_6c01_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
	if (!cctrue (12)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341195;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (2);
	continue_030_prefetch();
}}l_341195: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0 B */

/* Bcc.L #<data>.L (GE) */
uae_u32 REGPARAM2 CPUFUNC(op_6cff_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
	if (!cctrue (12)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341196;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (6);
	continue_030_prefetch();
}}l_341196: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0 B */

/* Bcc.W #<data>.W (LT) */
uae_u32 REGPARAM2 CPUFUNC(op_6d00_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
	if (!cctrue (13)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341197;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (4);
	continue_030_prefetch();
}}l_341197: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* BccQ.B #<data> (LT) */
uae_u32 REGPARAM2 CPUFUNC(op_6d01_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
	if (!cctrue (13)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341198;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (2);
	continue_030_prefetch();
}}l_341198: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0 B */

/* Bcc.L #<data>.L (LT) */
uae_u32 REGPARAM2 CPUFUNC(op_6dff_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
	if (!cctrue (13)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341199;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (6);
	continue_030_prefetch();
}}l_341199: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0 B */

/* Bcc.W #<data>.W (GT) */
uae_u32 REGPARAM2 CPUFUNC(op_6e00_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
	if (!cctrue (14)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341200;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (4);
	continue_030_prefetch();
}}l_341200: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* BccQ.B #<data> (GT) */
uae_u32 REGPARAM2 CPUFUNC(op_6e01_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
	if (!cctrue (14)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341201;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (2);
	continue_030_prefetch();
}}l_341201: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0 B */

/* Bcc.L #<data>.L (GT) */
uae_u32 REGPARAM2 CPUFUNC(op_6eff_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
	if (!cctrue (14)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341202;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (6);
	continue_030_prefetch();
}}l_341202: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0 B */

/* Bcc.W #<data>.W (LE) */
uae_u32 REGPARAM2 CPUFUNC(op_6f00_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
	if (!cctrue (15)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341203;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (4);
	continue_030_prefetch();
}}l_341203: ;
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0 B */

/* BccQ.B #<data> (LE) */
uae_u32 REGPARAM2 CPUFUNC(op_6f01_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
	if (!cctrue (15)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341204;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (2);
	continue_030_prefetch();
}}l_341204: ;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0 B */

/* Bcc.L #<data>.L (LE) */
uae_u32 REGPARAM2 CPUFUNC(op_6fff_34)(uae_u32 opcode)
{
	OpcodeFamily = 55;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
	if (!cctrue (15)) goto didnt_jump;
	if (src & 1) {
		exception3i (opcode, m68k_getpci () + 2 + (uae_s32)src);
		goto l_341205;
	}
	m68k_incpci ((uae_s32)src + 2);
	fill_prefetch_030();
	return 10 * CYCLE_UNIT / 2;
didnt_jump:;
	m68k_incpci (6);
	continue_030_prefetch();
}}l_341205: ;
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0 B */

/* MOVEQ.L #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_7000_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 30;
	CurrentInstrCycles = 4;  
{{	uae_u32 src = srcreg;
{	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (src);
	m68k_incpci (2);
}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.B Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_8000_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.B (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_8010_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.B (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_8018_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.B -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_8020_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.B (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_8028_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.B (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_8030_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* OR.B (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_8038_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.B (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_8039_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* OR.B (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_803a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.B (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_803b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* OR.B #<data>.B,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_803c_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}	m68k_incpci (4);
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.W Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_8040_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.W (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_8050_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.W (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_8058_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.W -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_8060_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.W (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_8068_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.W (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_8070_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* OR.W (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_8078_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.W (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_8079_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* OR.W (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_807a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.W (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_807b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* OR.W #<data>.W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_807c_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.L Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_8080_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (src);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.L (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_8090_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (src);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.L (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_8098_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (src);
}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.L -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_80a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (src);
}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.L (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_80a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (src);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.L (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_80b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* OR.L (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_80b8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (src);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.L (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_80b9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (src);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* OR.L (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_80ba_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (src);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.L (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_80bb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* OR.L #<data>.L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_80bc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (src);
}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* DIVU.W Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_80c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 60;
	CurrentInstrCycles = 54; 
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	CLEAR_CZNV ();
	if (src == 0) {
		divbyzero_special (0, dst);
	m68k_incpci (2);
		Exception_cpu(5);
		goto l_341240;
	} else {
		uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
		uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
		if (newv > 0xffff) {
			setdivuoverflowflags((uae_u32)dst, (uae_u16)src);
		} else {
			CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_NFLG (((uae_s16)(newv)) < 0);
			newv = (newv & 0xffff) | ((uae_u32)rem << 16);
			m68k_dreg (regs, dstreg) = (newv);
		}
	m68k_incpci (2);
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}l_341240: ;
return 54 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DIVU.W (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_80d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 60;
	CurrentInstrCycles = 54; 
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	CLEAR_CZNV ();
	if (src == 0) {
		divbyzero_special (0, dst);
	m68k_incpci (2);
		Exception_cpu(5);
		goto l_341241;
	} else {
		uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
		uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
		if (newv > 0xffff) {
			setdivuoverflowflags((uae_u32)dst, (uae_u16)src);
		} else {
			CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_NFLG (((uae_s16)(newv)) < 0);
			newv = (newv & 0xffff) | ((uae_u32)rem << 16);
			m68k_dreg (regs, dstreg) = (newv);
		}
	m68k_incpci (2);
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_341241: ;
return 54 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DIVU.W (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_80d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 60;
	CurrentInstrCycles = 54; 
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	CLEAR_CZNV ();
	if (src == 0) {
		divbyzero_special (0, dst);
	m68k_incpci (2);
		Exception_cpu(5);
		goto l_341242;
	} else {
		uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
		uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
		if (newv > 0xffff) {
			setdivuoverflowflags((uae_u32)dst, (uae_u16)src);
		} else {
			CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_NFLG (((uae_s16)(newv)) < 0);
			newv = (newv & 0xffff) | ((uae_u32)rem << 16);
			m68k_dreg (regs, dstreg) = (newv);
		}
	m68k_incpci (2);
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_341242: ;
	mmufixup[0].reg = -1;
return 54 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DIVU.W -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_80e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 60;
	CurrentInstrCycles = 54; 
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	CLEAR_CZNV ();
	if (src == 0) {
		divbyzero_special (0, dst);
	m68k_incpci (2);
		Exception_cpu(5);
		goto l_341243;
	} else {
		uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
		uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
		if (newv > 0xffff) {
			setdivuoverflowflags((uae_u32)dst, (uae_u16)src);
		} else {
			CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_NFLG (((uae_s16)(newv)) < 0);
			newv = (newv & 0xffff) | ((uae_u32)rem << 16);
			m68k_dreg (regs, dstreg) = (newv);
		}
	m68k_incpci (2);
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_341243: ;
	mmufixup[0].reg = -1;
return 54 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DIVU.W (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_80e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 60;
	CurrentInstrCycles = 54; 
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	CLEAR_CZNV ();
	if (src == 0) {
		divbyzero_special (0, dst);
	m68k_incpci (4);
		Exception_cpu(5);
		goto l_341244;
	} else {
		uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
		uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
		if (newv > 0xffff) {
			setdivuoverflowflags((uae_u32)dst, (uae_u16)src);
		} else {
			CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_NFLG (((uae_s16)(newv)) < 0);
			newv = (newv & 0xffff) | ((uae_u32)rem << 16);
			m68k_dreg (regs, dstreg) = (newv);
		}
	m68k_incpci (4);
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_341244: ;
return 54 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* DIVU.W (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_80f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 60;
	CurrentInstrCycles = 54; 
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	CLEAR_CZNV ();
	if (src == 0) {
		divbyzero_special (0, dst);
	m68k_incpci (0);
		Exception_cpu(5);
		goto l_341245;
	} else {
		uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
		uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
		if (newv > 0xffff) {
			setdivuoverflowflags((uae_u32)dst, (uae_u16)src);
		} else {
			CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_NFLG (((uae_s16)(newv)) < 0);
			newv = (newv & 0xffff) | ((uae_u32)rem << 16);
			m68k_dreg (regs, dstreg) = (newv);
		}
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}l_341245: ;
return 54 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* DIVU.W (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_80f8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 60;
	CurrentInstrCycles = 54; 
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	CLEAR_CZNV ();
	if (src == 0) {
		divbyzero_special (0, dst);
	m68k_incpci (4);
		Exception_cpu(5);
		goto l_341246;
	} else {
		uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
		uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
		if (newv > 0xffff) {
			setdivuoverflowflags((uae_u32)dst, (uae_u16)src);
		} else {
			CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_NFLG (((uae_s16)(newv)) < 0);
			newv = (newv & 0xffff) | ((uae_u32)rem << 16);
			m68k_dreg (regs, dstreg) = (newv);
		}
	m68k_incpci (4);
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_341246: ;
return 54 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* DIVU.W (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_80f9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 60;
	CurrentInstrCycles = 54; 
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	CLEAR_CZNV ();
	if (src == 0) {
		divbyzero_special (0, dst);
	m68k_incpci (6);
		Exception_cpu(5);
		goto l_341247;
	} else {
		uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
		uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
		if (newv > 0xffff) {
			setdivuoverflowflags((uae_u32)dst, (uae_u16)src);
		} else {
			CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_NFLG (((uae_s16)(newv)) < 0);
			newv = (newv & 0xffff) | ((uae_u32)rem << 16);
			m68k_dreg (regs, dstreg) = (newv);
		}
	m68k_incpci (6);
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_341247: ;
return 54 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* DIVU.W (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_80fa_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 60;
	CurrentInstrCycles = 54; 
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	CLEAR_CZNV ();
	if (src == 0) {
		divbyzero_special (0, dst);
	m68k_incpci (4);
		Exception_cpu(5);
		goto l_341248;
	} else {
		uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
		uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
		if (newv > 0xffff) {
			setdivuoverflowflags((uae_u32)dst, (uae_u16)src);
		} else {
			CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_NFLG (((uae_s16)(newv)) < 0);
			newv = (newv & 0xffff) | ((uae_u32)rem << 16);
			m68k_dreg (regs, dstreg) = (newv);
		}
	m68k_incpci (4);
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_341248: ;
return 54 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* DIVU.W (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_80fb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 60;
	CurrentInstrCycles = 54; 
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	CLEAR_CZNV ();
	if (src == 0) {
		divbyzero_special (0, dst);
	m68k_incpci (0);
		Exception_cpu(5);
		goto l_341249;
	} else {
		uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
		uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
		if (newv > 0xffff) {
			setdivuoverflowflags((uae_u32)dst, (uae_u16)src);
		} else {
			CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_NFLG (((uae_s16)(newv)) < 0);
			newv = (newv & 0xffff) | ((uae_u32)rem << 16);
			m68k_dreg (regs, dstreg) = (newv);
		}
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}l_341249: ;
return 54 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* DIVU.W #<data>.W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_80fc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 60;
	CurrentInstrCycles = 54; 
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	CLEAR_CZNV ();
	if (src == 0) {
		divbyzero_special (0, dst);
	m68k_incpci (4);
		Exception_cpu(5);
		goto l_341250;
	} else {
		uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
		uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
		if (newv > 0xffff) {
			setdivuoverflowflags((uae_u32)dst, (uae_u16)src);
		} else {
			CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_NFLG (((uae_s16)(newv)) < 0);
			newv = (newv & 0xffff) | ((uae_u32)rem << 16);
			m68k_dreg (regs, dstreg) = (newv);
		}
	m68k_incpci (4);
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}l_341250: ;
return 54 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SBCD.B Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_8100_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 10;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{	uae_u16 newv_lo = (dst & 0xF) - (src & 0xF) - (GET_XFLG () ? 1 : 0);
	uae_u16 newv_hi = (dst & 0xF0) - (src & 0xF0);
	uae_u16 newv, tmp_newv;
	int bcd = 0;
	newv = tmp_newv = newv_hi + newv_lo;
	if (newv_lo & 0xF0) { newv -= 6; bcd = 6; };
	if ((((dst & 0xFF) - (src & 0xFF) - (GET_XFLG () ? 1 : 0)) & 0x100) > 0xFF) { newv -= 0x60; }
	SET_CFLG ((((dst & 0xFF) - (src & 0xFF) - bcd - (GET_XFLG () ? 1 : 0)) & 0x300) > 0xFF);
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SBCD.B -(An),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_8108_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 10;
	CurrentInstrCycles = 13; 
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{	uae_u16 newv_lo = (dst & 0xF) - (src & 0xF) - (GET_XFLG () ? 1 : 0);
	uae_u16 newv_hi = (dst & 0xF0) - (src & 0xF0);
	uae_u16 newv, tmp_newv;
	int bcd = 0;
	newv = tmp_newv = newv_hi + newv_lo;
	if (newv_lo & 0xF0) { newv -= 6; bcd = 6; };
	if ((((dst & 0xFF) - (src & 0xFF) - (GET_XFLG () ? 1 : 0)) & 0x100) > 0xFF) { newv -= 0x60; }
	SET_CFLG ((((dst & 0xFF) - (src & 0xFF) - bcd - (GET_XFLG () ? 1 : 0)) & 0x300) > 0xFF);
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 13 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.B Dn,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_8110_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.B Dn,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_8118_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.B Dn,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_8120_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.B Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_8128_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.B Dn,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_8130_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* OR.B Dn,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_8138_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.B Dn,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_8139_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* PACK.L Dn,Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_8140_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 96;
	CurrentInstrCycles = 6;  
{	uae_u16 val = m68k_dreg (regs, srcreg) + get_iword_mmu030c_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & 0xffffff00) | ((val >> 4) & 0xf0) | (val & 0xf);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}	m68k_incpci (4);
return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* PACK.L -(An),-(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_8148_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 96;
	CurrentInstrCycles = 11; 
{	uae_u16 val;
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) -= areg_byteinc[srcreg];
	val = (uae_u16)(get_byte_mmu030c_state (m68k_areg (regs, srcreg)) & 0xff);
	m68k_areg (regs, srcreg) -= areg_byteinc[srcreg];
	val = val | ((uae_u16)(get_byte_mmu030c_state (m68k_areg (regs, srcreg)) & 0xff) << 8);
	val += get_iword_mmu030c_state (2);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) -= areg_byteinc[dstreg];
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (m68k_areg (regs, dstreg),((val >> 4) & 0xf0) | (val & 0xf));
	regs.irc = get_iword_mmu030c_opcode_state (0);
}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 11 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* OR.W Dn,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_8150_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.W Dn,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_8158_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.W Dn,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_8160_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.W Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_8168_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.W Dn,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_8170_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* OR.W Dn,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_8178_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.W Dn,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_8179_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* UNPK.L Dn,Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_8180_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 97;
	CurrentInstrCycles = 8;  
{	uae_u16 val = m68k_dreg (regs, srcreg);
	val = ((val << 4) & 0xf00) | (val & 0xf);
	val += get_iword_mmu030c_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & 0xffff0000) | (val & 0xffff);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}	m68k_incpci (4);
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* UNPK.L -(An),-(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_8188_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 97;
	CurrentInstrCycles = 11; 
{	uae_u16 val;
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) -= areg_byteinc[srcreg];
	val = (uae_u16)(get_byte_mmu030c_state (m68k_areg (regs, srcreg)) & 0xff);
	val = (((val << 4) & 0xf00) | (val & 0xf)) + get_iword_mmu030c_state (2);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) -= 2 * areg_byteinc[dstreg];
	put_byte_mmu030c_state (m68k_areg (regs, dstreg) + areg_byteinc[dstreg], val);
	put_byte_mmu030c_state (m68k_areg (regs, dstreg), val >> 8);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}	m68k_incpci (4);
	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 11 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* OR.L Dn,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_8190_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.L Dn,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_8198_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.L Dn,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_81a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* OR.L Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_81a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.L Dn,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_81b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* OR.L Dn,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_81b8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* OR.L Dn,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_81b9_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 1;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src |= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* DIVS.W Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_81c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 61;
	CurrentInstrCycles = 54; 
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	if (src == 0) {
		divbyzero_special (1, dst);
	m68k_incpci (2);
		Exception_cpu(5);
		goto l_341278;
	}
	CLEAR_CZNV ();
	if (dst == 0x80000000 && src == -1) {
		setdivsoverflowflags((uae_s32)dst, (uae_s16)src);
	} else {
		uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
		uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
		if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) {
			setdivsoverflowflags((uae_s32)dst, (uae_s16)src);
		} else {
			if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_NFLG (((uae_s16)(newv)) < 0);
			newv = (newv & 0xffff) | ((uae_u32)rem << 16);
			m68k_dreg (regs, dstreg) = (newv);
		}
	}
	m68k_incpci (2);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}l_341278: ;
return 54 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DIVS.W (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_81d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 61;
	CurrentInstrCycles = 54; 
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	if (src == 0) {
		divbyzero_special (1, dst);
	m68k_incpci (2);
		Exception_cpu(5);
		goto l_341279;
	}
	CLEAR_CZNV ();
	if (dst == 0x80000000 && src == -1) {
		setdivsoverflowflags((uae_s32)dst, (uae_s16)src);
	} else {
		uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
		uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
		if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) {
			setdivsoverflowflags((uae_s32)dst, (uae_s16)src);
		} else {
			if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_NFLG (((uae_s16)(newv)) < 0);
			newv = (newv & 0xffff) | ((uae_u32)rem << 16);
			m68k_dreg (regs, dstreg) = (newv);
		}
	}
	m68k_incpci (2);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_341279: ;
return 54 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DIVS.W (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_81d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 61;
	CurrentInstrCycles = 54; 
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	if (src == 0) {
		divbyzero_special (1, dst);
	m68k_incpci (2);
		Exception_cpu(5);
		goto l_341280;
	}
	CLEAR_CZNV ();
	if (dst == 0x80000000 && src == -1) {
		setdivsoverflowflags((uae_s32)dst, (uae_s16)src);
	} else {
		uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
		uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
		if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) {
			setdivsoverflowflags((uae_s32)dst, (uae_s16)src);
		} else {
			if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_NFLG (((uae_s16)(newv)) < 0);
			newv = (newv & 0xffff) | ((uae_u32)rem << 16);
			m68k_dreg (regs, dstreg) = (newv);
		}
	}
	m68k_incpci (2);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_341280: ;
	mmufixup[0].reg = -1;
return 54 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DIVS.W -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_81e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 61;
	CurrentInstrCycles = 54; 
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	if (src == 0) {
		divbyzero_special (1, dst);
	m68k_incpci (2);
		Exception_cpu(5);
		goto l_341281;
	}
	CLEAR_CZNV ();
	if (dst == 0x80000000 && src == -1) {
		setdivsoverflowflags((uae_s32)dst, (uae_s16)src);
	} else {
		uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
		uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
		if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) {
			setdivsoverflowflags((uae_s32)dst, (uae_s16)src);
		} else {
			if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_NFLG (((uae_s16)(newv)) < 0);
			newv = (newv & 0xffff) | ((uae_u32)rem << 16);
			m68k_dreg (regs, dstreg) = (newv);
		}
	}
	m68k_incpci (2);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_341281: ;
	mmufixup[0].reg = -1;
return 54 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* DIVS.W (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_81e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 61;
	CurrentInstrCycles = 54; 
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	if (src == 0) {
		divbyzero_special (1, dst);
	m68k_incpci (4);
		Exception_cpu(5);
		goto l_341282;
	}
	CLEAR_CZNV ();
	if (dst == 0x80000000 && src == -1) {
		setdivsoverflowflags((uae_s32)dst, (uae_s16)src);
	} else {
		uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
		uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
		if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) {
			setdivsoverflowflags((uae_s32)dst, (uae_s16)src);
		} else {
			if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_NFLG (((uae_s16)(newv)) < 0);
			newv = (newv & 0xffff) | ((uae_u32)rem << 16);
			m68k_dreg (regs, dstreg) = (newv);
		}
	}
	m68k_incpci (4);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_341282: ;
return 54 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* DIVS.W (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_81f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 61;
	CurrentInstrCycles = 54; 
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	if (src == 0) {
		divbyzero_special (1, dst);
	m68k_incpci (0);
		Exception_cpu(5);
		goto l_341283;
	}
	CLEAR_CZNV ();
	if (dst == 0x80000000 && src == -1) {
		setdivsoverflowflags((uae_s32)dst, (uae_s16)src);
	} else {
		uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
		uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
		if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) {
			setdivsoverflowflags((uae_s32)dst, (uae_s16)src);
		} else {
			if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_NFLG (((uae_s16)(newv)) < 0);
			newv = (newv & 0xffff) | ((uae_u32)rem << 16);
			m68k_dreg (regs, dstreg) = (newv);
		}
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}l_341283: ;
return 54 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* DIVS.W (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_81f8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 61;
	CurrentInstrCycles = 54; 
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	if (src == 0) {
		divbyzero_special (1, dst);
	m68k_incpci (4);
		Exception_cpu(5);
		goto l_341284;
	}
	CLEAR_CZNV ();
	if (dst == 0x80000000 && src == -1) {
		setdivsoverflowflags((uae_s32)dst, (uae_s16)src);
	} else {
		uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
		uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
		if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) {
			setdivsoverflowflags((uae_s32)dst, (uae_s16)src);
		} else {
			if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_NFLG (((uae_s16)(newv)) < 0);
			newv = (newv & 0xffff) | ((uae_u32)rem << 16);
			m68k_dreg (regs, dstreg) = (newv);
		}
	}
	m68k_incpci (4);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_341284: ;
return 54 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* DIVS.W (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_81f9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 61;
	CurrentInstrCycles = 54; 
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	if (src == 0) {
		divbyzero_special (1, dst);
	m68k_incpci (6);
		Exception_cpu(5);
		goto l_341285;
	}
	CLEAR_CZNV ();
	if (dst == 0x80000000 && src == -1) {
		setdivsoverflowflags((uae_s32)dst, (uae_s16)src);
	} else {
		uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
		uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
		if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) {
			setdivsoverflowflags((uae_s32)dst, (uae_s16)src);
		} else {
			if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_NFLG (((uae_s16)(newv)) < 0);
			newv = (newv & 0xffff) | ((uae_u32)rem << 16);
			m68k_dreg (regs, dstreg) = (newv);
		}
	}
	m68k_incpci (6);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_341285: ;
return 54 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* DIVS.W (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_81fa_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 61;
	CurrentInstrCycles = 54; 
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	if (src == 0) {
		divbyzero_special (1, dst);
	m68k_incpci (4);
		Exception_cpu(5);
		goto l_341286;
	}
	CLEAR_CZNV ();
	if (dst == 0x80000000 && src == -1) {
		setdivsoverflowflags((uae_s32)dst, (uae_s16)src);
	} else {
		uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
		uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
		if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) {
			setdivsoverflowflags((uae_s32)dst, (uae_s16)src);
		} else {
			if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_NFLG (((uae_s16)(newv)) < 0);
			newv = (newv & 0xffff) | ((uae_u32)rem << 16);
			m68k_dreg (regs, dstreg) = (newv);
		}
	}
	m68k_incpci (4);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_341286: ;
return 54 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* DIVS.W (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_81fb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 61;
	CurrentInstrCycles = 54; 
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	if (src == 0) {
		divbyzero_special (1, dst);
	m68k_incpci (0);
		Exception_cpu(5);
		goto l_341287;
	}
	CLEAR_CZNV ();
	if (dst == 0x80000000 && src == -1) {
		setdivsoverflowflags((uae_s32)dst, (uae_s16)src);
	} else {
		uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
		uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
		if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) {
			setdivsoverflowflags((uae_s32)dst, (uae_s16)src);
		} else {
			if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_NFLG (((uae_s16)(newv)) < 0);
			newv = (newv & 0xffff) | ((uae_u32)rem << 16);
			m68k_dreg (regs, dstreg) = (newv);
		}
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}l_341287: ;
return 54 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* DIVS.W #<data>.W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_81fc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 61;
	CurrentInstrCycles = 54; 
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	if (src == 0) {
		divbyzero_special (1, dst);
	m68k_incpci (4);
		Exception_cpu(5);
		goto l_341288;
	}
	CLEAR_CZNV ();
	if (dst == 0x80000000 && src == -1) {
		setdivsoverflowflags((uae_s32)dst, (uae_s16)src);
	} else {
		uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
		uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
		if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) {
			setdivsoverflowflags((uae_s32)dst, (uae_s16)src);
		} else {
			if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_NFLG (((uae_s16)(newv)) < 0);
			newv = (newv & 0xffff) | ((uae_u32)rem << 16);
			m68k_dreg (regs, dstreg) = (newv);
		}
	}
	m68k_incpci (4);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}l_341288: ;
return 54 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.B Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9000_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.B (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9010_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.B (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9018_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.B -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9020_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.B (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9028_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.B (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9030_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* SUB.B (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9038_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.B (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9039_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* SUB.B (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_903a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.B (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_903b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* SUB.B #<data>.B,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_903c_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}	m68k_incpci (4);
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.W Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9040_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.W An,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9048_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_areg (regs, srcreg);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.W (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9050_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.W (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9058_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.W -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9060_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.W (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9068_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.W (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9070_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* SUB.W (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9078_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.W (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9079_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* SUB.W (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_907a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.W (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_907b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* SUB.W #<data>.W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_907c_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.L Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9080_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.L An,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9088_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_areg (regs, srcreg);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.L (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9090_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.L (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9098_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.L -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_90a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.L (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_90a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.L (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_90b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* SUB.L (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_90b8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.L (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_90b9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* SUB.L (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_90ba_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.L (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_90bb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* SUB.L #<data>.L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_90bc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* SUBA.W Dn,An */
uae_u32 REGPARAM2 CPUFUNC(op_90c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBA.W An,An */
uae_u32 REGPARAM2 CPUFUNC(op_90c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_areg (regs, srcreg);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBA.W (An),An */
uae_u32 REGPARAM2 CPUFUNC(op_90d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBA.W (An)+,An */
uae_u32 REGPARAM2 CPUFUNC(op_90d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBA.W -(An),An */
uae_u32 REGPARAM2 CPUFUNC(op_90e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBA.W (d16,An),An */
uae_u32 REGPARAM2 CPUFUNC(op_90e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUBA.W (d8,An,Xn),An */
uae_u32 REGPARAM2 CPUFUNC(op_90f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_areg (regs, dstreg) = (newv);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* SUBA.W (xxx).W,An */
uae_u32 REGPARAM2 CPUFUNC(op_90f8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUBA.W (xxx).L,An */
uae_u32 REGPARAM2 CPUFUNC(op_90f9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* SUBA.W (d16,PC),An */
uae_u32 REGPARAM2 CPUFUNC(op_90fa_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUBA.W (d8,PC,Xn),An */
uae_u32 REGPARAM2 CPUFUNC(op_90fb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_areg (regs, dstreg) = (newv);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* SUBA.W #<data>.W,An */
uae_u32 REGPARAM2 CPUFUNC(op_90fc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (newv);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUBX.B Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9100_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 9;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = dst - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBX.B -(An),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_9108_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 9;
	CurrentInstrCycles = 9;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{	uae_u32 newv = dst - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 9 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.B Dn,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_9110_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.B Dn,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_9118_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.B Dn,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_9120_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.B Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_9128_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.B Dn,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_9130_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* SUB.B Dn,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_9138_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.B Dn,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_9139_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* SUBX.W Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9140_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 9;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = dst - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s16)(newv)) == 0));
	SET_NFLG (((uae_s16)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBX.W -(An),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_9148_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 9;
	CurrentInstrCycles = 9;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{	uae_u32 newv = dst - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s16)(newv)) == 0));
	SET_NFLG (((uae_s16)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 9 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.W Dn,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_9150_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.W Dn,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_9158_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.W Dn,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_9160_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.W Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_9168_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.W Dn,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_9170_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* SUB.W Dn,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_9178_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.W Dn,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_9179_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* SUBX.L Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_9180_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 9;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = dst - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s32)(newv)) == 0));
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBX.L -(An),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_9188_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 9;
	CurrentInstrCycles = 9;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{	uae_u32 newv = dst - src - (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_VFLG ((flgs ^ flgo) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgn) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s32)(newv)) == 0));
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 9 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.L Dn,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_9190_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.L Dn,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_9198_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.L Dn,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_91a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUB.L Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_91a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.L Dn,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_91b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* SUB.L Dn,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_91b8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUB.L Dn,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_91b9_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 7;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgo) & (flgn ^ flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* SUBA.L Dn,An */
uae_u32 REGPARAM2 CPUFUNC(op_91c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBA.L An,An */
uae_u32 REGPARAM2 CPUFUNC(op_91c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_areg (regs, srcreg);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBA.L (An),An */
uae_u32 REGPARAM2 CPUFUNC(op_91d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBA.L (An)+,An */
uae_u32 REGPARAM2 CPUFUNC(op_91d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBA.L -(An),An */
uae_u32 REGPARAM2 CPUFUNC(op_91e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* SUBA.L (d16,An),An */
uae_u32 REGPARAM2 CPUFUNC(op_91e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUBA.L (d8,An,Xn),An */
uae_u32 REGPARAM2 CPUFUNC(op_91f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_areg (regs, dstreg) = (newv);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* SUBA.L (xxx).W,An */
uae_u32 REGPARAM2 CPUFUNC(op_91f8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUBA.L (xxx).L,An */
uae_u32 REGPARAM2 CPUFUNC(op_91f9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* SUBA.L (d16,PC),An */
uae_u32 REGPARAM2 CPUFUNC(op_91fa_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* SUBA.L (d8,PC,Xn),An */
uae_u32 REGPARAM2 CPUFUNC(op_91fb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_areg (regs, dstreg) = (newv);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* SUBA.L #<data>.L,An */
uae_u32 REGPARAM2 CPUFUNC(op_91fc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 8;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst - src;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_areg (regs, dstreg) = (newv);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* CMP.B Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b000_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMP.B (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b010_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMP.B (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b018_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMP.B -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b020_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMP.B (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b028_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMP.B (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b030_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* CMP.B (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b038_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMP.B (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b039_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* CMP.B (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b03a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMP.B (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b03b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* CMP.B #<data>.B,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b03c_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}	m68k_incpci (4);
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMP.W Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b040_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMP.W An,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b048_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_areg (regs, srcreg);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMP.W (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b050_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMP.W (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b058_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMP.W -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b060_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMP.W (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b068_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMP.W (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b070_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* CMP.W (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b078_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMP.W (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b079_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* CMP.W (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b07a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMP.W (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b07b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* CMP.W #<data>.W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b07c_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMP.L Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b080_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMP.L An,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b088_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_areg (regs, srcreg);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMP.L (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b090_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMP.L (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b098_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMP.L -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b0a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif

#ifdef PART_7
/* CMP.L (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b0a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMP.L (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b0b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* CMP.L (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b0b8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMP.L (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b0b9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* CMP.L (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b0ba_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMP.L (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b0bb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* CMP.L #<data>.L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b0bc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 25;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* CMPA.W Dn,An */
uae_u32 REGPARAM2 CPUFUNC(op_b0c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMPA.W An,An */
uae_u32 REGPARAM2 CPUFUNC(op_b0c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_areg (regs, srcreg);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMPA.W (An),An */
uae_u32 REGPARAM2 CPUFUNC(op_b0d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMPA.W (An)+,An */
uae_u32 REGPARAM2 CPUFUNC(op_b0d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMPA.W -(An),An */
uae_u32 REGPARAM2 CPUFUNC(op_b0e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMPA.W (d16,An),An */
uae_u32 REGPARAM2 CPUFUNC(op_b0e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMPA.W (d8,An,Xn),An */
uae_u32 REGPARAM2 CPUFUNC(op_b0f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* CMPA.W (xxx).W,An */
uae_u32 REGPARAM2 CPUFUNC(op_b0f8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMPA.W (xxx).L,An */
uae_u32 REGPARAM2 CPUFUNC(op_b0f9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* CMPA.W (d16,PC),An */
uae_u32 REGPARAM2 CPUFUNC(op_b0fa_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMPA.W (d8,PC,Xn),An */
uae_u32 REGPARAM2 CPUFUNC(op_b0fb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* CMPA.W #<data>.W,An */
uae_u32 REGPARAM2 CPUFUNC(op_b0fc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* EOR.B Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b100_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMPM.B (An)+,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_b108_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 26;
	CurrentInstrCycles = 8;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
{{uae_u32 newv = ((uae_u8)(dst)) - ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u8)(src)) > ((uae_u8)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 8 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* EOR.B Dn,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_b110_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* EOR.B Dn,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_b118_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* EOR.B Dn,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_b120_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* EOR.B Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_b128_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* EOR.B Dn,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_b130_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* EOR.B Dn,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_b138_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* EOR.B Dn,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_b139_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* EOR.W Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b140_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMPM.W (An)+,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_b148_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 26;
	CurrentInstrCycles = 8;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
{{uae_u32 newv = ((uae_u16)(dst)) - ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u16)(src)) > ((uae_u16)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 8 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* EOR.W Dn,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_b150_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* EOR.W Dn,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_b158_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* EOR.W Dn,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_b160_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* EOR.W Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_b168_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* EOR.W Dn,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_b170_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* EOR.W Dn,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_b178_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* EOR.W Dn,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_b179_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* EOR.L Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_b180_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (src);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMPM.L (An)+,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_b188_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 26;
	CurrentInstrCycles = 8;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 8 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* EOR.L Dn,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_b190_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* EOR.L Dn,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_b198_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* EOR.L Dn,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_b1a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* EOR.L Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_b1a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* EOR.L Dn,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_b1b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* EOR.L Dn,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_b1b8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* EOR.L Dn,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_b1b9_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 3;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src ^= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* CMPA.L Dn,An */
uae_u32 REGPARAM2 CPUFUNC(op_b1c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMPA.L An,An */
uae_u32 REGPARAM2 CPUFUNC(op_b1c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_areg (regs, srcreg);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMPA.L (An),An */
uae_u32 REGPARAM2 CPUFUNC(op_b1d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMPA.L (An)+,An */
uae_u32 REGPARAM2 CPUFUNC(op_b1d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMPA.L -(An),An */
uae_u32 REGPARAM2 CPUFUNC(op_b1e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* CMPA.L (d16,An),An */
uae_u32 REGPARAM2 CPUFUNC(op_b1e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMPA.L (d8,An,Xn),An */
uae_u32 REGPARAM2 CPUFUNC(op_b1f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* CMPA.L (xxx).W,An */
uae_u32 REGPARAM2 CPUFUNC(op_b1f8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMPA.L (xxx).L,An */
uae_u32 REGPARAM2 CPUFUNC(op_b1f9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* CMPA.L (d16,PC),An */
uae_u32 REGPARAM2 CPUFUNC(op_b1fa_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* CMPA.L (d8,PC,Xn),An */
uae_u32 REGPARAM2 CPUFUNC(op_b1fb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* CMPA.L #<data>.L,An */
uae_u32 REGPARAM2 CPUFUNC(op_b1fc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 27;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) - ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs != flgo) && (flgn != flgo));
	SET_CFLG (((uae_u32)(src)) > ((uae_u32)(dst)));
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* AND.B Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c000_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.B (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c010_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.B (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c018_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.B -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c020_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.B (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c028_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.B (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c030_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* AND.B (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c038_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.B (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c039_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* AND.B (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c03a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.B (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c03b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* AND.B #<data>.B,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c03c_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}	m68k_incpci (4);
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.W Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c040_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.W (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c050_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.W (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c058_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.W -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c060_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.W (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c068_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.W (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c070_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* AND.W (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c078_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.W (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c079_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* AND.W (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c07a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.W (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c07b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* AND.W #<data>.W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c07c_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.L Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c080_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (src);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.L (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c090_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (src);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.L (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c098_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (src);
}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.L -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c0a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (src);
}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.L (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c0a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (src);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.L (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c0b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* AND.L (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c0b8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (src);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.L (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c0b9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (src);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* AND.L (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c0ba_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (src);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.L (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c0bb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* AND.L #<data>.L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c0bc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (src);
}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MULU.W Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c0c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 62;
	CurrentInstrCycles = 25; 
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (newv);
	m68k_incpci (2);
}}}}return 25 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MULU.W (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c0d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 62;
	CurrentInstrCycles = 25; 
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (newv);
	m68k_incpci (2);
}}}}}return 25 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MULU.W (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c0d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 62;
	CurrentInstrCycles = 25; 
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (newv);
	m68k_incpci (2);
}}}}}	mmufixup[0].reg = -1;
return 25 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MULU.W -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c0e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 62;
	CurrentInstrCycles = 25; 
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (newv);
	m68k_incpci (2);
}}}}}	mmufixup[0].reg = -1;
return 25 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MULU.W (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c0e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 62;
	CurrentInstrCycles = 25; 
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (newv);
	m68k_incpci (4);
}}}}}return 25 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MULU.W (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c0f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 62;
	CurrentInstrCycles = 25; 
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}return 25 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MULU.W (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c0f8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 62;
	CurrentInstrCycles = 25; 
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (newv);
	m68k_incpci (4);
}}}}}return 25 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MULU.W (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c0f9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 62;
	CurrentInstrCycles = 25; 
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (newv);
	m68k_incpci (6);
}}}}}return 25 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MULU.W (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c0fa_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 62;
	CurrentInstrCycles = 25; 
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (newv);
	m68k_incpci (4);
}}}}}return 25 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MULU.W (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c0fb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 62;
	CurrentInstrCycles = 25; 
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}return 25 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MULU.W #<data>.W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c0fc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 62;
	CurrentInstrCycles = 25; 
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (newv);
	m68k_incpci (4);
}}}}return 25 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ABCD.B Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c100_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 14;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{	uae_u16 newv_lo = (src & 0xF) + (dst & 0xF) + (GET_XFLG () ? 1 : 0);
	uae_u16 newv_hi = (src & 0xF0) + (dst & 0xF0);
	uae_u16 newv, tmp_newv;
	int cflg;
	newv = tmp_newv = newv_hi + newv_lo;	if (newv_lo > 9) { newv += 6; }
	cflg = (newv & 0x3F0) > 0x90;
	if (cflg) newv += 0x60;
	SET_CFLG (cflg);
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ABCD.B -(An),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_c108_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 14;
	CurrentInstrCycles = 13; 
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{	uae_u16 newv_lo = (src & 0xF) + (dst & 0xF) + (GET_XFLG () ? 1 : 0);
	uae_u16 newv_hi = (src & 0xF0) + (dst & 0xF0);
	uae_u16 newv, tmp_newv;
	int cflg;
	newv = tmp_newv = newv_hi + newv_lo;	if (newv_lo > 9) { newv += 6; }
	cflg = (newv & 0x3F0) > 0x90;
	if (cflg) newv += 0x60;
	SET_CFLG (cflg);
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 13 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.B Dn,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_c110_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.B Dn,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_c118_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.B Dn,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_c120_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.B Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_c128_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.B Dn,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_c130_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* AND.B Dn,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_c138_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.B Dn,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_c139_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s8)(src)) == 0);
	SET_NFLG (((uae_s8)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* EXG.L Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c140_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 35;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (dst);
	m68k_dreg (regs, dstreg) = (src);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* EXG.L An,An */
uae_u32 REGPARAM2 CPUFUNC(op_c148_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 35;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_areg (regs, srcreg);
{	uae_s32 dst = m68k_areg (regs, dstreg);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, srcreg) = (dst);
	m68k_areg (regs, dstreg) = (src);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.W Dn,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_c150_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.W Dn,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_c158_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.W Dn,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_c160_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.W Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_c168_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.W Dn,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_c170_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* AND.W Dn,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_c178_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.W Dn,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_c179_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(src)) == 0);
	SET_NFLG (((uae_s16)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* EXG.L Dn,An */
uae_u32 REGPARAM2 CPUFUNC(op_c188_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 35;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_areg (regs, dstreg);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, srcreg) = (dst);
	m68k_areg (regs, dstreg) = (src);
}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.L Dn,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_c190_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.L Dn,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_c198_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.L Dn,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_c1a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* AND.L Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_c1a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.L Dn,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_c1b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* AND.L Dn,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_c1b8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* AND.L Dn,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_c1b9_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 2;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	src &= dst;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(src)) == 0);
	SET_NFLG (((uae_s32)(src)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, src);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MULS.W Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c1c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 63;
	CurrentInstrCycles = 25; 
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (newv);
}}}}	m68k_incpci (2);
return 25 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MULS.W (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c1d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 63;
	CurrentInstrCycles = 25; 
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (2);
return 25 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MULS.W (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c1d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 63;
	CurrentInstrCycles = 25; 
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 25 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MULS.W -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c1e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 63;
	CurrentInstrCycles = 25; 
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 25 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* MULS.W (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c1e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 63;
	CurrentInstrCycles = 25; 
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (4);
return 25 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MULS.W (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c1f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 63;
	CurrentInstrCycles = 25; 
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}return 25 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MULS.W (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c1f8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 63;
	CurrentInstrCycles = 25; 
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (4);
return 25 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MULS.W (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c1f9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 63;
	CurrentInstrCycles = 25; 
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (6);
return 25 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* MULS.W (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c1fa_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 63;
	CurrentInstrCycles = 25; 
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (4);
return 25 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* MULS.W (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c1fb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 63;
	CurrentInstrCycles = 25; 
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}return 25 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* MULS.W #<data>.W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_c1fc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 63;
	CurrentInstrCycles = 25; 
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (newv);
}}}}	m68k_incpci (4);
return 25 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.B Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d000_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.B (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d010_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.B (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d018_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.B -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d020_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.B (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d028_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.B (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d030_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* ADD.B (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d038_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.B (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d039_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ADD.B (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d03a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.B (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d03b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s8 src = get_byte_mmu030c_state (srca);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* ADD.B #<data>.B,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d03c_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 8;  
{{	uae_s8 src = (uae_u8)get_iword_mmu030c_state (2);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}	m68k_incpci (4);
return 8 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.W Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d040_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.W An,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d048_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_areg (regs, srcreg);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.W (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d050_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.W (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d058_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.W -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d060_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.W (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d068_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.W (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d070_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* ADD.W (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d078_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.W (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d079_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ADD.W (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d07a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.W (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d07b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* ADD.W #<data>.W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d07c_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.L Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d080_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.L An,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d088_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_areg (regs, srcreg);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.L (An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d090_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.L (An)+,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d098_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.L -(An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d0a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.L (d16,An),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d0a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.L (d8,An,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d0b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* ADD.L (xxx).W,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d0b8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.L (xxx).L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d0b9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ADD.L (d16,PC),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d0ba_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.L (d8,PC,Xn),Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d0bb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* ADD.L #<data>.L,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d0bc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ADDA.W Dn,An */
uae_u32 REGPARAM2 CPUFUNC(op_d0c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDA.W An,An */
uae_u32 REGPARAM2 CPUFUNC(op_d0c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_areg (regs, srcreg);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDA.W (An),An */
uae_u32 REGPARAM2 CPUFUNC(op_d0d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDA.W (An)+,An */
uae_u32 REGPARAM2 CPUFUNC(op_d0d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDA.W -(An),An */
uae_u32 REGPARAM2 CPUFUNC(op_d0e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDA.W (d16,An),An */
uae_u32 REGPARAM2 CPUFUNC(op_d0e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADDA.W (d8,An,Xn),An */
uae_u32 REGPARAM2 CPUFUNC(op_d0f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_areg (regs, dstreg) = (newv);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* ADDA.W (xxx).W,An */
uae_u32 REGPARAM2 CPUFUNC(op_d0f8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADDA.W (xxx).L,An */
uae_u32 REGPARAM2 CPUFUNC(op_d0f9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ADDA.W (d16,PC),An */
uae_u32 REGPARAM2 CPUFUNC(op_d0fa_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADDA.W (d8,PC,Xn),An */
uae_u32 REGPARAM2 CPUFUNC(op_d0fb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s16 src = get_word_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_areg (regs, dstreg) = (newv);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* ADDA.W #<data>.W,An */
uae_u32 REGPARAM2 CPUFUNC(op_d0fc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = get_iword_mmu030c_state (2);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (newv);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADDX.B Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d100_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 13;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uae_s8 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = dst + src + (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgo) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDX.B -(An),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_d108_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 13;
	CurrentInstrCycles = 9;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - areg_byteinc[srcreg];
{	uae_s8 src = get_byte_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{	uae_u32 newv = dst + src + (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgo) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s8)(newv)) == 0));
	SET_NFLG (((uae_s8)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 9 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.B Dn,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_d110_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.B Dn,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_d118_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += areg_byteinc[dstreg];
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.B Dn,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_d120_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - areg_byteinc[dstreg];
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.B Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_d128_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.B Dn,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_d130_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* ADD.B Dn,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_d138_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.B Dn,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_d139_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s8 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s8 dst = get_byte_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u8)(dst)) + ((uae_u8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	SET_ZFLG (((uae_s8)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u8)(~dst)) < ((uae_u8)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_byte_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ADDX.W Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d140_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 13;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uae_s16 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = dst + src + (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgo) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s16)(newv)) == 0));
	SET_NFLG (((uae_s16)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDX.W -(An),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_d148_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 13;
	CurrentInstrCycles = 9;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 2;
{	uae_s16 src = get_word_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{	uae_u32 newv = dst + src + (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgo) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s16)(newv)) == 0));
	SET_NFLG (((uae_s16)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 9 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.W Dn,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_d150_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.W Dn,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_d158_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 2;
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.W Dn,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_d160_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 2;
{	uae_s16 dst = get_word_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.W Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_d168_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.W Dn,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_d170_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* ADD.W Dn,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_d178_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.W Dn,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_d179_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s16 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s16 dst = get_word_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u16)(dst)) + ((uae_u16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	SET_ZFLG (((uae_s16)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u16)(~dst)) < ((uae_u16)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ADDX.L Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_d180_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 13;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_dreg (regs, dstreg);
{	uae_u32 newv = dst + src + (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgo) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s32)(newv)) == 0));
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDX.L -(An),-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_d188_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 13;
	CurrentInstrCycles = 9;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[1].reg = dstreg;
	mmufixup[1].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{	uae_u32 newv = dst + src + (GET_XFLG () ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (flgs ^ ((flgs ^ flgo) & (flgo ^ flgn)));
	COPY_CARRY ();
	SET_ZFLG (GET_ZFLG () & (((uae_s32)(newv)) == 0));
	SET_NFLG (((uae_s32)(newv)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
	mmufixup[1].reg = -1;
return 9 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.L Dn,(An) */
uae_u32 REGPARAM2 CPUFUNC(op_d190_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.L Dn,(An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_d198_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) += 4;
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.L Dn,-(An) */
uae_u32 REGPARAM2 CPUFUNC(op_d1a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) - 4;
{	uae_s32 dst = get_long_mmu030c_state (dsta);
	mmufixup[0].reg = dstreg;
	mmufixup[0].value = m68k_areg (regs, dstreg);
	m68k_areg (regs, dstreg) = dsta;
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADD.L Dn,(d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_d1a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.L Dn,(d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_d1b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	m68k_incpci (2);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* ADD.L Dn,(xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_d1b8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADD.L Dn,(xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_d1b9_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	OpcodeFamily = 11;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (2);
{	uae_s32 dst = get_long_mmu030c_state (dsta);
{{uae_u32 newv = ((uae_u32)(dst)) + ((uae_u32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	SET_ZFLG (((uae_s32)(newv)) == 0);
	SET_VFLG ((flgs ^ flgn) & (flgo ^ flgn));
	SET_CFLG (((uae_u32)(~dst)) < ((uae_u32)(src)));
	COPY_CARRY ();
	SET_NFLG (flgn != 0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_long_mmu030c_state (dsta, newv);
}}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ADDA.L Dn,An */
uae_u32 REGPARAM2 CPUFUNC(op_d1c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_dreg (regs, srcreg);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDA.L An,An */
uae_u32 REGPARAM2 CPUFUNC(op_d1c8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uae_s32 src = m68k_areg (regs, srcreg);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDA.L (An),An */
uae_u32 REGPARAM2 CPUFUNC(op_d1d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDA.L (An)+,An */
uae_u32 REGPARAM2 CPUFUNC(op_d1d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg);
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDA.L -(An),An */
uae_u32 REGPARAM2 CPUFUNC(op_d1e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) - 4;
{	uae_s32 src = get_long_mmu030c_state (srca);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (2);
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ADDA.L (d16,An),An */
uae_u32 REGPARAM2 CPUFUNC(op_d1e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADDA.L (d8,An,Xn),An */
uae_u32 REGPARAM2 CPUFUNC(op_d1f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	m68k_incpci (2);
{	srca = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_areg (regs, dstreg) = (newv);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* ADDA.L (xxx).W,An */
uae_u32 REGPARAM2 CPUFUNC(op_d1f8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADDA.L (xxx).L,An */
uae_u32 REGPARAM2 CPUFUNC(op_d1f9_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = get_ilong_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ADDA.L (d16,PC),An */
uae_u32 REGPARAM2 CPUFUNC(op_d1fa_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uaecptr srca;
	srca = m68k_getpci () + 2;
	srca += (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_areg (regs, dstreg) = (newv);
}}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ADDA.L (d8,PC,Xn),An */
uae_u32 REGPARAM2 CPUFUNC(op_d1fb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uaecptr tmppc;
	uaecptr srca;
	m68k_incpci (2);
{	tmppc = m68k_getpci ();
	srca = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_s32 src = get_long_mmu030c_state (srca);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (0);
	m68k_areg (regs, dstreg) = (newv);
}}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* ADDA.L #<data>.L,An */
uae_u32 REGPARAM2 CPUFUNC(op_d1fc_34)(uae_u32 opcode)
{
	uae_u32 dstreg = (opcode >> 9) & 7;
	OpcodeFamily = 12;
	CurrentInstrCycles = 4;  
{{	uae_s32 src;
	src = get_ilong_mmu030c_state (2);
{	uae_s32 dst = m68k_areg (regs, dstreg);
{	uae_u32 newv = dst + src;
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_areg (regs, dstreg) = (newv);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ASRQ.B #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e000_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 64;
	CurrentInstrCycles = 6;  
{{	uae_u32 cnt = srcreg;
{	uae_s8 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u8)data;
	uae_u32 sign = (0x80 & val) >> 7;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 8) {
		val = 0xff & (uae_u32)-sign;
		SET_CFLG (sign);
		COPY_CARRY ();
	} else {
		val >>= cnt - 1;
		SET_CFLG (val & 1);
		COPY_CARRY ();
		val >>= 1;
		val |= (0xff << (8 - cnt)) & (uae_u32)-sign;
		val &= 0xff;
	}
	SET_ZFLG (((uae_s8)(val)) == 0);
	SET_NFLG (((uae_s8)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* LSRQ.B #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e008_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 66;
	CurrentInstrCycles = 4;  
{{	uae_u32 cnt = srcreg;
{	uae_s8 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u8)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 8) {
		SET_CFLG ((cnt == 8) & (val >> 7));
		COPY_CARRY ();
		val = 0;
	} else {
		val >>= cnt - 1;
		SET_CFLG (val & 1);
		COPY_CARRY ();
		val >>= 1;
	}
	SET_ZFLG (((uae_s8)(val)) == 0);
	SET_NFLG (((uae_s8)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROXRQ.B #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e010_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 71;
	CurrentInstrCycles = 12; 
{{	uae_u32 cnt = srcreg;
{	uae_s8 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u8)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
{	cnt--;
	{
	uae_u32 carry;
	uae_u32 hival = (val << 1) | GET_XFLG ();
	hival <<= (7 - cnt);
	val >>= cnt;
	carry = val & 1;
	val >>= 1;
	val |= hival;
	SET_XFLG (carry);
	val &= 0xff;
	} }
	SET_CFLG (GET_XFLG ());
	SET_ZFLG (((uae_s8)(val)) == 0);
	SET_NFLG (((uae_s8)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 12 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* RORQ.B #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e018_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 69;
	CurrentInstrCycles = 6;  
{{	uae_u32 cnt = srcreg;
{	uae_s8 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u8)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
{	uae_u32 hival;
	cnt &= 7;
	hival = val << (8 - cnt);
	val >>= cnt;
	val |= hival;
	val &= 0xff;
	SET_CFLG ((val & 0x80) >> 7);
	}
	SET_ZFLG (((uae_s8)(val)) == 0);
	SET_NFLG (((uae_s8)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ASR.B Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e020_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 64;
	CurrentInstrCycles = 6;  
{{	uae_s8 cnt = m68k_dreg (regs, srcreg);
{	uae_s8 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u8)data;
	uae_u32 sign = (0x80 & val) >> 7;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 8) {
		val = 0xff & (uae_u32)-sign;
		SET_CFLG (sign);
		COPY_CARRY ();
	} else if (cnt > 0) {
		val >>= cnt - 1;
		SET_CFLG (val & 1);
		COPY_CARRY ();
		val >>= 1;
		val |= (0xff << (8 - cnt)) & (uae_u32)-sign;
		val &= 0xff;
	}
	SET_ZFLG (((uae_s8)(val)) == 0);
	SET_NFLG (((uae_s8)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* LSR.B Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e028_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 66;
	CurrentInstrCycles = 6;  
{{	uae_s8 cnt = m68k_dreg (regs, srcreg);
{	uae_s8 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u8)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 8) {
		SET_CFLG ((cnt == 8) & (val >> 7));
		COPY_CARRY ();
		val = 0;
	} else if (cnt > 0) {
		val >>= cnt - 1;
		SET_CFLG (val & 1);
		COPY_CARRY ();
		val >>= 1;
	}
	SET_ZFLG (((uae_s8)(val)) == 0);
	SET_NFLG (((uae_s8)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROXR.B Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e030_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 71;
	CurrentInstrCycles = 12; 
{{	uae_s8 cnt = m68k_dreg (regs, srcreg);
{	uae_s8 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u8)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 36) cnt -= 36;
	if (cnt >= 18) cnt -= 18;
	if (cnt >= 9) cnt -= 9;
	if (cnt > 0) {
	cnt--;
	{
	uae_u32 carry;
	uae_u32 hival = (val << 1) | GET_XFLG ();
	hival <<= (7 - cnt);
	val >>= cnt;
	carry = val & 1;
	val >>= 1;
	val |= hival;
	SET_XFLG (carry);
	val &= 0xff;
	} }
	SET_CFLG (GET_XFLG ());
	SET_ZFLG (((uae_s8)(val)) == 0);
	SET_NFLG (((uae_s8)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 12 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROR.B Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e038_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 69;
	CurrentInstrCycles = 8;  
{{	uae_s8 cnt = m68k_dreg (regs, srcreg);
{	uae_s8 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u8)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt > 0) {	uae_u32 hival;
	cnt &= 7;
	hival = val << (8 - cnt);
	val >>= cnt;
	val |= hival;
	val &= 0xff;
	SET_CFLG ((val & 0x80) >> 7);
	}
	SET_ZFLG (((uae_s8)(val)) == 0);
	SET_NFLG (((uae_s8)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 8 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ASRQ.W #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e040_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 64;
	CurrentInstrCycles = 6;  
{{	uae_u32 cnt = srcreg;
{	uae_s16 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u16)data;
	uae_u32 sign = (0x8000 & val) >> 15;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 16) {
		val = 0xffff & (uae_u32)-sign;
		SET_CFLG (sign);
		COPY_CARRY ();
	} else {
		val >>= cnt - 1;
		SET_CFLG (val & 1);
		COPY_CARRY ();
		val >>= 1;
		val |= (0xffff << (16 - cnt)) & (uae_u32)-sign;
		val &= 0xffff;
	}
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((val) & 0xffff);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

#endif

#ifdef PART_8
/* LSRQ.W #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e048_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 66;
	CurrentInstrCycles = 4;  
{{	uae_u32 cnt = srcreg;
{	uae_s16 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u16)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 16) {
		SET_CFLG ((cnt == 16) & (val >> 15));
		COPY_CARRY ();
		val = 0;
	} else {
		val >>= cnt - 1;
		SET_CFLG (val & 1);
		COPY_CARRY ();
		val >>= 1;
	}
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((val) & 0xffff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROXRQ.W #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e050_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 71;
	CurrentInstrCycles = 12; 
{{	uae_u32 cnt = srcreg;
{	uae_s16 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u16)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
{	cnt--;
	{
	uae_u32 carry;
	uae_u32 hival = (val << 1) | GET_XFLG ();
	hival <<= (15 - cnt);
	val >>= cnt;
	carry = val & 1;
	val >>= 1;
	val |= hival;
	SET_XFLG (carry);
	val &= 0xffff;
	} }
	SET_CFLG (GET_XFLG ());
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((val) & 0xffff);
}}}}	m68k_incpci (2);
return 12 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* RORQ.W #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e058_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 69;
	CurrentInstrCycles = 6;  
{{	uae_u32 cnt = srcreg;
{	uae_s16 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u16)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
{	uae_u32 hival;
	cnt &= 15;
	hival = val << (16 - cnt);
	val >>= cnt;
	val |= hival;
	val &= 0xffff;
	SET_CFLG ((val & 0x8000) >> 15);
	}
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((val) & 0xffff);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ASR.W Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e060_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 64;
	CurrentInstrCycles = 6;  
{{	uae_s16 cnt = m68k_dreg (regs, srcreg);
{	uae_s16 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u16)data;
	uae_u32 sign = (0x8000 & val) >> 15;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 16) {
		val = 0xffff & (uae_u32)-sign;
		SET_CFLG (sign);
		COPY_CARRY ();
	} else if (cnt > 0) {
		val >>= cnt - 1;
		SET_CFLG (val & 1);
		COPY_CARRY ();
		val >>= 1;
		val |= (0xffff << (16 - cnt)) & (uae_u32)-sign;
		val &= 0xffff;
	}
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((val) & 0xffff);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* LSR.W Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e068_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 66;
	CurrentInstrCycles = 6;  
{{	uae_s16 cnt = m68k_dreg (regs, srcreg);
{	uae_s16 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u16)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 16) {
		SET_CFLG ((cnt == 16) & (val >> 15));
		COPY_CARRY ();
		val = 0;
	} else if (cnt > 0) {
		val >>= cnt - 1;
		SET_CFLG (val & 1);
		COPY_CARRY ();
		val >>= 1;
	}
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((val) & 0xffff);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROXR.W Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e070_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 71;
	CurrentInstrCycles = 12; 
{{	uae_s16 cnt = m68k_dreg (regs, srcreg);
{	uae_s16 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u16)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 34) cnt -= 34;
	if (cnt >= 17) cnt -= 17;
	if (cnt > 0) {
	cnt--;
	{
	uae_u32 carry;
	uae_u32 hival = (val << 1) | GET_XFLG ();
	hival <<= (15 - cnt);
	val >>= cnt;
	carry = val & 1;
	val >>= 1;
	val |= hival;
	SET_XFLG (carry);
	val &= 0xffff;
	} }
	SET_CFLG (GET_XFLG ());
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((val) & 0xffff);
}}}}	m68k_incpci (2);
return 12 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROR.W Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e078_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 69;
	CurrentInstrCycles = 8;  
{{	uae_s16 cnt = m68k_dreg (regs, srcreg);
{	uae_s16 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u16)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt > 0) {	uae_u32 hival;
	cnt &= 15;
	hival = val << (16 - cnt);
	val >>= cnt;
	val |= hival;
	val &= 0xffff;
	SET_CFLG ((val & 0x8000) >> 15);
	}
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((val) & 0xffff);
}}}}	m68k_incpci (2);
return 8 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ASRQ.L #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e080_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 64;
	CurrentInstrCycles = 6;  
{{	uae_u32 cnt = srcreg;
{	uae_s32 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = data;
	uae_u32 sign = (0x80000000 & val) >> 31;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 32) {
		val = 0xffffffff & (uae_u32)-sign;
		SET_CFLG (sign);
		COPY_CARRY ();
	} else {
		val >>= cnt - 1;
		SET_CFLG (val & 1);
		COPY_CARRY ();
		val >>= 1;
		val |= (0xffffffff << (32 - cnt)) & (uae_u32)-sign;
		val &= 0xffffffff;
	}
	SET_ZFLG (((uae_s32)(val)) == 0);
	SET_NFLG (((uae_s32)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (val);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* LSRQ.L #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e088_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 66;
	CurrentInstrCycles = 4;  
{{	uae_u32 cnt = srcreg;
{	uae_s32 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 32) {
		SET_CFLG ((cnt == 32) & (val >> 31));
		COPY_CARRY ();
		val = 0;
	} else {
		val >>= cnt - 1;
		SET_CFLG (val & 1);
		COPY_CARRY ();
		val >>= 1;
	}
	SET_ZFLG (((uae_s32)(val)) == 0);
	SET_NFLG (((uae_s32)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (val);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROXRQ.L #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e090_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 71;
	CurrentInstrCycles = 12; 
{{	uae_u32 cnt = srcreg;
{	uae_s32 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
{	cnt--;
	{
	uae_u32 carry;
	uae_u32 hival = (val << 1) | GET_XFLG ();
	hival <<= (31 - cnt);
	val >>= cnt;
	carry = val & 1;
	val >>= 1;
	val |= hival;
	SET_XFLG (carry);
	val &= 0xffffffff;
	} }
	SET_CFLG (GET_XFLG ());
	SET_ZFLG (((uae_s32)(val)) == 0);
	SET_NFLG (((uae_s32)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (val);
}}}}	m68k_incpci (2);
return 12 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* RORQ.L #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e098_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 69;
	CurrentInstrCycles = 6;  
{{	uae_u32 cnt = srcreg;
{	uae_s32 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
{	uae_u32 hival;
	cnt &= 31;
	hival = val << (32 - cnt);
	val >>= cnt;
	val |= hival;
	val &= 0xffffffff;
	SET_CFLG ((val & 0x80000000) >> 31);
	}
	SET_ZFLG (((uae_s32)(val)) == 0);
	SET_NFLG (((uae_s32)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (val);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ASR.L Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e0a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 64;
	CurrentInstrCycles = 6;  
{{	uae_s32 cnt = m68k_dreg (regs, srcreg);
{	uae_s32 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = data;
	uae_u32 sign = (0x80000000 & val) >> 31;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 32) {
		val = 0xffffffff & (uae_u32)-sign;
		SET_CFLG (sign);
		COPY_CARRY ();
	} else if (cnt > 0) {
		val >>= cnt - 1;
		SET_CFLG (val & 1);
		COPY_CARRY ();
		val >>= 1;
		val |= (0xffffffff << (32 - cnt)) & (uae_u32)-sign;
		val &= 0xffffffff;
	}
	SET_ZFLG (((uae_s32)(val)) == 0);
	SET_NFLG (((uae_s32)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (val);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* LSR.L Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e0a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 66;
	CurrentInstrCycles = 6;  
{{	uae_s32 cnt = m68k_dreg (regs, srcreg);
{	uae_s32 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 32) {
		SET_CFLG ((cnt == 32) & (val >> 31));
		COPY_CARRY ();
		val = 0;
	} else if (cnt > 0) {
		val >>= cnt - 1;
		SET_CFLG (val & 1);
		COPY_CARRY ();
		val >>= 1;
	}
	SET_ZFLG (((uae_s32)(val)) == 0);
	SET_NFLG (((uae_s32)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (val);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROXR.L Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e0b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 71;
	CurrentInstrCycles = 12; 
{{	uae_s32 cnt = m68k_dreg (regs, srcreg);
{	uae_s32 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 33) cnt -= 33;
	if (cnt > 0) {
	cnt--;
	{
	uae_u32 carry;
	uae_u32 hival = (val << 1) | GET_XFLG ();
	hival <<= (31 - cnt);
	val >>= cnt;
	carry = val & 1;
	val >>= 1;
	val |= hival;
	SET_XFLG (carry);
	val &= 0xffffffff;
	} }
	SET_CFLG (GET_XFLG ());
	SET_ZFLG (((uae_s32)(val)) == 0);
	SET_NFLG (((uae_s32)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (val);
}}}}	m68k_incpci (2);
return 12 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROR.L Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e0b8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 69;
	CurrentInstrCycles = 8;  
{{	uae_s32 cnt = m68k_dreg (regs, srcreg);
{	uae_s32 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt > 0) {	uae_u32 hival;
	cnt &= 31;
	hival = val << (32 - cnt);
	val >>= cnt;
	val |= hival;
	val &= 0xffffffff;
	SET_CFLG ((val & 0x80000000) >> 31);
	}
	SET_ZFLG (((uae_s32)(val)) == 0);
	SET_NFLG (((uae_s32)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (val);
}}}}	m68k_incpci (2);
return 8 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ASRW.W (An) */
uae_u32 REGPARAM2 CPUFUNC(op_e0d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 72;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u32 val = (uae_u16)data;
	uae_u32 sign = 0x8000 & val;
	uae_u32 cflg = val & 1;
	val = (val >> 1) | sign;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (cflg);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ASRW.W (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_e0d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 72;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg);
{	uae_s16 data = get_word_mmu030c_state (dataa);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_u32 val = (uae_u16)data;
	uae_u32 sign = 0x8000 & val;
	uae_u32 cflg = val & 1;
	val = (val >> 1) | sign;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (cflg);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ASRW.W -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_e0e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 72;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg) - 2;
{	uae_s16 data = get_word_mmu030c_state (dataa);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = dataa;
{	uae_u32 val = (uae_u16)data;
	uae_u32 sign = 0x8000 & val;
	uae_u32 cflg = val & 1;
	val = (val >> 1) | sign;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (cflg);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ASRW.W (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_e0e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 72;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u32 val = (uae_u16)data;
	uae_u32 sign = 0x8000 & val;
	uae_u32 cflg = val & 1;
	val = (val >> 1) | sign;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (cflg);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ASRW.W (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_e0f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 72;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	m68k_incpci (2);
{	dataa = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u32 val = (uae_u16)data;
	uae_u32 sign = 0x8000 & val;
	uae_u32 cflg = val & 1;
	val = (val >> 1) | sign;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (cflg);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* ASRW.W (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_e0f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 72;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u32 val = (uae_u16)data;
	uae_u32 sign = 0x8000 & val;
	uae_u32 cflg = val & 1;
	val = (val >> 1) | sign;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (cflg);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ASRW.W (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_e0f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 72;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = get_ilong_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u32 val = (uae_u16)data;
	uae_u32 sign = 0x8000 & val;
	uae_u32 cflg = val & 1;
	val = (val >> 1) | sign;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (cflg);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ASLQ.B #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e100_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 65;
	CurrentInstrCycles = 6;  
{{	uae_u32 cnt = srcreg;
{	uae_s8 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u8)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 8) {
		SET_VFLG (val != 0);
		SET_CFLG (cnt == 8 ? val & 1 : 0);
		COPY_CARRY ();
		val = 0;
	} else {
		uae_u32 mask = (0xff << (7 - cnt)) & 0xff;
		SET_VFLG ((val & mask) != mask && (val & mask) != 0);
		val <<= cnt - 1;
		SET_CFLG ((val & 0x80) >> 7);
		COPY_CARRY ();
		val <<= 1;
		val &= 0xff;
	}
	SET_ZFLG (((uae_s8)(val)) == 0);
	SET_NFLG (((uae_s8)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* LSLQ.B #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e108_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 67;
	CurrentInstrCycles = 4;  
{{	uae_u32 cnt = srcreg;
{	uae_s8 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u8)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 8) {
		SET_CFLG (cnt == 8 ? val & 1 : 0);
		COPY_CARRY ();
		val = 0;
	} else {
		val <<= (cnt - 1);
		SET_CFLG ((val & 0x80) >> 7);
		COPY_CARRY ();
		val <<= 1;
	val &= 0xff;
	}
	SET_ZFLG (((uae_s8)(val)) == 0);
	SET_NFLG (((uae_s8)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROXLQ.B #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e110_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 70;
	CurrentInstrCycles = 12; 
{{	uae_u32 cnt = srcreg;
{	uae_s8 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u8)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
{	cnt--;
	{
	uae_u32 carry;
	uae_u32 loval = val >> (7 - cnt);
	carry = loval & 1;
	val = (((val << 1) | GET_XFLG ()) << cnt) | (loval >> 1);
	SET_XFLG (carry);
	val &= 0xff;
	} }
	SET_CFLG (GET_XFLG ());
	SET_ZFLG (((uae_s8)(val)) == 0);
	SET_NFLG (((uae_s8)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 12 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROLQ.B #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e118_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 68;
	CurrentInstrCycles = 6;  
{{	uae_u32 cnt = srcreg;
{	uae_s8 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u8)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
{	uae_u32 loval;
	cnt &= 7;
	loval = val >> (8 - cnt);
	val <<= cnt;
	val |= loval;
	val &= 0xff;
	SET_CFLG (val & 1);
}
	SET_ZFLG (((uae_s8)(val)) == 0);
	SET_NFLG (((uae_s8)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ASL.B Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e120_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 65;
	CurrentInstrCycles = 6;  
{{	uae_s8 cnt = m68k_dreg (regs, srcreg);
{	uae_s8 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u8)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 8) {
		SET_VFLG (val != 0);
		SET_CFLG (cnt == 8 ? val & 1 : 0);
		COPY_CARRY ();
		val = 0;
	} else if (cnt > 0) {
		uae_u32 mask = (0xff << (7 - cnt)) & 0xff;
		SET_VFLG ((val & mask) != mask && (val & mask) != 0);
		val <<= cnt - 1;
		SET_CFLG ((val & 0x80) >> 7);
		COPY_CARRY ();
		val <<= 1;
		val &= 0xff;
	}
	SET_ZFLG (((uae_s8)(val)) == 0);
	SET_NFLG (((uae_s8)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* LSL.B Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e128_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 67;
	CurrentInstrCycles = 6;  
{{	uae_s8 cnt = m68k_dreg (regs, srcreg);
{	uae_s8 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u8)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 8) {
		SET_CFLG (cnt == 8 ? val & 1 : 0);
		COPY_CARRY ();
		val = 0;
	} else if (cnt > 0) {
		val <<= (cnt - 1);
		SET_CFLG ((val & 0x80) >> 7);
		COPY_CARRY ();
		val <<= 1;
	val &= 0xff;
	}
	SET_ZFLG (((uae_s8)(val)) == 0);
	SET_NFLG (((uae_s8)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROXL.B Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e130_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 70;
	CurrentInstrCycles = 12; 
{{	uae_s8 cnt = m68k_dreg (regs, srcreg);
{	uae_s8 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u8)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 36) cnt -= 36;
	if (cnt >= 18) cnt -= 18;
	if (cnt >= 9) cnt -= 9;
	if (cnt > 0) {
	cnt--;
	{
	uae_u32 carry;
	uae_u32 loval = val >> (7 - cnt);
	carry = loval & 1;
	val = (((val << 1) | GET_XFLG ()) << cnt) | (loval >> 1);
	SET_XFLG (carry);
	val &= 0xff;
	} }
	SET_CFLG (GET_XFLG ());
	SET_ZFLG (((uae_s8)(val)) == 0);
	SET_NFLG (((uae_s8)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 12 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROL.B Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e138_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 68;
	CurrentInstrCycles = 8;  
{{	uae_s8 cnt = m68k_dreg (regs, srcreg);
{	uae_s8 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u8)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt > 0) {
	uae_u32 loval;
	cnt &= 7;
	loval = val >> (8 - cnt);
	val <<= cnt;
	val |= loval;
	val &= 0xff;
	SET_CFLG (val & 1);
}
	SET_ZFLG (((uae_s8)(val)) == 0);
	SET_NFLG (((uae_s8)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xff) | ((val) & 0xff);
}}}}	m68k_incpci (2);
return 8 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ASLQ.W #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e140_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 65;
	CurrentInstrCycles = 6;  
{{	uae_u32 cnt = srcreg;
{	uae_s16 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u16)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 16) {
		SET_VFLG (val != 0);
		SET_CFLG (cnt == 16 ? val & 1 : 0);
		COPY_CARRY ();
		val = 0;
	} else {
		uae_u32 mask = (0xffff << (15 - cnt)) & 0xffff;
		SET_VFLG ((val & mask) != mask && (val & mask) != 0);
		val <<= cnt - 1;
		SET_CFLG ((val & 0x8000) >> 15);
		COPY_CARRY ();
		val <<= 1;
		val &= 0xffff;
	}
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((val) & 0xffff);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* LSLQ.W #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e148_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 67;
	CurrentInstrCycles = 4;  
{{	uae_u32 cnt = srcreg;
{	uae_s16 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u16)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 16) {
		SET_CFLG (cnt == 16 ? val & 1 : 0);
		COPY_CARRY ();
		val = 0;
	} else {
		val <<= (cnt - 1);
		SET_CFLG ((val & 0x8000) >> 15);
		COPY_CARRY ();
		val <<= 1;
	val &= 0xffff;
	}
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((val) & 0xffff);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROXLQ.W #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e150_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 70;
	CurrentInstrCycles = 12; 
{{	uae_u32 cnt = srcreg;
{	uae_s16 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u16)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
{	cnt--;
	{
	uae_u32 carry;
	uae_u32 loval = val >> (15 - cnt);
	carry = loval & 1;
	val = (((val << 1) | GET_XFLG ()) << cnt) | (loval >> 1);
	SET_XFLG (carry);
	val &= 0xffff;
	} }
	SET_CFLG (GET_XFLG ());
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((val) & 0xffff);
}}}}	m68k_incpci (2);
return 12 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROLQ.W #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e158_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 68;
	CurrentInstrCycles = 6;  
{{	uae_u32 cnt = srcreg;
{	uae_s16 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u16)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
{	uae_u32 loval;
	cnt &= 15;
	loval = val >> (16 - cnt);
	val <<= cnt;
	val |= loval;
	val &= 0xffff;
	SET_CFLG (val & 1);
}
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((val) & 0xffff);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ASL.W Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e160_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 65;
	CurrentInstrCycles = 6;  
{{	uae_s16 cnt = m68k_dreg (regs, srcreg);
{	uae_s16 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u16)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 16) {
		SET_VFLG (val != 0);
		SET_CFLG (cnt == 16 ? val & 1 : 0);
		COPY_CARRY ();
		val = 0;
	} else if (cnt > 0) {
		uae_u32 mask = (0xffff << (15 - cnt)) & 0xffff;
		SET_VFLG ((val & mask) != mask && (val & mask) != 0);
		val <<= cnt - 1;
		SET_CFLG ((val & 0x8000) >> 15);
		COPY_CARRY ();
		val <<= 1;
		val &= 0xffff;
	}
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((val) & 0xffff);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* LSL.W Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e168_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 67;
	CurrentInstrCycles = 6;  
{{	uae_s16 cnt = m68k_dreg (regs, srcreg);
{	uae_s16 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u16)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 16) {
		SET_CFLG (cnt == 16 ? val & 1 : 0);
		COPY_CARRY ();
		val = 0;
	} else if (cnt > 0) {
		val <<= (cnt - 1);
		SET_CFLG ((val & 0x8000) >> 15);
		COPY_CARRY ();
		val <<= 1;
	val &= 0xffff;
	}
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((val) & 0xffff);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROXL.W Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e170_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 70;
	CurrentInstrCycles = 12; 
{{	uae_s16 cnt = m68k_dreg (regs, srcreg);
{	uae_s16 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u16)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 34) cnt -= 34;
	if (cnt >= 17) cnt -= 17;
	if (cnt > 0) {
	cnt--;
	{
	uae_u32 carry;
	uae_u32 loval = val >> (15 - cnt);
	carry = loval & 1;
	val = (((val << 1) | GET_XFLG ()) << cnt) | (loval >> 1);
	SET_XFLG (carry);
	val &= 0xffff;
	} }
	SET_CFLG (GET_XFLG ());
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((val) & 0xffff);
}}}}	m68k_incpci (2);
return 12 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROL.W Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e178_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 68;
	CurrentInstrCycles = 8;  
{{	uae_s16 cnt = m68k_dreg (regs, srcreg);
{	uae_s16 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = (uae_u16)data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt > 0) {
	uae_u32 loval;
	cnt &= 15;
	loval = val >> (16 - cnt);
	val <<= cnt;
	val |= loval;
	val &= 0xffff;
	SET_CFLG (val & 1);
}
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (m68k_dreg (regs, dstreg) & ~0xffff) | ((val) & 0xffff);
}}}}	m68k_incpci (2);
return 8 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ASLQ.L #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e180_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 65;
	CurrentInstrCycles = 6;  
{{	uae_u32 cnt = srcreg;
{	uae_s32 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 32) {
		SET_VFLG (val != 0);
		SET_CFLG (cnt == 32 ? val & 1 : 0);
		COPY_CARRY ();
		val = 0;
	} else {
		uae_u32 mask = (0xffffffff << (31 - cnt)) & 0xffffffff;
		SET_VFLG ((val & mask) != mask && (val & mask) != 0);
		val <<= cnt - 1;
		SET_CFLG ((val & 0x80000000) >> 31);
		COPY_CARRY ();
		val <<= 1;
		val &= 0xffffffff;
	}
	SET_ZFLG (((uae_s32)(val)) == 0);
	SET_NFLG (((uae_s32)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (val);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* LSLQ.L #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e188_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 67;
	CurrentInstrCycles = 4;  
{{	uae_u32 cnt = srcreg;
{	uae_s32 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 32) {
		SET_CFLG (cnt == 32 ? val & 1 : 0);
		COPY_CARRY ();
		val = 0;
	} else {
		val <<= (cnt - 1);
		SET_CFLG ((val & 0x80000000) >> 31);
		COPY_CARRY ();
		val <<= 1;
	val &= 0xffffffff;
	}
	SET_ZFLG (((uae_s32)(val)) == 0);
	SET_NFLG (((uae_s32)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (val);
}}}}	m68k_incpci (2);
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROXLQ.L #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e190_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 70;
	CurrentInstrCycles = 12; 
{{	uae_u32 cnt = srcreg;
{	uae_s32 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
{	cnt--;
	{
	uae_u32 carry;
	uae_u32 loval = val >> (31 - cnt);
	carry = loval & 1;
	val = (((val << 1) | GET_XFLG ()) << cnt) | (loval >> 1);
	SET_XFLG (carry);
	val &= 0xffffffff;
	} }
	SET_CFLG (GET_XFLG ());
	SET_ZFLG (((uae_s32)(val)) == 0);
	SET_NFLG (((uae_s32)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (val);
}}}}	m68k_incpci (2);
return 12 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROLQ.L #<data>,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e198_34)(uae_u32 opcode)
{
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 68;
	CurrentInstrCycles = 6;  
{{	uae_u32 cnt = srcreg;
{	uae_s32 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
{	uae_u32 loval;
	cnt &= 31;
	loval = val >> (32 - cnt);
	val <<= cnt;
	val |= loval;
	val &= 0xffffffff;
	SET_CFLG (val & 1);
}
	SET_ZFLG (((uae_s32)(val)) == 0);
	SET_NFLG (((uae_s32)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (val);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ASL.L Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e1a0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 65;
	CurrentInstrCycles = 6;  
{{	uae_s32 cnt = m68k_dreg (regs, srcreg);
{	uae_s32 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 32) {
		SET_VFLG (val != 0);
		SET_CFLG (cnt == 32 ? val & 1 : 0);
		COPY_CARRY ();
		val = 0;
	} else if (cnt > 0) {
		uae_u32 mask = (0xffffffff << (31 - cnt)) & 0xffffffff;
		SET_VFLG ((val & mask) != mask && (val & mask) != 0);
		val <<= cnt - 1;
		SET_CFLG ((val & 0x80000000) >> 31);
		COPY_CARRY ();
		val <<= 1;
		val &= 0xffffffff;
	}
	SET_ZFLG (((uae_s32)(val)) == 0);
	SET_NFLG (((uae_s32)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (val);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* LSL.L Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e1a8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 67;
	CurrentInstrCycles = 6;  
{{	uae_s32 cnt = m68k_dreg (regs, srcreg);
{	uae_s32 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 32) {
		SET_CFLG (cnt == 32 ? val & 1 : 0);
		COPY_CARRY ();
		val = 0;
	} else if (cnt > 0) {
		val <<= (cnt - 1);
		SET_CFLG ((val & 0x80000000) >> 31);
		COPY_CARRY ();
		val <<= 1;
	val &= 0xffffffff;
	}
	SET_ZFLG (((uae_s32)(val)) == 0);
	SET_NFLG (((uae_s32)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (val);
}}}}	m68k_incpci (2);
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROXL.L Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e1b0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 70;
	CurrentInstrCycles = 12; 
{{	uae_s32 cnt = m68k_dreg (regs, srcreg);
{	uae_s32 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt >= 33) cnt -= 33;
	if (cnt > 0) {
	cnt--;
	{
	uae_u32 carry;
	uae_u32 loval = val >> (31 - cnt);
	carry = loval & 1;
	val = (((val << 1) | GET_XFLG ()) << cnt) | (loval >> 1);
	SET_XFLG (carry);
	val &= 0xffffffff;
	} }
	SET_CFLG (GET_XFLG ());
	SET_ZFLG (((uae_s32)(val)) == 0);
	SET_NFLG (((uae_s32)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (val);
}}}}	m68k_incpci (2);
return 12 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROL.L Dn,Dn */
uae_u32 REGPARAM2 CPUFUNC(op_e1b8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = ((opcode >> 9) & 7);
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 68;
	CurrentInstrCycles = 8;  
{{	uae_s32 cnt = m68k_dreg (regs, srcreg);
{	uae_s32 data = m68k_dreg (regs, dstreg);
{	uae_u32 val = data;
	int ccnt = cnt & 63;
	cnt &= 63;
	CLEAR_CZNV ();
	if (cnt > 0) {
	uae_u32 loval;
	cnt &= 31;
	loval = val >> (32 - cnt);
	val <<= cnt;
	val |= loval;
	val &= 0xffffffff;
	SET_CFLG (val & 1);
}
	SET_ZFLG (((uae_s32)(val)) == 0);
	SET_NFLG (((uae_s32)(val)) < 0);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_dreg (regs, dstreg) = (val);
}}}}	m68k_incpci (2);
return 8 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ASLW.W (An) */
uae_u32 REGPARAM2 CPUFUNC(op_e1d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 73;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u32 val = (uae_u16)data;
	uae_u32 sign = 0x8000 & val;
	uae_u32 sign2;
	val <<= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	sign2 = 0x8000 & val;
	SET_CFLG (sign != 0);
	COPY_CARRY ();
	SET_VFLG (GET_VFLG () | (sign2 != sign));
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ASLW.W (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_e1d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 73;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg);
{	uae_s16 data = get_word_mmu030c_state (dataa);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_u32 val = (uae_u16)data;
	uae_u32 sign = 0x8000 & val;
	uae_u32 sign2;
	val <<= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	sign2 = 0x8000 & val;
	SET_CFLG (sign != 0);
	COPY_CARRY ();
	SET_VFLG (GET_VFLG () | (sign2 != sign));
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ASLW.W -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_e1e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 73;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg) - 2;
{	uae_s16 data = get_word_mmu030c_state (dataa);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = dataa;
{	uae_u32 val = (uae_u16)data;
	uae_u32 sign = 0x8000 & val;
	uae_u32 sign2;
	val <<= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	sign2 = 0x8000 & val;
	SET_CFLG (sign != 0);
	COPY_CARRY ();
	SET_VFLG (GET_VFLG () | (sign2 != sign));
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ASLW.W (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_e1e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 73;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u32 val = (uae_u16)data;
	uae_u32 sign = 0x8000 & val;
	uae_u32 sign2;
	val <<= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	sign2 = 0x8000 & val;
	SET_CFLG (sign != 0);
	COPY_CARRY ();
	SET_VFLG (GET_VFLG () | (sign2 != sign));
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ASLW.W (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_e1f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 73;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	m68k_incpci (2);
{	dataa = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u32 val = (uae_u16)data;
	uae_u32 sign = 0x8000 & val;
	uae_u32 sign2;
	val <<= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	sign2 = 0x8000 & val;
	SET_CFLG (sign != 0);
	COPY_CARRY ();
	SET_VFLG (GET_VFLG () | (sign2 != sign));
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* ASLW.W (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_e1f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 73;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u32 val = (uae_u16)data;
	uae_u32 sign = 0x8000 & val;
	uae_u32 sign2;
	val <<= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	sign2 = 0x8000 & val;
	SET_CFLG (sign != 0);
	COPY_CARRY ();
	SET_VFLG (GET_VFLG () | (sign2 != sign));
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ASLW.W (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_e1f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 73;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = get_ilong_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u32 val = (uae_u16)data;
	uae_u32 sign = 0x8000 & val;
	uae_u32 sign2;
	val <<= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	sign2 = 0x8000 & val;
	SET_CFLG (sign != 0);
	COPY_CARRY ();
	SET_VFLG (GET_VFLG () | (sign2 != sign));
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* LSRW.W (An) */
uae_u32 REGPARAM2 CPUFUNC(op_e2d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 74;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u32 val = (uae_u16)data;
	uae_u32 carry = val & 1;
	val >>= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* LSRW.W (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_e2d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 74;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg);
{	uae_s16 data = get_word_mmu030c_state (dataa);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_u32 val = (uae_u16)data;
	uae_u32 carry = val & 1;
	val >>= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* LSRW.W -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_e2e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 74;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg) - 2;
{	uae_s16 data = get_word_mmu030c_state (dataa);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = dataa;
{	uae_u32 val = (uae_u16)data;
	uae_u32 carry = val & 1;
	val >>= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* LSRW.W (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_e2e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 74;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u32 val = (uae_u16)data;
	uae_u32 carry = val & 1;
	val >>= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* LSRW.W (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_e2f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 74;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	m68k_incpci (2);
{	dataa = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u32 val = (uae_u16)data;
	uae_u32 carry = val & 1;
	val >>= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* LSRW.W (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_e2f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 74;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u32 val = (uae_u16)data;
	uae_u32 carry = val & 1;
	val >>= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* LSRW.W (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_e2f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 74;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = get_ilong_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u32 val = (uae_u16)data;
	uae_u32 carry = val & 1;
	val >>= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* LSLW.W (An) */
uae_u32 REGPARAM2 CPUFUNC(op_e3d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 75;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 0x8000;
	val <<= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry >> 15);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* LSLW.W (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_e3d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 75;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg);
{	uae_s16 data = get_word_mmu030c_state (dataa);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_u16 val = data;
	uae_u32 carry = val & 0x8000;
	val <<= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry >> 15);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* LSLW.W -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_e3e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 75;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg) - 2;
{	uae_s16 data = get_word_mmu030c_state (dataa);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = dataa;
{	uae_u16 val = data;
	uae_u32 carry = val & 0x8000;
	val <<= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry >> 15);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* LSLW.W (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_e3e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 75;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 0x8000;
	val <<= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry >> 15);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* LSLW.W (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_e3f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 75;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	m68k_incpci (2);
{	dataa = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 0x8000;
	val <<= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry >> 15);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* LSLW.W (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_e3f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 75;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 0x8000;
	val <<= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry >> 15);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* LSLW.W (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_e3f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 75;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = get_ilong_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 0x8000;
	val <<= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry >> 15);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ROXRW.W (An) */
uae_u32 REGPARAM2 CPUFUNC(op_e4d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 79;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 1;
	val >>= 1;
	if (GET_XFLG ()) val |= 0x8000;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROXRW.W (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_e4d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 79;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg);
{	uae_s16 data = get_word_mmu030c_state (dataa);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_u16 val = data;
	uae_u32 carry = val & 1;
	val >>= 1;
	if (GET_XFLG ()) val |= 0x8000;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROXRW.W -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_e4e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 79;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg) - 2;
{	uae_s16 data = get_word_mmu030c_state (dataa);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = dataa;
{	uae_u16 val = data;
	uae_u32 carry = val & 1;
	val >>= 1;
	if (GET_XFLG ()) val |= 0x8000;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROXRW.W (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_e4e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 79;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 1;
	val >>= 1;
	if (GET_XFLG ()) val |= 0x8000;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ROXRW.W (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_e4f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 79;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	m68k_incpci (2);
{	dataa = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 1;
	val >>= 1;
	if (GET_XFLG ()) val |= 0x8000;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* ROXRW.W (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_e4f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 79;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 1;
	val >>= 1;
	if (GET_XFLG ()) val |= 0x8000;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ROXRW.W (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_e4f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 79;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = get_ilong_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 1;
	val >>= 1;
	if (GET_XFLG ()) val |= 0x8000;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ROXLW.W (An) */
uae_u32 REGPARAM2 CPUFUNC(op_e5d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 78;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 0x8000;
	val <<= 1;
	if (GET_XFLG ()) val |= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry >> 15);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROXLW.W (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_e5d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 78;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg);
{	uae_s16 data = get_word_mmu030c_state (dataa);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_u16 val = data;
	uae_u32 carry = val & 0x8000;
	val <<= 1;
	if (GET_XFLG ()) val |= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry >> 15);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROXLW.W -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_e5e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 78;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg) - 2;
{	uae_s16 data = get_word_mmu030c_state (dataa);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = dataa;
{	uae_u16 val = data;
	uae_u32 carry = val & 0x8000;
	val <<= 1;
	if (GET_XFLG ()) val |= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry >> 15);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROXLW.W (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_e5e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 78;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 0x8000;
	val <<= 1;
	if (GET_XFLG ()) val |= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry >> 15);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ROXLW.W (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_e5f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 78;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	m68k_incpci (2);
{	dataa = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 0x8000;
	val <<= 1;
	if (GET_XFLG ()) val |= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry >> 15);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* ROXLW.W (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_e5f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 78;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 0x8000;
	val <<= 1;
	if (GET_XFLG ()) val |= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry >> 15);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ROXLW.W (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_e5f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 78;
	CurrentInstrCycles = 4;  
{{	uaecptr dataa;
	dataa = get_ilong_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 0x8000;
	val <<= 1;
	if (GET_XFLG ()) val |= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry >> 15);
	COPY_CARRY ();
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* RORW.W (An) */
uae_u32 REGPARAM2 CPUFUNC(op_e6d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 77;
	CurrentInstrCycles = 6;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 1;
	val >>= 1;
	if (carry) val |= 0x8000;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* RORW.W (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_e6d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 77;
	CurrentInstrCycles = 6;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg);
{	uae_s16 data = get_word_mmu030c_state (dataa);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_u16 val = data;
	uae_u32 carry = val & 1;
	val >>= 1;
	if (carry) val |= 0x8000;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}	mmufixup[0].reg = -1;
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* RORW.W -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_e6e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 77;
	CurrentInstrCycles = 6;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg) - 2;
{	uae_s16 data = get_word_mmu030c_state (dataa);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = dataa;
{	uae_u16 val = data;
	uae_u32 carry = val & 1;
	val >>= 1;
	if (carry) val |= 0x8000;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}	mmufixup[0].reg = -1;
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* RORW.W (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_e6e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 77;
	CurrentInstrCycles = 6;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 1;
	val >>= 1;
	if (carry) val |= 0x8000;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* RORW.W (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_e6f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 77;
	CurrentInstrCycles = 6;  
{{	uaecptr dataa;
	m68k_incpci (2);
{	dataa = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 1;
	val >>= 1;
	if (carry) val |= 0x8000;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}}return 6 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* RORW.W (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_e6f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 77;
	CurrentInstrCycles = 6;  
{{	uaecptr dataa;
	dataa = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 1;
	val >>= 1;
	if (carry) val |= 0x8000;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* RORW.W (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_e6f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 77;
	CurrentInstrCycles = 6;  
{{	uaecptr dataa;
	dataa = get_ilong_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 1;
	val >>= 1;
	if (carry) val |= 0x8000;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* ROLW.W (An) */
uae_u32 REGPARAM2 CPUFUNC(op_e7d0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 76;
	CurrentInstrCycles = 6;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 0x8000;
	val <<= 1;
	if (carry)  val |= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry >> 15);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROLW.W (An)+ */
uae_u32 REGPARAM2 CPUFUNC(op_e7d8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 76;
	CurrentInstrCycles = 6;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg);
{	uae_s16 data = get_word_mmu030c_state (dataa);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 2;
{	uae_u16 val = data;
	uae_u32 carry = val & 0x8000;
	val <<= 1;
	if (carry)  val |= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry >> 15);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}	mmufixup[0].reg = -1;
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROLW.W -(An) */
uae_u32 REGPARAM2 CPUFUNC(op_e7e0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 76;
	CurrentInstrCycles = 6;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg) - 2;
{	uae_s16 data = get_word_mmu030c_state (dataa);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = dataa;
{	uae_u16 val = data;
	uae_u32 carry = val & 0x8000;
	val <<= 1;
	if (carry)  val |= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry >> 15);
	regs.irc = get_iword_mmu030c_opcode_state (2);
	m68k_incpci (2);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}	mmufixup[0].reg = -1;
return 6 * CYCLE_UNIT / 2;
}
/* 2 0,0   */

/* ROLW.W (d16,An) */
uae_u32 REGPARAM2 CPUFUNC(op_e7e8_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 76;
	CurrentInstrCycles = 6;  
{{	uaecptr dataa;
	dataa = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 0x8000;
	val <<= 1;
	if (carry)  val |= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry >> 15);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ROLW.W (d8,An,Xn) */
uae_u32 REGPARAM2 CPUFUNC(op_e7f0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 76;
	CurrentInstrCycles = 6;  
{{	uaecptr dataa;
	m68k_incpci (2);
{	dataa = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 0x8000;
	val <<= 1;
	if (carry)  val |= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry >> 15);
	regs.irc = get_iword_mmu030c_opcode_state (0);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}}return 6 * CYCLE_UNIT / 2;
}
/* 2 2,0   */

/* ROLW.W (xxx).W */
uae_u32 REGPARAM2 CPUFUNC(op_e7f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 76;
	CurrentInstrCycles = 6;  
{{	uaecptr dataa;
	dataa = (uae_s32)(uae_s16)get_iword_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 0x8000;
	val <<= 1;
	if (carry)  val |= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry >> 15);
	regs.irc = get_iword_mmu030c_opcode_state (4);
	m68k_incpci (4);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

/* ROLW.W (xxx).L */
uae_u32 REGPARAM2 CPUFUNC(op_e7f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 76;
	CurrentInstrCycles = 6;  
{{	uaecptr dataa;
	dataa = get_ilong_mmu030c_state (2);
{	uae_s16 data = get_word_mmu030c_state (dataa);
{	uae_u16 val = data;
	uae_u32 carry = val & 0x8000;
	val <<= 1;
	if (carry)  val |= 1;
	CLEAR_CZNV ();
	SET_ZFLG (((uae_s16)(val)) == 0);
	SET_NFLG (((uae_s16)(val)) < 0);
	SET_CFLG (carry >> 15);
	regs.irc = get_iword_mmu030c_opcode_state (6);
	m68k_incpci (6);
	regs.instruction_pc = m68k_getpci ();
	mmu030_state[1] |= MMU030_STATEFLAG1_LASTWRITE;
	put_word_mmu030c_state (dataa, val);
}}}}return 6 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

/* BFTST.L #<data>.W,Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_e8c0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 88;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp = m68k_dreg(regs, dstreg);
	offset &= 0x1f;
	tmp = (tmp << offset) | (tmp >> (32 - offset));
	bdata[0] = tmp & ((1 << (32 - width)) - 1);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* BFTST.L #<data>.W,(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_e8d0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 88;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* BFTST.L #<data>.W,(d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_e8e8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 88;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* BFTST.L #<data>.W,(d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_e8f0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 88;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* BFTST.L #<data>.W,(xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_e8f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 88;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* BFTST.L #<data>.W,(xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_e8f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 88;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	regs.irc = get_iword_mmu030c_opcode_state (8);
}}}}	m68k_incpci (8);
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* BFTST.L #<data>.W,(d16,PC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_e8fa_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 2;
	OpcodeFamily = 88;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_getpci () + 4;
	dsta += (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* BFTST.L #<data>.W,(d8,PC,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_e8fb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 3;
	OpcodeFamily = 88;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr tmppc;
	uaecptr dsta;
	m68k_incpci (4);
{	tmppc = m68k_getpci ();
	dsta = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* BFEXTU.L #<data>.W,Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_e9c0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 89;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp = m68k_dreg(regs, dstreg);
	offset &= 0x1f;
	tmp = (tmp << offset) | (tmp >> (32 - offset));
	bdata[0] = tmp & ((1 << (32 - width)) - 1);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	m68k_dreg (regs, (extra >> 12) & 7) = tmp;
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* BFEXTU.L #<data>.W,(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_e9d0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 89;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	m68k_dreg (regs, (extra >> 12) & 7) = tmp;
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* BFEXTU.L #<data>.W,(d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_e9e8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 89;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	m68k_dreg (regs, (extra >> 12) & 7) = tmp;
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* BFEXTU.L #<data>.W,(d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_e9f0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 89;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	m68k_dreg (regs, (extra >> 12) & 7) = tmp;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* BFEXTU.L #<data>.W,(xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_e9f8_34)(uae_u32 opcode)
{
	OpcodeFamily = 89;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	m68k_dreg (regs, (extra >> 12) & 7) = tmp;
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* BFEXTU.L #<data>.W,(xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_e9f9_34)(uae_u32 opcode)
{
	OpcodeFamily = 89;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	m68k_dreg (regs, (extra >> 12) & 7) = tmp;
	regs.irc = get_iword_mmu030c_opcode_state (8);
}}}}	m68k_incpci (8);
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* BFEXTU.L #<data>.W,(d16,PC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_e9fa_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 2;
	OpcodeFamily = 89;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_getpci () + 4;
	dsta += (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	m68k_dreg (regs, (extra >> 12) & 7) = tmp;
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* BFEXTU.L #<data>.W,(d8,PC,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_e9fb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 3;
	OpcodeFamily = 89;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr tmppc;
	uaecptr dsta;
	m68k_incpci (4);
{	tmppc = m68k_getpci ();
	dsta = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	m68k_dreg (regs, (extra >> 12) & 7) = tmp;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* BFCHG.L #<data>.W,Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_eac0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 90;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp = m68k_dreg(regs, dstreg);
	offset &= 0x1f;
	tmp = (tmp << offset) | (tmp >> (32 - offset));
	bdata[0] = tmp & ((1 << (32 - width)) - 1);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = tmp ^ (0xffffffffu >> (32 - width));
	tmp = bdata[0] | (tmp << (32 - width));
	m68k_dreg(regs, dstreg) = (tmp >> offset) | (tmp << (32 - offset));
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* BFCHG.L #<data>.W,(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_ead0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 90;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = tmp ^ (0xffffffffu >> (32 - width));
	x_put_bitfield(dsta, bdata, tmp, offset, width);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* BFCHG.L #<data>.W,(d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_eae8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 90;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = tmp ^ (0xffffffffu >> (32 - width));
	x_put_bitfield(dsta, bdata, tmp, offset, width);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* BFCHG.L #<data>.W,(d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_eaf0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 90;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = tmp ^ (0xffffffffu >> (32 - width));
	x_put_bitfield(dsta, bdata, tmp, offset, width);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* BFCHG.L #<data>.W,(xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_eaf8_34)(uae_u32 opcode)
{
	OpcodeFamily = 90;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = tmp ^ (0xffffffffu >> (32 - width));
	x_put_bitfield(dsta, bdata, tmp, offset, width);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* BFCHG.L #<data>.W,(xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_eaf9_34)(uae_u32 opcode)
{
	OpcodeFamily = 90;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = tmp ^ (0xffffffffu >> (32 - width));
	x_put_bitfield(dsta, bdata, tmp, offset, width);
	regs.irc = get_iword_mmu030c_opcode_state (8);
}}}}	m68k_incpci (8);
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* BFEXTS.L #<data>.W,Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_ebc0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 91;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp = m68k_dreg(regs, dstreg);
	offset &= 0x1f;
	tmp = (tmp << offset) | (tmp >> (32 - offset));
	bdata[0] = tmp & ((1 << (32 - width)) - 1);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp = (uae_s32)tmp >> (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	m68k_dreg (regs, (extra >> 12) & 7) = tmp;
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* BFEXTS.L #<data>.W,(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_ebd0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 91;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp = (uae_s32)tmp >> (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	m68k_dreg (regs, (extra >> 12) & 7) = tmp;
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* BFEXTS.L #<data>.W,(d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_ebe8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 91;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp = (uae_s32)tmp >> (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	m68k_dreg (regs, (extra >> 12) & 7) = tmp;
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* BFEXTS.L #<data>.W,(d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_ebf0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 91;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp = (uae_s32)tmp >> (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	m68k_dreg (regs, (extra >> 12) & 7) = tmp;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* BFEXTS.L #<data>.W,(xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_ebf8_34)(uae_u32 opcode)
{
	OpcodeFamily = 91;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp = (uae_s32)tmp >> (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	m68k_dreg (regs, (extra >> 12) & 7) = tmp;
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* BFEXTS.L #<data>.W,(xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_ebf9_34)(uae_u32 opcode)
{
	OpcodeFamily = 91;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp = (uae_s32)tmp >> (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	m68k_dreg (regs, (extra >> 12) & 7) = tmp;
	regs.irc = get_iword_mmu030c_opcode_state (8);
}}}}	m68k_incpci (8);
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* BFEXTS.L #<data>.W,(d16,PC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_ebfa_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 2;
	OpcodeFamily = 91;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_getpci () + 4;
	dsta += (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp = (uae_s32)tmp >> (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	m68k_dreg (regs, (extra >> 12) & 7) = tmp;
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* BFEXTS.L #<data>.W,(d8,PC,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_ebfb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 3;
	OpcodeFamily = 91;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr tmppc;
	uaecptr dsta;
	m68k_incpci (4);
{	tmppc = m68k_getpci ();
	dsta = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp = (uae_s32)tmp >> (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	m68k_dreg (regs, (extra >> 12) & 7) = tmp;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* BFCLR.L #<data>.W,Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_ecc0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 92;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp = m68k_dreg(regs, dstreg);
	offset &= 0x1f;
	tmp = (tmp << offset) | (tmp >> (32 - offset));
	bdata[0] = tmp & ((1 << (32 - width)) - 1);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = 0;
	tmp = bdata[0] | (tmp << (32 - width));
	m68k_dreg(regs, dstreg) = (tmp >> offset) | (tmp << (32 - offset));
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* BFCLR.L #<data>.W,(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_ecd0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 92;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = 0;
	x_put_bitfield(dsta, bdata, tmp, offset, width);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* BFCLR.L #<data>.W,(d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_ece8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 92;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = 0;
	x_put_bitfield(dsta, bdata, tmp, offset, width);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* BFCLR.L #<data>.W,(d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_ecf0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 92;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = 0;
	x_put_bitfield(dsta, bdata, tmp, offset, width);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* BFCLR.L #<data>.W,(xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_ecf8_34)(uae_u32 opcode)
{
	OpcodeFamily = 92;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = 0;
	x_put_bitfield(dsta, bdata, tmp, offset, width);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* BFCLR.L #<data>.W,(xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_ecf9_34)(uae_u32 opcode)
{
	OpcodeFamily = 92;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = 0;
	x_put_bitfield(dsta, bdata, tmp, offset, width);
	regs.irc = get_iword_mmu030c_opcode_state (8);
}}}}	m68k_incpci (8);
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* BFFFO.L #<data>.W,Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_edc0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 93;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 offset2 = offset;
	uae_u32 tmp = m68k_dreg(regs, dstreg);
	offset &= 0x1f;
	tmp = (tmp << offset) | (tmp >> (32 - offset));
	bdata[0] = tmp & ((1 << (32 - width)) - 1);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	{ uae_u32 mask = 1 << (width - 1);
	while (mask) { if (tmp & mask) break; mask >>= 1; offset2++; }}
	m68k_dreg (regs, (extra >> 12) & 7) = offset2;
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* BFFFO.L #<data>.W,(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_edd0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 93;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 offset2 = offset;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	{ uae_u32 mask = 1 << (width - 1);
	while (mask) { if (tmp & mask) break; mask >>= 1; offset2++; }}
	m68k_dreg (regs, (extra >> 12) & 7) = offset2;
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* BFFFO.L #<data>.W,(d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_ede8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 93;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 offset2 = offset;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	{ uae_u32 mask = 1 << (width - 1);
	while (mask) { if (tmp & mask) break; mask >>= 1; offset2++; }}
	m68k_dreg (regs, (extra >> 12) & 7) = offset2;
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* BFFFO.L #<data>.W,(d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_edf0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 93;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 offset2 = offset;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	{ uae_u32 mask = 1 << (width - 1);
	while (mask) { if (tmp & mask) break; mask >>= 1; offset2++; }}
	m68k_dreg (regs, (extra >> 12) & 7) = offset2;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* BFFFO.L #<data>.W,(xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_edf8_34)(uae_u32 opcode)
{
	OpcodeFamily = 93;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 offset2 = offset;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	{ uae_u32 mask = 1 << (width - 1);
	while (mask) { if (tmp & mask) break; mask >>= 1; offset2++; }}
	m68k_dreg (regs, (extra >> 12) & 7) = offset2;
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* BFFFO.L #<data>.W,(xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_edf9_34)(uae_u32 opcode)
{
	OpcodeFamily = 93;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 offset2 = offset;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	{ uae_u32 mask = 1 << (width - 1);
	while (mask) { if (tmp & mask) break; mask >>= 1; offset2++; }}
	m68k_dreg (regs, (extra >> 12) & 7) = offset2;
	regs.irc = get_iword_mmu030c_opcode_state (8);
}}}}	m68k_incpci (8);
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* BFFFO.L #<data>.W,(d16,PC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_edfa_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 2;
	OpcodeFamily = 93;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_getpci () + 4;
	dsta += (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 offset2 = offset;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	{ uae_u32 mask = 1 << (width - 1);
	while (mask) { if (tmp & mask) break; mask >>= 1; offset2++; }}
	m68k_dreg (regs, (extra >> 12) & 7) = offset2;
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* BFFFO.L #<data>.W,(d8,PC,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_edfb_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 3;
	OpcodeFamily = 93;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr tmppc;
	uaecptr dsta;
	m68k_incpci (4);
{	tmppc = m68k_getpci ();
	dsta = get_disp_ea_020_mmu030c (tmppc, 0);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 offset2 = offset;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	{ uae_u32 mask = 1 << (width - 1);
	while (mask) { if (tmp & mask) break; mask >>= 1; offset2++; }}
	m68k_dreg (regs, (extra >> 12) & 7) = offset2;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* BFSET.L #<data>.W,Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_eec0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 94;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp = m68k_dreg(regs, dstreg);
	offset &= 0x1f;
	tmp = (tmp << offset) | (tmp >> (32 - offset));
	bdata[0] = tmp & ((1 << (32 - width)) - 1);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = 0xffffffffu >> (32 - width);
	tmp = bdata[0] | (tmp << (32 - width));
	m68k_dreg(regs, dstreg) = (tmp >> offset) | (tmp << (32 - offset));
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* BFSET.L #<data>.W,(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_eed0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 94;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = 0xffffffffu >> (32 - width);
	x_put_bitfield(dsta, bdata, tmp, offset, width);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* BFSET.L #<data>.W,(d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_eee8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 94;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = 0xffffffffu >> (32 - width);
	x_put_bitfield(dsta, bdata, tmp, offset, width);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* BFSET.L #<data>.W,(d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_eef0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 94;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = 0xffffffffu >> (32 - width);
	x_put_bitfield(dsta, bdata, tmp, offset, width);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* BFSET.L #<data>.W,(xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_eef8_34)(uae_u32 opcode)
{
	OpcodeFamily = 94;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = 0xffffffffu >> (32 - width);
	x_put_bitfield(dsta, bdata, tmp, offset, width);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* BFSET.L #<data>.W,(xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_eef9_34)(uae_u32 opcode)
{
	OpcodeFamily = 94;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = 0xffffffffu >> (32 - width);
	x_put_bitfield(dsta, bdata, tmp, offset, width);
	regs.irc = get_iword_mmu030c_opcode_state (8);
}}}}	m68k_incpci (8);
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* BFINS.L #<data>.W,Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_efc0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 95;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp = m68k_dreg(regs, dstreg);
	offset &= 0x1f;
	tmp = (tmp << offset) | (tmp >> (32 - offset));
	bdata[0] = tmp & ((1 << (32 - width)) - 1);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = m68k_dreg (regs, (extra >> 12) & 7);
	tmp = tmp & (0xffffffffu >> (32 - width));
	SET_NFLG (tmp & (1 << (width - 1)) ? 1 : 0);
	SET_ZFLG (tmp == 0);
	tmp = bdata[0] | (tmp << (32 - width));
	m68k_dreg(regs, dstreg) = (tmp >> offset) | (tmp << (32 - offset));
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* BFINS.L #<data>.W,(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_efd0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 95;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = m68k_dreg (regs, (extra >> 12) & 7);
	tmp = tmp & (0xffffffffu >> (32 - width));
	SET_NFLG (tmp & (1 << (width - 1)) ? 1 : 0);
	SET_ZFLG (tmp == 0);
	x_put_bitfield(dsta, bdata, tmp, offset, width);
	regs.irc = get_iword_mmu030c_opcode_state (4);
}}}}	m68k_incpci (4);
return 4 * CYCLE_UNIT / 2;
}
/* 4 0,0   */

#endif
/* BFINS.L #<data>.W,(d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_efe8_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 95;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = m68k_areg (regs, dstreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = m68k_dreg (regs, (extra >> 12) & 7);
	tmp = tmp & (0xffffffffu >> (32 - width));
	SET_NFLG (tmp & (1 << (width - 1)) ? 1 : 0);
	SET_ZFLG (tmp == 0);
	x_put_bitfield(dsta, bdata, tmp, offset, width);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* BFINS.L #<data>.W,(d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_eff0_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 95;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	m68k_incpci (4);
{	dsta = get_disp_ea_020_mmu030c (m68k_areg (regs, dstreg), 0);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = m68k_dreg (regs, (extra >> 12) & 7);
	tmp = tmp & (0xffffffffu >> (32 - width));
	SET_NFLG (tmp & (1 << (width - 1)) ? 1 : 0);
	SET_ZFLG (tmp == 0);
	x_put_bitfield(dsta, bdata, tmp, offset, width);
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}}return 4 * CYCLE_UNIT / 2;
}
/* 4 2,0   */

#endif
/* BFINS.L #<data>.W,(xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_eff8_34)(uae_u32 opcode)
{
	OpcodeFamily = 95;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = (uae_s32)(uae_s16)get_iword_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = m68k_dreg (regs, (extra >> 12) & 7);
	tmp = tmp & (0xffffffffu >> (32 - width));
	SET_NFLG (tmp & (1 << (width - 1)) ? 1 : 0);
	SET_ZFLG (tmp == 0);
	x_put_bitfield(dsta, bdata, tmp, offset, width);
	regs.irc = get_iword_mmu030c_opcode_state (6);
}}}}	m68k_incpci (6);
return 4 * CYCLE_UNIT / 2;
}
/* 6 0,0   */

#endif
/* BFINS.L #<data>.W,(xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_eff9_34)(uae_u32 opcode)
{
	OpcodeFamily = 95;
	CurrentInstrCycles = 4;  
{{	uae_s16 extra = get_iword_mmu030c_state (2);
{	uaecptr dsta;
	dsta = get_ilong_mmu030c_state (4);
{	uae_u32 bdata[2];
	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp;
	dsta += offset >> 3;
	tmp = x_get_bitfield (dsta, bdata, offset, width);
	SET_NFLG_ALWAYS (((uae_s32)tmp) < 0 ? 1 : 0);
	tmp >>= (32 - width);
	SET_ZFLG (tmp == 0); SET_VFLG (0); SET_CFLG (0);
	tmp = m68k_dreg (regs, (extra >> 12) & 7);
	tmp = tmp & (0xffffffffu >> (32 - width));
	SET_NFLG (tmp & (1 << (width - 1)) ? 1 : 0);
	SET_ZFLG (tmp == 0);
	x_put_bitfield(dsta, bdata, tmp, offset, width);
	regs.irc = get_iword_mmu030c_opcode_state (8);
}}}}	m68k_incpci (8);
return 4 * CYCLE_UNIT / 2;
}
/* 8 0,0   */

#endif
/* MMUOP030.L Dn,#<data>.W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f000_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 118;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341788; }
{	uaecptr pc = m68k_getpci ();
	uae_u16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	uae_u16 extraa = 0;
	if (mmu_op30 (pc, opcode, extra, extraa)) goto l_341788;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}l_341788: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* MMUOP030.L An,#<data>.W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f008_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 118;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341789; }
{	uaecptr pc = m68k_getpci ();
	uae_u16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	uae_u16 extraa = 0;
	if (mmu_op30 (pc, opcode, extra, extraa)) goto l_341789;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}l_341789: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* MMUOP030.L (An),#<data>.W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f010_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 118;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341790; }
{	uaecptr pc = m68k_getpci ();
	uae_u16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
{	uaecptr extraa;
	extraa = m68k_areg (regs, srcreg);
	if (mmu_op30 (pc, opcode, extra, extraa)) goto l_341790;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}l_341790: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* MMUOP030.L (An)+,#<data>.W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f018_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 118;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341791; }
{	uaecptr pc = m68k_getpci ();
	uae_u16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
{	uaecptr extraa;
	extraa = m68k_areg (regs, srcreg);
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) += 4;
	if (mmu_op30 (pc, opcode, extra, extraa)) goto l_341791;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}l_341791: ;
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* MMUOP030.L -(An),#<data>.W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f020_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 118;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341792; }
{	uaecptr pc = m68k_getpci ();
	uae_u16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
{	uaecptr extraa;
	extraa = m68k_areg (regs, srcreg) - 4;
	mmufixup[0].reg = srcreg;
	mmufixup[0].value = m68k_areg (regs, srcreg);
	m68k_areg (regs, srcreg) = extraa;
	if (mmu_op30 (pc, opcode, extra, extraa)) goto l_341792;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}l_341792: ;
	mmufixup[0].reg = -1;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* MMUOP030.L (d16,An),#<data>.W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f028_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 118;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341793; }
{	uaecptr pc = m68k_getpci ();
	uae_u16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
{	uaecptr extraa;
	extraa = m68k_areg (regs, srcreg) + (uae_s32)(uae_s16)get_iword_mmu030c_state (0);
	m68k_incpci (2);
	if (mmu_op30 (pc, opcode, extra, extraa)) goto l_341793;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}l_341793: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* MMUOP030.L (d8,An,Xn),#<data>.W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f030_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 118;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341794; }
{	uaecptr pc = m68k_getpci ();
	uae_u16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
{	uaecptr extraa;
{	extraa = get_disp_ea_020_mmu030c (m68k_areg (regs, srcreg), 0);
	if (mmu_op30 (pc, opcode, extra, extraa)) goto l_341794;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}}l_341794: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* MMUOP030.L (xxx).W,#<data>.W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f038_34)(uae_u32 opcode)
{
	OpcodeFamily = 118;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341795; }
{	uaecptr pc = m68k_getpci ();
	uae_u16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
{	uaecptr extraa;
	extraa = (uae_s32)(uae_s16)get_iword_mmu030c_state (0);
	m68k_incpci (2);
	if (mmu_op30 (pc, opcode, extra, extraa)) goto l_341795;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}l_341795: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* MMUOP030.L (xxx).L,#<data>.W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f039_34)(uae_u32 opcode)
{
	OpcodeFamily = 118;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341796; }
{	uaecptr pc = m68k_getpci ();
	uae_u16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
{	uaecptr extraa;
	extraa = get_ilong_mmu030c_state (0);
	m68k_incpci (4);
	if (mmu_op30 (pc, opcode, extra, extraa)) goto l_341796;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}}l_341796: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FPP.L #<data>.W,Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f200_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 104;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
{	uae_s16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	fpuop_arithmetic(opcode, extra);
	if (regs.fp_exception) goto l_341797;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341797: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FPP.L #<data>.W,An */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f208_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 104;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
{	uae_s16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	fpuop_arithmetic(opcode, extra);
	if (regs.fp_exception) goto l_341798;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341798: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FPP.L #<data>.W,(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f210_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 104;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
{	uae_s16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	fpuop_arithmetic(opcode, extra);
	if (regs.fp_exception) goto l_341799;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341799: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FPP.L #<data>.W,(An)+ */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f218_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 104;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
{	uae_s16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	fpuop_arithmetic(opcode, extra);
	if (regs.fp_exception) goto l_341800;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341800: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FPP.L #<data>.W,-(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f220_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 104;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
{	uae_s16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	fpuop_arithmetic(opcode, extra);
	if (regs.fp_exception) goto l_341801;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341801: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FPP.L #<data>.W,(d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f228_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 104;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
{	uae_s16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	fpuop_arithmetic(opcode, extra);
	if (regs.fp_exception) goto l_341802;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341802: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FPP.L #<data>.W,(d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f230_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 104;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
{	uae_s16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	fpuop_arithmetic(opcode, extra);
	if (regs.fp_exception) goto l_341803;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341803: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FPP.L #<data>.W,(xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f238_34)(uae_u32 opcode)
{
	OpcodeFamily = 104;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
{	uae_s16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	fpuop_arithmetic(opcode, extra);
	if (regs.fp_exception) goto l_341804;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341804: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FPP.L #<data>.W,(xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f239_34)(uae_u32 opcode)
{
	OpcodeFamily = 104;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
{	uae_s16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	fpuop_arithmetic(opcode, extra);
	if (regs.fp_exception) goto l_341805;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341805: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FPP.L #<data>.W,(d16,PC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f23a_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 2;
	OpcodeFamily = 104;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
{	uae_s16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	fpuop_arithmetic(opcode, extra);
	if (regs.fp_exception) goto l_341806;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341806: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FPP.L #<data>.W,(d8,PC,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f23b_34)(uae_u32 opcode)
{
	uae_u32 dstreg = 3;
	OpcodeFamily = 104;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
{	uae_s16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	fpuop_arithmetic(opcode, extra);
	if (regs.fp_exception) goto l_341807;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341807: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FPP.L #<data>.W,#<data>.L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f23c_34)(uae_u32 opcode)
{
	OpcodeFamily = 104;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
{	uae_s16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	fpuop_arithmetic(opcode, extra);
	if (regs.fp_exception) goto l_341808;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341808: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FScc.L #<data>.W,Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f240_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 106;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
{	uae_s16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	fpuop_scc (opcode, extra);
	if (regs.fp_exception) goto l_341809;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341809: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FDBcc.L #<data>.W,Dn */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f248_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 105;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
{	uae_s16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	fpuop_dbcc (opcode, extra);
	if (regs.fp_exception) goto l_341810;
	if (regs.fp_branch) {
		regs.fp_branch = false;
		fill_prefetch();
		goto l_341810;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341810: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FScc.L #<data>.W,(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f250_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 106;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
{	uae_s16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	fpuop_scc (opcode, extra);
	if (regs.fp_exception) goto l_341811;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341811: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FScc.L #<data>.W,(An)+ */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f258_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 106;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
{	uae_s16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	fpuop_scc (opcode, extra);
	if (regs.fp_exception) goto l_341812;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341812: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FScc.L #<data>.W,-(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f260_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 106;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
{	uae_s16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	fpuop_scc (opcode, extra);
	if (regs.fp_exception) goto l_341813;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341813: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FScc.L #<data>.W,(d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f268_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 106;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
{	uae_s16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	fpuop_scc (opcode, extra);
	if (regs.fp_exception) goto l_341814;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341814: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FScc.L #<data>.W,(d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f270_34)(uae_u32 opcode)
{
	uae_u32 dstreg = opcode & 7;
	OpcodeFamily = 106;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
{	uae_s16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	fpuop_scc (opcode, extra);
	if (regs.fp_exception) goto l_341815;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341815: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FScc.L #<data>.W,(xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f278_34)(uae_u32 opcode)
{
	OpcodeFamily = 106;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
{	uae_s16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	fpuop_scc (opcode, extra);
	if (regs.fp_exception) goto l_341816;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341816: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FScc.L #<data>.W,(xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f279_34)(uae_u32 opcode)
{
	OpcodeFamily = 106;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
{	uae_s16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	fpuop_scc (opcode, extra);
	if (regs.fp_exception) goto l_341817;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341817: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FTRAPcc.L #<data>.W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f27a_34)(uae_u32 opcode)
{
	OpcodeFamily = 107;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
	uaecptr oldpc = m68k_getpci ();
	uae_u16 extra = get_iword_mmu030c_state (2);
{	uae_s16 dummy = get_iword_mmu030c_state (4);
	m68k_incpci (6);
	fpuop_trapcc (opcode, oldpc, extra);
	if (regs.fp_exception) goto l_341818;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341818: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FTRAPcc.L #<data>.L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f27b_34)(uae_u32 opcode)
{
	OpcodeFamily = 107;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
	uaecptr oldpc = m68k_getpci ();
	uae_u16 extra = get_iword_mmu030c_state (2);
{	uae_s32 dummy;
	dummy = get_ilong_mmu030c_state (4);
	m68k_incpci (8);
	fpuop_trapcc (opcode, oldpc, extra);
	if (regs.fp_exception) goto l_341819;
	regs.irc = get_iword_mmu030c_opcode_state (0);
}
#endif
}l_341819: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FTRAPcc.L  */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f27c_34)(uae_u32 opcode)
{
	OpcodeFamily = 107;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
	uaecptr oldpc = m68k_getpci ();
	uae_u16 extra = get_iword_mmu030c_state (2);
	m68k_incpci (4);
	fpuop_trapcc (opcode, oldpc, extra);
	if (regs.fp_exception) goto l_341820;
	regs.irc = get_iword_mmu030c_opcode_state (0);

#endif
}l_341820: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FBccQ.L #<data>,#<data>.W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f280_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 63);
	OpcodeFamily = 108;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
	m68k_incpci (2);
{	uaecptr pc = m68k_getpci ();
{	uae_s16 extra = get_iword_mmu030c_state (0);
	m68k_incpci (2);
	fpuop_bcc (opcode, pc,extra);
	if (regs.fp_exception) goto l_341821;
	if (regs.fp_branch) {
		regs.fp_branch = false;
		fill_prefetch();
		goto l_341821;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}
#endif
}l_341821: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FBccQ.L #<data>,#<data>.L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f2c0_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 63);
	OpcodeFamily = 108;
	CurrentInstrCycles = 4;  
{
#ifdef FPUEMU
	m68k_incpci (2);
{	uaecptr pc = m68k_getpci ();
{	uae_s32 extra;
	extra = get_ilong_mmu030c_state (0);
	m68k_incpci (4);
	fpuop_bcc (opcode, pc,extra);
	if (regs.fp_exception) goto l_341822;
	if (regs.fp_branch) {
		regs.fp_branch = false;
		fill_prefetch();
		goto l_341822;
	}
	regs.irc = get_iword_mmu030c_opcode_state (0);
}}
#endif
}l_341822: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FSAVE.L (An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f310_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 109;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341823; }
{
#ifdef FPUEMU
	m68k_incpci (2);
	fpuop_save (opcode);
	if (regs.fp_exception) goto l_341823;
	regs.irc = get_iword_mmu030c_opcode_state (0);

#endif
}}l_341823: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FSAVE.L -(An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f320_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 109;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341824; }
{
#ifdef FPUEMU
	m68k_incpci (2);
	fpuop_save (opcode);
	if (regs.fp_exception) goto l_341824;
	regs.irc = get_iword_mmu030c_opcode_state (0);

#endif
}}l_341824: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FSAVE.L (d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f328_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 109;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341825; }
{
#ifdef FPUEMU
	m68k_incpci (2);
	fpuop_save (opcode);
	if (regs.fp_exception) goto l_341825;
	regs.irc = get_iword_mmu030c_opcode_state (0);

#endif
}}l_341825: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FSAVE.L (d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f330_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 109;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341826; }
{
#ifdef FPUEMU
	m68k_incpci (2);
	fpuop_save (opcode);
	if (regs.fp_exception) goto l_341826;
	regs.irc = get_iword_mmu030c_opcode_state (0);

#endif
}}l_341826: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FSAVE.L (xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f338_34)(uae_u32 opcode)
{
	OpcodeFamily = 109;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341827; }
{
#ifdef FPUEMU
	m68k_incpci (2);
	fpuop_save (opcode);
	if (regs.fp_exception) goto l_341827;
	regs.irc = get_iword_mmu030c_opcode_state (0);

#endif
}}l_341827: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FSAVE.L (xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f339_34)(uae_u32 opcode)
{
	OpcodeFamily = 109;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341828; }
{
#ifdef FPUEMU
	m68k_incpci (2);
	fpuop_save (opcode);
	if (regs.fp_exception) goto l_341828;
	regs.irc = get_iword_mmu030c_opcode_state (0);

#endif
}}l_341828: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FRESTORE.L (An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f350_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 110;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341829; }
{
#ifdef FPUEMU
	m68k_incpci (2);
	fpuop_restore (opcode);
	if (regs.fp_exception) goto l_341829;
	regs.irc = get_iword_mmu030c_opcode_state (0);

#endif
}}l_341829: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FRESTORE.L (An)+ */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f358_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 110;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341830; }
{
#ifdef FPUEMU
	m68k_incpci (2);
	fpuop_restore (opcode);
	if (regs.fp_exception) goto l_341830;
	regs.irc = get_iword_mmu030c_opcode_state (0);

#endif
}}l_341830: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FRESTORE.L (d16,An) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f368_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 110;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341831; }
{
#ifdef FPUEMU
	m68k_incpci (2);
	fpuop_restore (opcode);
	if (regs.fp_exception) goto l_341831;
	regs.irc = get_iword_mmu030c_opcode_state (0);

#endif
}}l_341831: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FRESTORE.L (d8,An,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f370_34)(uae_u32 opcode)
{
	uae_u32 srcreg = (opcode & 7);
	OpcodeFamily = 110;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341832; }
{
#ifdef FPUEMU
	m68k_incpci (2);
	fpuop_restore (opcode);
	if (regs.fp_exception) goto l_341832;
	regs.irc = get_iword_mmu030c_opcode_state (0);

#endif
}}l_341832: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FRESTORE.L (xxx).W */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f378_34)(uae_u32 opcode)
{
	OpcodeFamily = 110;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341833; }
{
#ifdef FPUEMU
	m68k_incpci (2);
	fpuop_restore (opcode);
	if (regs.fp_exception) goto l_341833;
	regs.irc = get_iword_mmu030c_opcode_state (0);

#endif
}}l_341833: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FRESTORE.L (xxx).L */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f379_34)(uae_u32 opcode)
{
	OpcodeFamily = 110;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341834; }
{
#ifdef FPUEMU
	m68k_incpci (2);
	fpuop_restore (opcode);
	if (regs.fp_exception) goto l_341834;
	regs.irc = get_iword_mmu030c_opcode_state (0);

#endif
}}l_341834: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FRESTORE.L (d16,PC) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f37a_34)(uae_u32 opcode)
{
	OpcodeFamily = 110;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341835; }
{
#ifdef FPUEMU
	m68k_incpci (2);
	fpuop_restore (opcode);
	if (regs.fp_exception) goto l_341835;
	regs.irc = get_iword_mmu030c_opcode_state (0);

#endif
}}l_341835: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
/* FRESTORE.L (d8,PC,Xn) */
#ifndef CPUEMU_68000_ONLY
uae_u32 REGPARAM2 CPUFUNC(op_f37b_34)(uae_u32 opcode)
{
	OpcodeFamily = 110;
	CurrentInstrCycles = 4;  
{if (!regs.s) { Exception (8); goto l_341836; }
{
#ifdef FPUEMU
	m68k_incpci (2);
	fpuop_restore (opcode);
	if (regs.fp_exception) goto l_341836;
	regs.irc = get_iword_mmu030c_opcode_state (0);

#endif
}}l_341836: ;
return 4 * CYCLE_UNIT / 2;
}

#endif
#endif

